<?php
define("MBW_REQUEST_MODE", "API");
if(!defined('_MB_')) exit();
do_action('mbw_commerce_api_init');

if(!mbw_verify_nonce()){
	if(mbw_get_param("board_action")=="board_hit") {echo mbw_data_encode($mstore->result_data);exit;}
	mbw_error_message("MSG_NONCE_MATCH_ERROR", "","1401");
}
global $mb_commerce_tables;
global $mb_commerce_pay_cancel_state,$mb_commerce_pay_wait_state,$mb_commerce_pay_request_state,$mb_commerce_pay_complete_state;

$send_data					= array();
$where_data					= array();
$query_data					= array();
$commerce_data			= array();
$billing_ids					= "";
$query1						= "";
$query2						= "";
$query_command			= "";
$board_pid					= intval(mbw_get_param("board_pid"));

$api_fields			= $mb_fields["select_board"];
$board_action		= mbw_get_param("board_action");
$cart_action			= array("add_cart","direct_checkout","cart_checkout");
$order_action		= array("order_virtual","order_shipping");

if(in_array($board_action, $cart_action)!==false || strpos($board_action,"checkout")===0 || strpos($board_action,"cart")===0){
	$api_fields					= $mb_fields["commerce_cart"];
}else if(in_array($board_action, $order_action)!==false){
	$api_fields					= $mb_fields["commerce_order"];	
} else if($board_action=="modify_admin_category"){
	$api_fields					= $mb_fields["board_options"];
} else if($board_action=="add_wishlist"){
	$api_fields					= $mb_fields["commerce_wishlist"];
}

$item_field						= $mb_fields["commerce_product"];
$send_data						= mbw_set_api_params($api_fields);

do_action('mbw_commerce_api_header');
$upload_check			= mbw_check_api_file("board");


if($mstore->get_result_data("state")=="error"){
	echo mbw_data_encode($mstore->result_data);	
	exit;
}

if(mbw_get_param("board_action")=="add_cart"){
	
	$select_query				= mbw_get_add_query(array("column"=>"*","join"=>"none","table"=>$mb_commerce_tables["commerce_product"]), array(array("field"=>"fn_pid","value"=>mbw_get_param("board_pid"))));
	$product_item				= $mdb->get_row($select_query,ARRAY_A);

	if(!empty($product_item)){

		if(mbw_get_param("order_count")==""){
			$order_count		= 1;
			if(isset($api_fields["fn_order_count"])) $send_data[$api_fields["fn_order_count"]]							= $order_count;
		}else{
			$order_count				= mbw_get_param("order_count");
			$order_count				= abs(intval($order_count));
			if(empty($order_count)) $order_count	= 1;
		}

		if(mbw_is_product_order(mbw_get_param("board_pid"), array($order_count), $product_item)){
			$mb_board_table_name											= $mb_commerce_tables["commerce_cart"];
			$cart_id						= mbw_get_cart_id();	
			$order_options			= mbw_get_param("order_options");
			$order_options1			= mbw_get_param("order_options1");
			$order_options2			= mbw_get_param("order_options2");
			$order_options3			= mbw_get_param("order_options3");
			
			$where_data			= array();
			if(mbw_is_login()){
				$where_data[]			= array("field"=>$api_fields["fn_user_pid"],"value"=>mbw_get_user("fn_pid"));
				$where_data[]			= array("field"=>$api_fields["fn_cart_id"],"value"=>"","sign"=>"!=");
			}else{
				$where_data[]			= array("field"=>$api_fields["fn_cart_id"],"value"=>$cart_id);
			}
			$where_data[]			= array("field"=>$api_fields["fn_product_pid"],"value"=>$board_pid);
			$where_data[]			= array("field"=>$api_fields["fn_order_options"],"value"=>"");
			if(!empty($order_options1)) $where_data[]			= array("field"=>$api_fields["fn_order_options1"],"value"=>$order_options1);
			if(!empty($order_options2)) $where_data[]			= array("field"=>$api_fields["fn_order_options2"],"value"=>$order_options2);
			if(!empty($order_options3)) $where_data[]			= array("field"=>$api_fields["fn_order_options3"],"value"=>$order_options3);
			$where_data[]			= array("field"=>$api_fields["fn_is_order"],"value"=>"0");

			if(empty($order_options))
				$cart_pid			= $mdb->get_var(mbw_get_add_query(array("column"=>$api_fields["fn_pid"],"join"=>"none","table"=>$mb_commerce_tables["commerce_cart"]), $where_data));
			else $cart_pid			= 0;
			$where_data			= array();
			
			//카트에 동일한 상품이 등록되어 있을 경우
			if(!empty($cart_pid)) {
				$query_command		= "";
				$query_data[]				= $mdb->prepare("UPDATE ".$mb_commerce_tables["commerce_cart"]." set ".$api_fields["fn_order_count"]."=".$api_fields["fn_order_count"]."+%d where ".$api_fields["fn_pid"]."=%d", $order_count,$cart_pid);
			}else{
				//카트에 상품 등록
				$query_command		= "INSERT";
				
				//if(isset($api_fields["fn_billing_id"]))		$send_data[$api_fields["fn_billing_id"]]							= $board_pid;
				if(isset($api_fields["fn_product_pid"]))		$send_data[$api_fields["fn_product_pid"]]						= $board_pid;
				if(isset($api_fields["fn_cart_id"]))		$send_data[$api_fields["fn_cart_id"]]									= $cart_id;

				$product_data		= mbw_set_commerce_data($api_fields, $item_field, $product_item);
				$send_data			= array_merge($send_data,$product_data);
				$commerce_data["item_count"]	= mbw_get_cart_items_count()+1;
			}
		}
	}else{
		mbw_error_message("MSG_COMMERCE_PRODUCT_EXIST_ERROR");
	}

}else if(mbw_get_param("board_action")=="cart_checkout"){
	$mb_board_table_name	= $mb_commerce_tables["commerce_cart"];
	$check_array					= mbw_get_param("check_array");
	if(!empty($check_array) || mbw_get_param("board_pid")!=""){
		$billing_format				= array();
		if(mbw_get_param("board_pid")!=""){		// 1개 구입
			$billing_pid					= array(mbw_get_param("board_pid"));
		}else{ // 여러개 구입
			$billing_pid					= $check_array;
		}		
		foreach($billing_pid as $value) $billing_format[]		= "%d";
		$billing_id					= mbw_get_billing_id($billing_pid[0]);
		$billing_id					= mbw_value_filter($billing_id);
		$order_id						= $billing_id;

		$cart_data					= $mdb->get_results($mdb->prepare("select ".$api_fields["fn_shop_pid"].",".$api_fields["fn_product_type"].",".$api_fields["fn_product_pid"].",".$api_fields["fn_order_count"]." from ".$mb_board_table_name." WHERE ".$api_fields["fn_pid"]." in (".implode(",",$billing_format).")", $billing_pid ),ARRAY_A);
		$cart_product_pid			= array_column($cart_data, $api_fields["fn_product_pid"]);
		$cart_order_count			= array_column($cart_data, $api_fields["fn_order_count"]);

		if(mbw_is_product_order($cart_product_pid,$cart_order_count)){
			if(count($billing_pid)>1){
				$cart_shop_pid			= array_unique(array_column($cart_data, $api_fields["fn_shop_pid"]));
				$cart_product_type		= implode(",",array_column($cart_data, $api_fields["fn_product_type"]));

				if(strpos(','.$cart_product_type.',', ',video,')!==false || strpos(','.$cart_product_type.',', ',reservation_')!==false){
					$billing_id2					= array();
					$index							= 1;
					foreach($billing_pid as $value) {
						$query_data[]	= $mdb->prepare("UPDATE ".$mb_board_table_name." SET ".$api_fields["fn_billing_id"]."='".$billing_id.$index."' WHERE ".$api_fields["fn_pid"]."=%d", $value );
						$billing_id2[]		= $billing_id.$index;
						$index++;
					}
					$billing_id		= implode(",",$billing_id2);
				}else if(count($cart_shop_pid)>1){	//상점이 다른 주문을 여러개 구입할 경우
					$billing_id2					= array();
					$index							= 1;
					foreach($cart_shop_pid as $key=>$value) {
						$query_data[]					= $mdb->prepare("UPDATE ".$mb_board_table_name." SET ".$api_fields["fn_billing_id"]."='".$billing_id.$index."' WHERE ".$api_fields["fn_pid"]." in (".implode(",",$billing_format).") and ".$api_fields["fn_shop_pid"]."=".$value, $billing_pid );	
						$billing_id2[]		= $billing_id.$index;
						$index++;
					}
					$billing_id		= implode(",",$billing_id2);
				}else{
					$query_data[]		= $mdb->prepare("UPDATE ".$mb_board_table_name." SET ".$api_fields["fn_billing_id"]."='".$billing_id."' WHERE ".$api_fields["fn_pid"]." in (".implode(",",$billing_format).")", $billing_pid );
				}
			}else{
				$query_data[]		= $mdb->prepare("UPDATE ".$mb_board_table_name." SET ".$api_fields["fn_billing_id"]."='".$billing_id."' WHERE ".$api_fields["fn_pid"]." in (".implode(",",$billing_format).")", $billing_pid );
			}
			mbw_commerce_session_start();
			$_SESSION['commerce_order_id']			= $order_id;
			$_SESSION['commerce_billing_id']			= $billing_id;
		}
	}
}else if(mbw_get_param("board_action")=="direct_checkout"){

	$select_query				= mbw_get_add_query(array("column"=>"*","table"=>$mb_commerce_tables["commerce_product"]), array(array("field"=>"fn_pid","value"=>mbw_get_param("board_pid"))));
	$product_item				= $mdb->get_row($select_query,ARRAY_A);
	if(!empty($product_item)){

		if(mbw_get_param("order_count")==""){
			$order_count		= 1;
			if(isset($api_fields["fn_order_count"])) $send_data[$api_fields["fn_order_count"]]							= $order_count;
		}else{
			$order_count				= mbw_get_param("order_count");
			$order_count				= abs(intval($order_count));
			if(empty($order_count)) $order_count	= 1;
		}

		if(mbw_is_product_order(mbw_get_param("board_pid"),array($order_count),$product_item)){
			$query_command												= "INSERT";
			$mb_board_table_name											= $mb_commerce_tables["commerce_cart"];

			if(mbw_get_param("direct_checkout_billing_id")!=''){
				$billing_id		= mbw_get_param("direct_checkout_billing_id");
				$billing_id		= mbw_value_filter($billing_id);
			}else{
				$cart_pid			= intval($mdb->get_var($mdb->prepare("select %1s from `%1s` ORDER BY %1s DESC limit 1;", $api_fields["fn_pid"],$mb_board_table_name,$api_fields["fn_pid"])))+1;
				$billing_id		= mbw_get_billing_id($cart_pid);
			}
			mbw_commerce_session_start();
			$_SESSION['commerce_order_id']			= $billing_id;
			$_SESSION['commerce_billing_id']			= $billing_id;
			
			if(isset($api_fields["fn_product_pid"]))		$send_data[$api_fields["fn_product_pid"]]			= $board_pid;
			if(isset($api_fields["fn_billing_id"]))		$send_data[$api_fields["fn_billing_id"]]				= $billing_id;

			$product_data	= mbw_set_commerce_data($api_fields, $item_field, $product_item);
			$send_data		= array_merge($send_data,$product_data);			
		}
	}else{
		mbw_error_message("MSG_COMMERCE_PRODUCT_EXIST_ERROR");		
	}

}else if(mbw_get_param("board_action")=="add_wishlist"){
	if(mbw_is_login()){
		$mb_board_table_name											= $mb_commerce_tables["commerce_wishlist"];

		$where_data			= array();
		$where_data[]			= array("field"=>$api_fields["fn_user_pid"],"value"=>$send_data[$api_fields["fn_user_pid"]]);
		$where_data[]			= array("field"=>$api_fields["fn_product_pid"],"value"=>$board_pid);

		$wishlist_pid			= $mdb->get_var(mbw_get_add_query(array("column"=>$api_fields["fn_pid"],"join"=>"none","table"=>$mb_commerce_tables["commerce_wishlist"]), $where_data));
		$where_data			= array();
		
		//Wishlist에 동일한 상품이 등록되어 있지 않을 경우에만 등록
		if(empty($wishlist_pid)) {
			$select_query				= mbw_get_add_query(array("column"=>"*","join"=>"none","table"=>$mb_commerce_tables["commerce_product"]), array(array("field"=>"fn_pid","value"=>mbw_get_param("board_pid"))));
			$product_item				= $mdb->get_row($select_query,ARRAY_A);
			if(!empty($product_item)){
				$query_command												= "INSERT";
						
				if(isset($api_fields["fn_order_count"]))		$send_data[$api_fields["fn_order_count"]]						= 1;
				if(isset($api_fields["fn_product_pid"]))		$send_data[$api_fields["fn_product_pid"]]						= $board_pid;
				$product_data	= mbw_set_commerce_data($api_fields, $item_field, $product_item);
				$send_data		= array_merge($send_data,$product_data);
			}else{
				mbw_error_message("MSG_COMMERCE_PRODUCT_EXIST_ERROR");
			}
		}
	}

}else if((intval(mbw_get_board_option("fn_modify_level")) <= intval(mbw_get_user("fn_user_level"))) && mbw_get_param("board_action")=="multi_modify"){
	//체크박스가 선택된 항목만 수정
	$check_array	= mbw_get_param("check_array");
	if(!empty($check_array)){
		$checked_pid			= ",".implode(",",$check_array).",";
	}else if(!empty($board_pid)){
		$checked_pid			= ",".$board_pid.",";
	}
	
	if(!empty($checked_pid)){	
		$pid_data				= mbw_get_param($api_fields["fn_pid"]."_array");
		$count					= count($pid_data);

		for($i=0;$i<$count;$i++){
			$modify_data		= array();
			if(!empty($pid_data[$i]) && strpos($checked_pid, ",".$pid_data[$i].",")!==false){
				foreach($send_data as $key => $value){
					if(is_array($send_data[$key])){						
						$modify_data[$key]										= $send_data[$key][$i];
					}
				}
				$where_data[$api_fields["fn_pid"]]					= $pid_data[$i];
				if(isset($api_fields["fn_modify_date"]))	$modify_data[$api_fields["fn_modify_date"]]	= mbw_get_current_time();
				if(!empty($where_data)){
					$mdb->db_query("UPDATE",$mb_board_table_name, $modify_data, $where_data);
				}
			}
		}
	}
}else if(mbw_get_param("board_action")=="multi_modify_cart"){
	//체크박스가 선택된 항목만 수정
	$check_array	= mbw_get_param("check_array");
	if(!empty($check_array)){
		$checked_pid			= ",".implode(",",$check_array).",";
	}else if(!empty($board_pid)){
		$checked_pid			= ",".$board_pid.",";
	}
	
	if(!empty($checked_pid)){	
		$pid_data				= mbw_get_param($api_fields["fn_pid"]."_array");	
		$count				= count($pid_data);

		for($i=0;$i<$count;$i++){
			$modify_data		= array();
			if(!empty($pid_data[$i]) && strpos($checked_pid, ",".$pid_data[$i].",")!==false){
				$key			= $api_fields["fn_order_count"]; 
				if(is_array($send_data[$key])){
					$modify_data[$key]					= abs(intval($send_data[$key][$i]));
					if(empty($modify_data[$key])) $modify_data[$key]	= 1;
				}
				$where_data[$api_fields["fn_pid"]]			= $pid_data[$i];			
				$where_data[$api_fields["fn_user_pid"]]		= mbw_get_user("fn_pid");

				if(isset($api_fields["fn_modify_date"]))	$modify_data[$api_fields["fn_modify_date"]]	= mbw_get_current_time();
				$mdb->db_query("UPDATE",$mb_board_table_name, $modify_data, $where_data);
			}
		}
	}
}else if(mbw_get_param("board_action")=="multi_modify_cart2"){
	if(mbw_get_param("cart_pid")!=""){
		$cart_pid			= mbw_get_param("cart_pid");
		$count			= mbw_get_param("count");
		if(empty($count)) $count	= 1;
		$modify_data		= array();
		$key				= $api_fields["fn_order_count"]; 
		$modify_data[$key]							= abs(intval($count));
		$where_data[$api_fields["fn_pid"]]		= $cart_pid;
		$where_data[$api_fields["fn_user_pid"]]	= mbw_get_user("fn_pid");

		if(isset($api_fields["fn_modify_date"]))	$modify_data[$api_fields["fn_modify_date"]]	= mbw_get_current_time();
		$mdb->db_query("UPDATE",$mb_board_table_name, $modify_data, $where_data);
	}
}else if(mbw_get_param("board_action")=="multi_delete_cart" || mbw_get_param("board_action")=="multi_delete_wishlist"){

	$action	= mbw_get_param("board_action");
	if($action=="multi_delete_wishlist"){
		$table_name		= "mb_commerce_wishlist";
	}else{
		$table_name		= "mb_commerce_cart";
	}
	//체크박스가 선택된 항목만 수정
	$check_array		= mbw_get_param("check_array");
	if(!empty($check_array)){
		$pid_data			= $check_array;
	}else if(!empty($board_pid)){
		$pid_data			= array($board_pid);
	}	
	if(!empty($pid_data)){	
		$query_command		= "DELETE";
		$count					= count($pid_data);
		for($i=0;$i<$count;$i++){
			$where_data[$api_fields["fn_pid"]]			= intval($pid_data[$i]);
			$where_data[$api_fields["fn_user_pid"]]		= mbw_get_user("fn_pid");
			if(!empty($where_data)){
				$mdb->db_query($query_command,$table_name, array(), $where_data);
			}
		}
		$query_command		= "";
	}
}else if(mbw_get_param("board_action")=="check_coupon_id"){
	$coupon_id			= mbw_get_param("coupon_id");
	mbw_set_point_coupon($coupon_id,"point_id");
}else if(mbw_get_param("board_action")=="use_coupon"){
	mbw_set_point_coupon($board_pid);
}else if(mbw_get_param("board_action")=="create_coupon"){
	$point						= floatval(mbw_get_param("give_point"));
	$coupon_count			= floatval(mbw_get_param("coupon_count"));
	if(mbw_is_admin() && !empty($coupon_count) && !empty($point)) mbw_create_point_coupon($point,$coupon_count);	
}else if(mbw_get_param("board_action")=="multi_user_give"){
	$check_array				= mbw_get_param("check_array");
	if(!empty($check_array) && mbw_is_admin()){
		$checked_pid			= ",".implode(",",$check_array).",";
		$name_array				= mbw_get_param("user_name_array");	
		$pid_array				= mbw_get_param("user_pid_array");	
		$count					= count($pid_array);
		$point						= floatval(mbw_get_param("give_point"));
		$give_type				= mbw_get_param("give_type");
		$coupon_title			= (mbw_get_param("coupon_title"));
		$start_date				= (mbw_get_param("coupon_start_date"));
		$end_date				= (mbw_get_param("coupon_end_date"));

		for($i=0;$i<$count;$i++){
			if(!empty($pid_array[$i]) && strpos($checked_pid, ",".$pid_array[$i].",")!==false){
				$user_name		= "";
				if(!empty($name_array[$i])) $user_name		= $name_array[$i];
				if($give_type=="point"){
					mbw_set_user_point("admin","give",$point,$pid_array[$i],$user_name);
				}else if($give_type=="coupon"){
					mbw_add_point_coupon($point, array("user_pid"=>$pid_array[$i],"user_name"=>$user_name,"coupon_title"=>$coupon_title,"start_date"=>$start_date,"end_date"=>$end_date));
				}
			}
		}
		$mstore->set_result_data(array("message"=>"포인트가 정상적으로 지급되었습니다"));
		$query_command		= "";
	}
}else if(mbw_is_admin() && mbw_get_param("board_action")=="send_deposit_confirm_mail"){
	//무통장입금 확인 메일 전송
	if(mbw_get_param("board_pid")!="" && mbw_get_param("billing_id")!=""){
		$template_path				= mbw_get_template_path("commerce/mail/order_deposit","theme");
		if(!empty($template_path)){
			mbw_set_result_data(array("message"=>__MM('MSG_SEND_MAIL_SUCCESS')));
			require($template_path);
		}
	}
}else if(mbw_get_param("board_action")=="multi_modify_order"){
	//체크박스가 선택된 항목만 수정
	$check_array	= mbw_get_param("check_array");
	if(!empty($check_array)){
		$checked_pid			= ",".implode(",",$check_array).",";
	}else if(!empty($board_pid)){
		$checked_pid			= ",".$board_pid.",";
	}
	if(!empty($checked_pid)){	
		$pid_array			= mbw_get_param("pid_array");
		$user_pid_array		= mbw_get_param("user_pid_array");
		$pay_state_array		= mbw_get_param("pay_state_array");
		$order_state_array	= mbw_get_param("order_state_array");
		$order_point_array	= mbw_get_param("order_point_array");
		$order_price_array	= mbw_get_param("order_price_array");
		$use_point_array	= mbw_get_param("use_point_array");
		$use_money_array	= mbw_get_param("use_money_array");
		$pay_state			= "";
		$count				= count($pid_array);
		$check_user_pid		= intval(mbw_get_user("fn_pid"));

		for($i=0;$i<$count;$i++){
			$modify_data		= array();
			if(!empty($pid_array[$i]) && strpos($checked_pid, ",".$pid_array[$i].",")!==false){
				foreach($send_data as $key => $value){
					if(is_array($send_data[$key])){
						$modify_data[$key]										= $send_data[$key][$i];
					}
				}				
				$where_data[$api_fields["fn_pid"]]					= $pid_array[$i];
				//관리자가 아니면 본인 상품만 수정 가능하도록 권한 체크
				if(!mbw_is_admin()){
					$shop_pid	= $mdb->get_var($mdb->prepare("select ".$api_fields["fn_shop_pid"]." from `".$mb_board_table_name."` where `".$api_fields["fn_pid"]."`=%d limit 1", $pid_array[$i]));
					if(intval($shop_pid)!=$check_user_pid) continue;
					$where_data[$api_fields["fn_shop_pid"]]					= mbw_get_user("fn_pid");	
				}
				
				if(!empty($modify_data[$api_fields["fn_order_state"]])){
					$order_state						= $modify_data[$api_fields["fn_order_state"]];
					if(in_array($order_state, $mb_commerce_pay_cancel_state)!==false){
						$pay_state						= "cancel";
					}else if(in_array($order_state, $mb_commerce_pay_wait_state)!==false){
						$pay_state						= "wait";
					}else if(in_array($order_state, $mb_commerce_pay_request_state)!==false){
						$pay_state						= "request";
					}else if(in_array($order_state, $mb_commerce_pay_complete_state)!==false){
						$pay_state						= "complete";
					}
					$modify_data[$api_fields["fn_pay_state"]]										= $pay_state;
				}
				if(!empty($pay_state_array[$i])){
					$order_price		= $order_price_array[$i];
					$order_point		= $order_point_array[$i];
					$use_point			= $use_point_array[$i];
					$use_money		= $use_money_array[$i];
					$user_pid			= $user_pid_array[$i];

					if($pay_state_array[$i]=="wait"){
						if(isset($api_fields["fn_pay_date"]))		$modify_data[$api_fields["fn_pay_date"]]										= mbw_get_current_time();	
						
						if($pay_state=="complete"){	//주문 완료에서 입금완료로 변경
							//회원 정보에서 결제금액 수정
							if(!empty($user_pid)){
								$mdb->query($mdb->prepare("UPDATE ".$mb_admin_tables["users"]." set ".$mb_fields["users"]["fn_payment_count"]."=".$mb_fields["users"]["fn_payment_count"]."+1, ".$mb_fields["users"]["fn_payment_total"]."=".$mb_fields["users"]["fn_payment_total"]."+%d where ".$mb_fields["users"]["fn_pid"]."=%d", $order_price, $user_pid));

								do_action( 'mbw_commerce_api_bank_complete',$pid_array[$i],$user_pid);
								
								if(!empty($order_point)) mbw_set_user_point("commerce","order_save",$order_point,$user_pid);			//주문 포인트 지급
								if(!empty($use_point)) mbw_set_user_point("commerce","order_use",intval($use_point)*(-1),$user_pid);	//사용 포인트 차감
								if(!empty($use_money)) mbw_set_user_money("commerce","money_use",intval($use_money)*(-1),$user_pid);	//사용 캐시 차감
							}
							mbw_analytics("today_sales",$order_price);		// 오늘의 판매 금액 추가
						}else if($pay_state=="cancel"){		//주문 완료에서 취소로 변경
							if(function_exists('mbw_update_order_product_data')){
								//주문 및 결제 취소시 상품 판매 개수 차감하기
								mbw_update_order_product_data("cancel",$pid_array[$i]);
							}
						}
					}else if($pay_state_array[$i]=="complete" || $order_state_array[$i]=="refund_request"){

						if($pay_state=="cancel"){		//결제 완료 및 입금완료에서 취소로 변경
							//입금 및 결제 완료후 취소시 회원 결제금액 수정, 주문 포인트 회수, 사용한 포인트 반납 
							if(!empty($user_pid)){
								$mdb->query($mdb->prepare("UPDATE ".$mb_admin_tables["users"]." set ".$mb_fields["users"]["fn_payment_count"]."=".$mb_fields["users"]["fn_payment_count"]."-1, ".$mb_fields["users"]["fn_payment_total"]."=".$mb_fields["users"]["fn_payment_total"]."-%d where ".$mb_fields["users"]["fn_pid"]."=%d", $order_price, $user_pid));
								
								do_action( 'mbw_commerce_api_pay_cancel',$pid_array[$i],$user_pid);

								$cancel_point		= floatval($use_point) - floatval($order_point);
								if(!empty($cancel_point)) mbw_set_user_point("commerce","order_cancel",$cancel_point,$user_pid);			//주문취소시 사용한 포인트에서 받은 포인트를 빼고 지급
								if(!empty($use_money)) mbw_set_user_money("commerce","money_refund",$use_money,$user_pid);
							}
							if(function_exists('mbw_update_order_product_data')){
								//주문 및 결제 취소시 상품 판매 개수 차감하기
								mbw_update_order_product_data("cancel",$pid_array[$i]);
							}
						}
					}
				}

				if(isset($api_fields["fn_modify_date"]))	$modify_data[$api_fields["fn_modify_date"]]	= mbw_get_current_time();
				if(!empty($where_data)){
					$mdb->db_query("UPDATE",$mb_board_table_name, $modify_data, $where_data);
				}
			}
		}
	}
}else if(mbw_get_param("board_action")=="order_modify_cash_receipt"){
	$check_modify_cash_receipt_permission		= false;

	//관리자만 현금 영수증 상태 수정이 가능하도록 권한 체크
	if(mbw_is_admin()){
		$check_modify_cash_receipt_permission		= true;
	}
	$send_data					= array();
	if($check_modify_cash_receipt_permission){
		if(mbw_get_param("modify_type")=='none'){
			$query_command						= "UPDATE";
			$api_fields								= $mb_fields["commerce_order"];
			if(isset($api_fields["fn_pay_tid"]))		$send_data[$api_fields["fn_pay_tid"]]		= 'none';
			$where_data[$api_fields["fn_pid"]]			= $board_pid;
		}
	}
}else if(mbw_get_param("board_action")=="modify_pay_cancel"){	
	$check_pay_cancel_permission		= false;

	//관리자이거나 본인 상품만 취소 가능하도록 권한 체크
	if(mbw_is_admin()){
		$check_pay_cancel_permission		= true;
	}else{
		$check_user_pid		= intval(mbw_get_user("fn_pid"));
		$shop_pid	= $mdb->get_var($mdb->prepare("select ".$api_fields["fn_shop_pid"]." from `".$mb_board_table_name."` where `".$api_fields["fn_pid"]."`=%d limit 1", $board_pid));
		if(intval($shop_pid)==$check_user_pid) $check_pay_cancel_permission		= true;
	}

	if($check_pay_cancel_permission){

		$query_command				= "UPDATE";
		$api_fields						= $mb_fields["commerce_order"];

		$cancel_data						= array();
		$cancel_data["reason"]			= mbw_get_param("pay_cancel_reason");
		if(empty($cancel_data["reason"])) $cancel_data["reason"]	= "고객요청";
		$cancel_data["mid"]				= mbw_get_param("commerce_mid");
		$cancel_data["oid"]				= mbw_get_param("commerce_oid");
		$cancel_data["tid"]				= mbw_get_param("commerce_tid");
		$cancel_data["pay_price"]		= mbw_get_param("commerce_pay_price");
		$cancel_data["amt"]				= mbw_get_param("commerce_amt");		
		$cancel_data["platform"]		= mbw_get_param("commerce_platform");
		$cancel_data["pay_method"]	= mbw_get_param("commerce_pay_method");
		$pay_method					= array("paypal","kakaopay","naverpay","samsungpay","eximbay");
		if(in_array($cancel_data["pay_method"], $pay_method)!==false){
			if(is_file(MBW_COMMERCE_PAY_PATH.$cancel_data["pay_method"]."/functions.php")){
				include(MBW_COMMERCE_PAY_PATH.$cancel_data["pay_method"]."/functions.php");
			}
			if(function_exists('mbw_commerce_pay_cancel2')){	
				$pg_result_data					= mbw_commerce_pay_cancel2($cancel_data);
			}
		}else{
			if(mbw_get_param("commerce_cancel_type")=="partial_refund"){
				$pg_result_data					= mbw_commerce_pay_partial_refund($cancel_data);				
			}else{
				$pg_result_data					= mbw_commerce_pay_cancel($cancel_data);				
			}
		}

		if($pg_result_data["state"]!="success"){
			mbw_error_message($pg_result_data["result_msg"], "","1401");
		}else{
			//결제 취소 요청 회원 정보 삭제
			if(isset($send_data[$api_fields["fn_user_pid"]])) unset($send_data[$api_fields["fn_user_pid"]]);	
			if(isset($send_data[$api_fields["fn_user_name"]])) unset($send_data[$api_fields["fn_user_name"]]);	
			if(isset($send_data[$api_fields["fn_passwd"]])) unset($send_data[$api_fields["fn_passwd"]]);	

			//주문 상태  취소로 수정(cancelled_payment)		
			if(isset($api_fields["fn_pay_cancel_reason"]))		$send_data[$api_fields["fn_pay_cancel_reason"]]			= $cancel_data["reason"];
			if(isset($api_fields["fn_order_state"]))		$send_data[$api_fields["fn_order_state"]]							= "cancelled_payment";
			if(isset($api_fields["fn_pay_state"]))		$send_data[$api_fields["fn_pay_state"]]								= "cancel";
			if(isset($api_fields["fn_pay_date"]))		$send_data[$api_fields["fn_pay_date"]]								= mbw_get_current_time();
			if(isset($api_fields["fn_refund_price"]))		$send_data[$api_fields["fn_refund_price"]]						= $cancel_data["amt"];

			$select_query		= mbw_get_add_query(array("column"=>"*","table"=>$mb_commerce_tables["commerce_order"]), array(array("field"=>"fn_pid","value"=>$board_pid)));
			$order_item		= $mdb->get_row($select_query,ARRAY_A);
			if(!empty($order_item)){
				if(function_exists('mbw_update_order_product_data')){
					//주문 및 결제 취소시 상품 판매 개수 차감하기
					mbw_update_order_product_data("cancel",$board_pid);
				}
				$user_pid			= $order_item[$api_fields["fn_user_pid"]];
				//입금 및 결제 완료후 취소시 회원 결제금액 수정, 주문 포인트 회수, 사용한 포인트 반납 					
				if(!empty($user_pid)){
					$mdb->query($mdb->prepare("UPDATE ".$mb_admin_tables["users"]." set ".$mb_fields["users"]["fn_payment_count"]."=".$mb_fields["users"]["fn_payment_count"]."-1, ".$mb_fields["users"]["fn_payment_total"]."=".$mb_fields["users"]["fn_payment_total"]."-%d where ".$mb_fields["users"]["fn_pid"]."=%d", $order_item[$api_fields["fn_order_price"]], $user_pid));

					$cancel_point		= floatval($order_item[$api_fields["fn_use_point"]]) - floatval($order_item[$api_fields["fn_order_point"]]);
					if(!empty($cancel_point)) mbw_set_user_point("commerce","order_cancel",$cancel_point,$user_pid);			//주문취소시 사용한 포인트에서 받은 포인트를 빼고 지급
					if(isset($api_fields["fn_use_money"])){
						$use_money		= floatval($order_item[$api_fields["fn_use_money"]]);
						if(!empty($use_money)) mbw_set_user_money("commerce","money_refund",$use_money,$user_pid);
					}
				}
			}
			do_action( 'mbw_commerce_modify_pay_cancel',$board_pid);
		}
		$where_data[$api_fields["fn_pid"]]			= $board_pid;
	}else{
		mbw_error_message("결제 취소 권한이 없습니다");
	}
}else if(mbw_get_param("board_action")=="modify_order_confirm"){
	$query_command										= "UPDATE";		
	$pay_state													= "";
	$t_pay_state												= "";
	$where_data[$api_fields["fn_pid"]]					= $board_pid;
	$where_data[$api_fields["fn_user_pid"]]			= mbw_get_user("fn_pid");
	$where_data[$api_fields["fn_order_confirm"]]	= 0;

	if(isset($api_fields["fn_order_confirm"])) $send_data[$api_fields["fn_order_confirm"]]				= 100;
	if(isset($api_fields["fn_order_confirm_date"]))		$send_data[$api_fields["fn_order_confirm_date"]]										= mbw_get_current_time();
	do_action('mbw_commerce_api_modify_order_state',"order_confirm");
}else if(mbw_get_param("board_action")=="modify_order_state"){
		
	$pay_state										= "";
	$t_pay_state										= "";	

	$where_data2									= array();
	$where_data2[]									= array("field"=>$api_fields["fn_pid"],"value"=>$board_pid);
	$where_data2[]									= array("field"=>$api_fields["fn_user_pid"],"value"=>mbw_get_user("fn_pid"));
	$order_state										= mbw_get_param("order_state");

	if(mbw_is_login()){
		$t_pay_state		= $mdb->get_var(mbw_get_add_query(array("column"=>$api_fields["fn_pay_state"],"join"=>"none"), $where_data2));
	}else{
		$order_pw		= mbw_get_param("order_pw");
		$t_pay_data		= $mdb->get_row(mbw_get_add_query(array("column"=>$api_fields["fn_pay_state"].','.$api_fields["fn_passwd"],"join"=>"none"), $where_data2),ARRAY_A);
		$t_pay_state		= $t_pay_data[$api_fields["fn_pay_state"]];
		$t_pay_passwd	= $t_pay_data[$api_fields["fn_passwd"]];
		if(!mbw_check_password($order_pw, $t_pay_passwd)){
			$order_state		= "";
		}		
	}
	//비회원일 경우 비밀번호 체크하기	
	if(!empty($order_state) && !empty($t_pay_state)){
		$check_pay_state					= false;
		$pay_state							= "";
		if(in_array($order_state, $mb_commerce_pay_cancel_state)!==false){
			$pay_state						= "cancel";
			$check_pay_state				= true;
			if(function_exists('mbw_update_order_product_data')){
				//주문 및 결제 취소시 상품 판매 개수 차감하기
				mbw_update_order_product_data("cancel",$board_pid);
			}
		}else if(in_array($order_state, $mb_commerce_pay_wait_state)!==false){
			$pay_state						= "wait";
			$check_pay_state				= true;
		}else if(in_array($order_state, $mb_commerce_pay_request_state)!==false){
			$pay_state						= "request";
			if($t_pay_state=="complete") $check_pay_state				= true;
		}else if(in_array($order_state, $mb_commerce_pay_complete_state)!==false){
			$pay_state						= "complete";
			if($t_pay_state=="request") $check_pay_state				= true;
		}
		if($check_pay_state){
			if(($order_state=='cancelled_order' || $pay_state=='request') && mbw_get_param("cancel_reason")!=''){
				$send_data[$api_fields["fn_pay_cancel_reason"]]				= mbw_get_param("cancel_reason");
			}

			$query_command								= "UPDATE";
			$where_data[$api_fields["fn_pid"]]			= $board_pid;
			$where_data[$api_fields["fn_user_pid"]]		= mbw_get_user("fn_pid");

			if(isset($api_fields["fn_pay_state"])) $send_data[$api_fields["fn_pay_state"]]				= $pay_state;
			if($t_pay_state=="wait"){
				if(isset($api_fields["fn_pay_date"]))		$send_data[$api_fields["fn_pay_date"]]	= mbw_get_current_time();
			}
		}
		do_action('mbw_commerce_api_modify_order_state',$order_state);
	}	
}else if(mbw_get_param("board_action")=="modify_admin_category"){	
	if(mbw_is_admin()){
		$query_command							= "UPDATE";
		$where_data[$api_fields["fn_board_name2"]]			= "commerce_".mbw_get_param("product_type");
	}
}else if(in_array($board_action, $order_action)!==false){
	mbw_commerce_session_start();
	$mb_board_table_name		= $mb_commerce_tables["commerce_order"];

	if(mbw_get_param("billing_id")!="" && mbw_get_param("product_pid")!="" && mbw_get_param("product_order_count")!=""){

		//회원 포인트 체크하기
		$use_point						= 0;		
		$order_point					= 0;
		$total_point					= 0;
		$total_count					= 0;
		$total_price						= 0;
		$user_point						= 0;

		$use_money					= 0;
		$user_money					= 0;
		$use_point2					= 0;
		$is_order						= false;

		if(mbw_get_param("use_point")!="") 
			$use_point		= intval(mbw_get_param("use_point"));
		if(mbw_get_param("use_money")!="") 
			$use_money	= intval(mbw_get_param("use_money"));
		if(mbw_get_param("order_point")!="") 
			$order_point		= intval(mbw_get_param("order_point"));

		$point_type		= "point";
		$user_pid			= 0;
		if(mbw_is_login()){
			$user_pid		= mbw_get_user("fn_pid");
		}else if(mbw_get_param('user_pid')!=""){
			 if(mbw_get_param('commerce_pay_method')=="paypal" && mbw_get_param('paypal_ipn_auth')==md5(mbw_get_param('paypal_tx')."_".mbw_get_param('user_pid')."_".mbw_get_param('order_id'))) {
				 $user_pid		= mbw_get_param('user_pid');
			 }
		}
		if(!empty($user_pid)){
			if($use_money>0){
				$user_money		= $mdb->get_var($mdb->prepare("select ".$mb_fields["users"]["fn_user_money"]." from `".$mb_admin_tables["users"]."` where `".$mb_fields["users"]["fn_pid"]."`=%d limit 1", $user_pid));
				$use_point2		= $use_money;
				$point_type			= "money";
			}else if($use_point>0){
				$user_point			= $mdb->get_var($mdb->prepare("select ".$mb_fields["users"]["fn_user_point"]." from `".$mb_admin_tables["users"]."` where `".$mb_fields["users"]["fn_pid"]."`=%d limit 1", $user_pid));
				$use_point2		= $use_point;
				$point_type			= "point";
			}
		}
		
		//동일한 billing_id 가 있는지 확인	
		$temp_billing_id		= mbw_value_filter(mbw_get_param("billing_id"));
		$billing_ids			= explode(",",$temp_billing_id);
		$order_check		= intval($mdb->get_var(mbw_get_add_query(array("column"=>"count(*)","table"=>$mb_board_table_name),array(array("field"=>"fn_billing_id","value"=>$billing_ids[0])))));
		$price_check			= true;
		$session_order_price	= 0;
		if(!empty($_SESSION['commerce_order_price'])){
			$session_order_price	= $_SESSION['commerce_order_price'];
		}else if(mbw_get_cookie("commerce_order_price")!=""){
			$session_order_price	= mbw_get_cookie("commerce_order_price");
		}

		$is_add_shipping_cost		= intval(mbw_get_param("is_add_shipping"));				
		$shipping_cost				= 0;
		$error_message				= "";
		if(!empty($user_pid) && mbw_get_param("coupon_pid")!='' && mbw_get_param("coupon_pid")!='0'){
			$coupon_pid					= intval(mbw_get_param("coupon_pid"));
			$coupon_discount			= floatval(mbw_get_param("coupon_discount"));

			$select_query				= $mdb->prepare("select * from `".$mb_commerce_tables["commerce_coupon"]."` where `".$mb_fields["commerce_coupon"]["fn_pid"]."`=%d", $coupon_pid);			
			$coupon_item				= $mdb->get_row($select_query,ARRAY_A);
			if(empty($coupon_item)){
				$error_message		= '존재하지 않거나 삭제된 쿠폰입니다';
			}else{
				$coupon_is_use		= intval($coupon_item[$mb_fields["commerce_coupon"]["fn_is_use"]]);
				$coupon_user_pid	= intval($coupon_item[$mb_fields["commerce_coupon"]["fn_user_pid"]]);
				$coupon_value		= ($coupon_item[$mb_fields["commerce_coupon"]["fn_coupon_value"]]);
				if(strpos($coupon_value,"%")!==false){
					$coupon_value	= intval(floatval($session_order_price) * floatval(rtrim($coupon_value,'%')))/100;
				}

				if($coupon_is_use==1){
					$error_message		= '이미 사용한 쿠폰입니다';
				}else if($coupon_is_use>1){
					$error_message		= '사용할 수 없는 쿠폰입니다';
				}else if($coupon_user_pid!=$user_pid){
					$error_message		= '사용할 수 없는 쿠폰입니다';
				}else if($coupon_discount!=$coupon_value){
					$error_message		= '쿠폰 할인 금액이 일치하지 않습니다';
				}
			}
		}else{
			$coupon_pid					= 0;
			$coupon_discount			= 0;
		}

		if(!empty($is_add_shipping_cost)) $shipping_cost		= abs(floatval(mbw_get_param("add_shipping_cost")));
		$check_price		= (intval(floatval($session_order_price)*100) - intval($use_point*100) - intval($coupon_discount*100) + intval($shipping_cost*100))/100;

		if(!empty($error_message)){
			mbw_error_message($error_message, "");			
		}else if(!empty($session_order_price) && mbw_get_param("order_price")!=strval($check_price)){
			mbw_error_message("주문 금액이 일치하지 않습니다", "");
		}else if($order_check>0){
			mbw_error_message("이미 동일한 주문이 존재합니다", "");
		}else if($use_point>$user_point){
			mbw_error_message("MSG_USE_ERROR", $mb_languages["W_POINT"]);
		}else if($use_money>$user_money){
			mbw_error_message("MSG_USE_ERROR", "캐시");
		}else if(mbw_is_product_order(explode(",",mbw_get_param("product_pid")),explode(",",mbw_get_param("product_order_count")))){
			
			$commerce_pay_method		= mbw_get_param("commerce_pay_method");

			$pay_method						= array("paypal","kakaopay","naverpay","samsungpay","eximbay");
			if(mbw_get_param("order_price")=="0"){
				if($use_point>0) $commerce_pay_method		= "point";
				else if($use_money>0) $commerce_pay_method		= "money";
				$pg_result_data			= array("state"=>"success","pay_state"=>"complete");				
			}else if(in_array($commerce_pay_method, $pay_method)!==false){
				require(MBW_COMMERCE_PAY_PATH.$commerce_pay_method."/functions.php");
				$pg_result_data		= mbw_pay_order_result();
			}else if(strpos($commerce_pay_method,"bank")!==0){
				$pg_result_data		= mbw_pg_order_result();
			}else{				
				$pg_result_data			= array("state"=>"success","pay_state"=>"wait");
				if(isset($api_fields["fn_pay_bank_account"]))		$send_data[$api_fields["fn_pay_bank_account"]]		= mbw_get_param("bank_account_info");
			}
			if($pg_result_data["state"]=="success"){
				$board_pid			= intval($mdb->get_var($mdb->prepare("select %1s from `%1s` ORDER BY %1s DESC limit 1;", $api_fields["fn_pid"],$mb_board_table_name,$api_fields["fn_pid"])));
				$billing_index		= 1;

				foreach($billing_ids as $billing_id){
					$order_products				= $mdb->get_results(mbw_get_add_query(array("column"=>"*","join"=>"none","table"=>$mb_commerce_tables["commerce_cart"]), array(array("field"=>$mb_fields["commerce_cart"]["fn_billing_id"],"value"=>$billing_id),array("field"=>$mb_fields["commerce_cart"]["fn_is_order"],"value"=>"0"))), ARRAY_A);
					if(empty($order_products)){
						$order_products		= $mdb->get_results($mdb->prepare("SELECT * from ".$mb_commerce_tables["commerce_cart"]." WHERE billing_id=%s AND is_order='0';",$billing_id), ARRAY_A);
					}

					$total_count	= $total_count+count($order_products);
					if(count($order_products)==0) continue;
					$order_products_serialize	= serialize($order_products);
					
					$shipping_check		= false;
					$product_type			= "shipping";
					$product_pid			= array();

					$regular_price			= 0;
					$sale_price				= 0;
					$shipping_cost		= 0;
					$product_point		= 0;
					
					$order_count			= 0;
					$options_price			= 0;
					$order_options		= "";
					$order_options1		= "";
					$order_options2		= "";
					$order_options3		= "";

					foreach($order_products as $product){
						
						$product_pid[]			= $product[$api_fields["fn_product_pid"]];
						$shop_name			= $product[$api_fields["fn_shop_name"]];
						$shop_pid				= $product[$api_fields["fn_shop_pid"]];
						$shop_email			= $product[$api_fields["fn_shop_email"]];

						$order_options		= $product[$api_fields["fn_order_options"]];
						$order_options1		= $product[$api_fields["fn_order_options1"]];
						$order_options2		= $product[$api_fields["fn_order_options2"]];
						$order_options3		= $product[$api_fields["fn_order_options3"]];

						$regular_price			= $regular_price+(floatval($product[$api_fields["fn_regular_price"]])*floatval($product[$api_fields["fn_order_count"]]));
						$sale_price				= $sale_price+(floatval(apply_filters("mf_product_sale_price",$product[$api_fields["fn_sale_price"]],$product[$api_fields["fn_product_pid"]]))*floatval($product[$api_fields["fn_order_count"]]));
						$shipping_cost		= $shipping_cost+floatval($product[$api_fields["fn_shipping_cost"]]);
						$options_price			= $options_price+floatval($product[$api_fields["fn_order_options_price"]]);
						$product_point		= $product_point+(floatval($product[$api_fields["fn_product_point"]])*floatval($product[$api_fields["fn_order_count"]]));
						$order_count			= $order_count+floatval($product[$api_fields["fn_order_count"]]);

						//상품의 판매 개수 추가
						if(strpos($product[$api_fields["fn_product_type"]],"shipping")===0){
							$shipping_check	= true;						
							$query_data[]	= $mdb->prepare("UPDATE ".$mb_commerce_tables["commerce_product"]." set ".$mb_fields["commerce_product"]["fn_sale_count"]."=".$mb_fields["commerce_product"]["fn_sale_count"]."+%d, ".$mb_fields["commerce_product"]["fn_stock"]."=".$mb_fields["commerce_product"]["fn_stock"]."-%d where ".$mb_fields["commerce_product"]["fn_pid"]."=%d", $product[$api_fields["fn_order_count"]],$product[$api_fields["fn_order_count"]],$product[$api_fields["fn_product_pid"]]);
						}else{
							$query_data[]	= $mdb->prepare("UPDATE ".$mb_commerce_tables["commerce_product"]." set ".$mb_fields["commerce_product"]["fn_sale_count"]."=".$mb_fields["commerce_product"]["fn_sale_count"]."+%d where ".$mb_fields["commerce_product"]["fn_pid"]."=%d", $product[$api_fields["fn_order_count"]],$product[$api_fields["fn_product_pid"]]);
						}
					}
					if(mbw_get_option("commerce_item_type")=="all" || mbw_get_option("commerce_item_type")=="shop") {
						if($billing_index==1) $shipping_cost		= floatval(mbw_get_param("shipping_cost"));
						else $shipping_cost		= 0;
					}

					if(!empty($product)){
						if(isset($api_fields["fn_title"])){			
							if(count($order_products)>1){
								$send_data[$api_fields["fn_title"]]				= $product[$api_fields["fn_title"]]." 외 ".(count($order_products)-1)."건";
							}else{
								$send_data[$api_fields["fn_title"]]				= $product[$api_fields["fn_title"]];			
							}
						}
						if(isset($api_fields["fn_image_path"]))		$send_data[$api_fields["fn_image_path"]]				= $product[$api_fields["fn_image_path"]];
						if(isset($api_fields["fn_product_type"]))		$send_data[$api_fields["fn_product_type"]]			= $product[$api_fields["fn_product_type"]];
						if(isset($api_fields["fn_pay_type"]) && !empty($product[$api_fields["fn_pay_type"]]))		$send_data[$api_fields["fn_pay_type"]]						= $product[$api_fields["fn_pay_type"]];
						if(isset($api_fields["fn_product_pid"]))		$send_data[$api_fields["fn_product_pid"]]			= implode(",",$product_pid);

						if(mbw_get_option("commerce_db_version")>"1.0.2"){
							if(isset($api_fields["fn_category1"]))		$send_data[$api_fields["fn_category1"]]								= $product[$api_fields["fn_category1"]];
							if(isset($api_fields["fn_category2"]))		$send_data[$api_fields["fn_category2"]]								= $product[$api_fields["fn_category2"]];
							if(isset($api_fields["fn_category3"]))		$send_data[$api_fields["fn_category3"]]								= $product[$api_fields["fn_category3"]];

							if(isset($api_fields["fn_market_type1"]))	$send_data[$api_fields["fn_market_type1"]]						= $product[$api_fields["fn_market_type1"]];
							if(isset($api_fields["fn_market_type2"]))	$send_data[$api_fields["fn_market_type2"]]						= $product[$api_fields["fn_market_type2"]];
							if(isset($api_fields["fn_market_type3"]))	$send_data[$api_fields["fn_market_type3"]]						= $product[$api_fields["fn_market_type3"]];
							if(isset($api_fields["fn_market_type4"]))	$send_data[$api_fields["fn_market_type4"]]						= $product[$api_fields["fn_market_type4"]];
						}
						if(mbw_get_option("commerce_db_version")>"1.0.5"){
							if(isset($api_fields["fn_is_dutyfree"]))		$send_data[$api_fields["fn_is_dutyfree"]]								= $product[$api_fields["fn_is_dutyfree"]];
						}
						for($i=1;$i<=10;$i++){
							$f_name		= "fn_ext".$i;
							if(isset($api_fields[$f_name]) && isset($product[$api_fields[$f_name]]))	$send_data[$api_fields[$f_name]]	= $product[$api_fields[$f_name]];
						}
					}

					$query_command							= "INSERT";
					$completed_method						= array("card","handphone","d_bank","point","paypal","kakaopay","naverpay","samsungpay","eximbay","onlykakaopay","onlyssp","onlypayco","onlylpay","onlyssgcard");
					if(in_array($commerce_pay_method, $completed_method)!==false || mbw_get_param("order_price")=="0"){
						if(isset($api_fields["fn_order_state"]))		$send_data[$api_fields["fn_order_state"]]				= "completed_payment";
					}else{
						if(isset($api_fields["fn_order_state"]))		$send_data[$api_fields["fn_order_state"]]				= "completed_order";
					}

					if($shipping_check){
						if(isset($api_fields["fn_product_type"]))		$send_data[$api_fields["fn_product_type"]]			= "shipping";
					}					
									
					if(isset($api_fields["fn_billing_id"]))		$send_data[$api_fields["fn_billing_id"]]							= $billing_id;
					if(isset($api_fields["fn_shop_email"]))		$send_data[$api_fields["fn_shop_email"]]					= $shop_email;
					if(isset($api_fields["fn_shop_name"]))		$send_data[$api_fields["fn_shop_name"]]					= $shop_name;
					if(isset($api_fields["fn_shop_pid"]))		$send_data[$api_fields["fn_shop_pid"]]							= $shop_pid;
					if(isset($api_fields["fn_recommender_pid"]) && !empty($product[$api_fields["fn_recommender_pid"]]))	$send_data[$api_fields["fn_recommender_pid"]]	= $product[$api_fields["fn_recommender_pid"]];

					if(isset($api_fields["fn_order_options"]))		$send_data[$api_fields["fn_order_options"]]						= $order_options;
					if(isset($api_fields["fn_order_options1"]))		$send_data[$api_fields["fn_order_options1"]]						= $order_options1;
					if(isset($api_fields["fn_order_options2"]))		$send_data[$api_fields["fn_order_options2"]]						= $order_options2;
					if(isset($api_fields["fn_order_options3"]))		$send_data[$api_fields["fn_order_options3"]]						= $order_options3;

					if(isset($api_fields["fn_regular_price"]))		$send_data[$api_fields["fn_regular_price"]]							= $regular_price+$options_price;
					if(isset($api_fields["fn_sale_price"]))		$send_data[$api_fields["fn_sale_price"]]									= $sale_price+$options_price;					
					if(isset($api_fields["fn_shipping_cost"]))		$send_data[$api_fields["fn_shipping_cost"]]						= $shipping_cost;				

					$order_price		= floatval($sale_price)+floatval($shipping_cost)+$options_price;
					
					if($order_price>$use_point2){
						$order_price		= $order_price-$use_point2;
						$use_point3		= $use_point2;
						$use_point2		= 0;
					} else {
						$use_point2		= $use_point2-$order_price;
						$use_point3		= $order_price;
						$order_price		= 0;				
					}
					if(!empty($coupon_pid)){
						if($order_price>=$coupon_discount){
							$order_price		= $order_price-$coupon_discount;
						}else{
							$order_price		= 0;
						}
						if(isset($api_fields["fn_coupon_pid"]))		$send_data[$api_fields["fn_coupon_pid"]]							= $coupon_pid;
						if(isset($api_fields["fn_coupon_discount"]))		$send_data[$api_fields["fn_coupon_discount"]]			= $coupon_discount;
						$use_date				= mbw_get_current_time();
						$mdb->query($mdb->prepare("update ".$mb_commerce_tables["commerce_coupon"]." set ".$mb_fields["commerce_coupon"]["fn_is_use"]."=1,".$mb_fields["commerce_coupon"]["fn_use_date"]."=%s where ".$mb_fields["commerce_coupon"]["fn_pid"]."=%d",$use_date,$coupon_pid));
						$coupon_pid			= 0;
						$coupon_discount	= 0;
					}

					$total_price				= $total_price+$order_price;
					$total_point			= $total_point+$product_point;
					$order_point2			= $product_point;
					if($order_point<$order_point2) $order_point2		= $order_point;
					if(isset($api_fields["fn_product_point"]))		$send_data[$api_fields["fn_product_point"]]							= $product_point;
					if(isset($api_fields["fn_order_point"]))		$send_data[$api_fields["fn_order_point"]]									= $order_point2;

					if($point_type=="money"){
						if(isset($api_fields["fn_use_money"]))	$send_data[$api_fields["fn_use_money"]]									= $use_point3;
					}else{
						if(isset($api_fields["fn_use_point"]))		$send_data[$api_fields["fn_use_point"]]									= $use_point3;
					}
					if(isset($api_fields["fn_order_price"]))		$send_data[$api_fields["fn_order_price"]]								= $order_price;
					if(isset($api_fields["fn_order_options_price"]))		$send_data[$api_fields["fn_order_options_price"]]		= $options_price;
					if(isset($api_fields["fn_order_count"]))		$send_data[$api_fields["fn_order_count"]]								= $order_count;

					$board_pid		= $board_pid+1;
					if(isset($api_fields["fn_pid"]))		$send_data[$api_fields["fn_pid"]]														= $board_pid;
					if(isset($api_fields["fn_order_products"]))		$send_data[$api_fields["fn_order_products"]]						= $order_products_serialize;

					if(isset($api_fields["fn_pay_method"]))		$send_data[$api_fields["fn_pay_method"]]							= $commerce_pay_method;
					if(isset($api_fields["fn_pay_date"]))		$send_data[$api_fields["fn_pay_date"]]										= mbw_get_current_time();
					
					if(strpos($commerce_pay_method,"bank")!==0 && !empty($pg_result_data)){
						if(isset($api_fields["fn_pay_price"]))		$send_data[$api_fields["fn_pay_price"]]								= $pg_result_data["total_price"];
						if(isset($api_fields["fn_order_id"]))		$send_data[$api_fields["fn_order_id"]]									= $pg_result_data["order_id"];	
						if(isset($api_fields["fn_pay_tid"]))		$send_data[$api_fields["fn_pay_tid"]]										= $pg_result_data["tid"];
						if(isset($api_fields["fn_pay_bank_account"]))		$send_data[$api_fields["fn_pay_bank_account"]]		= $pg_result_data["bank_account"];
						if(isset($api_fields["fn_pay_info"]))		$send_data[$api_fields["fn_pay_info"]]									= $pg_result_data["pay_info"];
						if(isset($api_fields["fn_pay_auth_no"]))		$send_data[$api_fields["fn_pay_auth_no"]]						= $pg_result_data["pay_auth_no"];
					}else{
						if(isset($api_fields["fn_pay_price"]))		$send_data[$api_fields["fn_pay_price"]]								= $order_price;
						if(isset($api_fields["fn_order_id"]))		$send_data[$api_fields["fn_order_id"]]									= mbw_get_param("order_id");
					}

					if(isset($api_fields["fn_pay_state"]))		$send_data[$api_fields["fn_pay_state"]]										= $pg_result_data["pay_state"];
					if(isset($api_fields["fn_pay_pg"]))		$send_data[$api_fields["fn_pay_pg"]]											= mbw_get_option("commerce_pay_pg");
					if(isset($api_fields["fn_is_escrow"]))		$send_data[$api_fields["fn_is_escrow"]]									= mbw_get_param("use_escrow");
					if(isset($api_fields["fn_pay_platform"]))		$send_data[$api_fields["fn_pay_platform"]]							= mbw_get_option("commerce_pay_platform");

					if(mbw_get_vars("device_type")=="desktop"){
						if(isset($api_fields["fn_is_mobile"]))		$send_data[$api_fields["fn_is_mobile"]]								= "0";
					}else{
						if(isset($api_fields["fn_is_mobile"]))		$send_data[$api_fields["fn_is_mobile"]]								= "1";
					}
					if(has_filter('mf_commerce_send_data')) $send_data		= apply_filters("mf_commerce_send_data",$send_data);
					$query_data[]		= $mdb->get_query($query_command,$mb_board_table_name, $send_data, $where_data);
					$billing_index++;
				}

				if($total_count>0){
					$_SESSION['commerce_billing_id']	= mbw_get_param("billing_id");
					$_SESSION['commerce_order_id']	= mbw_get_param("billing_id");

					$billing_format				= array();
					foreach($billing_ids as $value) $billing_format[]		= "%s";
					$query_data[]	= $mdb->prepare("UPDATE ".$mb_commerce_tables["commerce_cart"]." set ".$mb_fields["commerce_cart"]["fn_is_order"]."='1' where ".$mb_fields["commerce_cart"]["fn_billing_id"]." in ('".implode("','",$billing_format)."')", $billing_ids );

					do_action( 'mbw_commerce_api_order_complete', mbw_get_param("billing_id"));
					
					if($pg_result_data["pay_state"]=="complete")
					{
						do_action( 'mbw_commerce_api_pay_complete',mbw_get_param("billing_id"));

						//회원 정보에서 결제금액 수정
						if(!empty($user_pid)){
							$query_data[]		= $mdb->prepare("UPDATE ".$mb_admin_tables["users"]." set ".$mb_fields["users"]["fn_payment_count"]."=".$mb_fields["users"]["fn_payment_count"]."+1, ".$mb_fields["users"]["fn_payment_total"]."=".$mb_fields["users"]["fn_payment_total"]."+%d where ".$mb_fields["users"]["fn_pid"]."=%d", $total_price,$user_pid);
							
							if(!empty($use_point)) mbw_set_user_point("commerce","order_use",$use_point*(-1),$user_pid);
							if(!empty($order_point)){
								if($order_point>$total_point) $order_point	= $total_point;
								mbw_set_user_point("commerce","order_save",$order_point,$user_pid);
							}
							if(!empty($use_money)) mbw_set_user_money("commerce","money_use",$use_money*(-1),$user_pid);
						}
						mbw_analytics("today_sales",$total_price);		// 오늘의 판매 금액 추가
					}
					$commerce_data['pay_method']		= $commerce_pay_method;
					if(!empty($pg_result_data['pay_state'])) $commerce_data['pay_state']			= $pg_result_data['pay_state'];
				}else{
					mbw_error_message("MSG_NONCE_MATCH_ERROR", "","1401");
				}
			}else{
				if(!empty($pg_result_data["result_msg"])){
					mbw_error_message($pg_result_data["result_msg"], "","1401");
				}else{
					mbw_error_message("한도초과 또는 일시적인 문제로 결제등록을 완료하지 못했습니다.<br>잠시후 다시 이용해 주시기 바랍니다", "","1401");
				}
			}
		}		
	}
	$query_command			= "";
}else if(mbw_get_param("board_action")=="menu"){
	$user_name		= "";
	$user_point		= "0";
	$user_level		= "0";
	$menu_body		= array();
	$menu_data		= array();
	if(mbw_get_option("show_name_popup")!==0){
		$menu_field		= "*";
		$select_query	= mbw_get_add_query(array("column"=>$menu_field,"table"=>$mb_admin_tables["users"]));
		$user_data		= $mdb->get_row($mdb->prepare($select_query." where ".$mb_fields["users"]["fn_pid"]."=%d", mbw_get_param("pid")),ARRAY_A);
		$mb_user_level	= intval(mbw_get_user("fn_user_level"));
		if(!empty($user_data)){
			$menu_options	= mbw_get_param("option");
			$board_type		= mbw_get_board_option("fn_board_type");
			if(($board_type!="admin" && $board_type!="custom")){
				if(strpos($menu_options, 'search')!==false) $menu_body[]		= '<a href="'.mbw_get_url( array("board_pid"=>"","mode"=>"list","board_page"=>1,"search_field"=>"","search_text"=>"","category1"=>mbw_get_param("category1"),"category2"=>mbw_get_param("category2"),"category3"=>mbw_get_param("category3"),"list_type"=>mbw_get_param("list_type")) ).'&search_field=fn_shop_pid&search_text='.mbw_get_param("pid").'"><span>'.__MW("판매자 검색").'</span></a>';
			}
			if($mb_user_level>=10 && strpos($menu_options, 'email')!==false && !empty($user_data[$mb_fields["users"]["fn_user_email"]])) $menu_body[]		= '<a href="mailto:'.$user_data[$mb_fields["users"]["fn_user_email"]].'"><span>'.__MW("W_USER_EMAIL").'</span></a>';
			if(strpos($menu_options, 'homepage')!==false && !empty($user_data[$mb_fields["users"]["fn_user_homepage"]])) $menu_body[]		= '<a href="'.$user_data[$mb_fields["users"]["fn_user_homepage"]].'" target="_blank"><span>'.__MW("W_USER_HOMEPAGE").'</span></a>';
			if(strpos($menu_options, 'blog')!==false && !empty($user_data[$mb_fields["users"]["fn_user_blog"]])) $menu_body[]		= '<a href="'.$user_data[$mb_fields["users"]["fn_user_blog"]].'" target="_blank"><span>'.__MW("W_USER_BLOG").'</span></a>';
		
			$user_name		= $user_data[$mb_fields["users"]["fn_user_name"]];
			$user_point		= $user_data[$mb_fields["users"]["fn_user_point"]];
			$user_level		= $user_data[$mb_fields["users"]["fn_user_level"]];
		}
		if(has_filter('mf_user_popup_menu')) $menu_body			= apply_filters("mf_user_popup_menu",$menu_body);
	}
	$menu_data["head"]	= "";
	$menu_data["user"]		= array("name"=>$user_name,"point"=>$user_point,"level"=>$user_level);
	$menu_data["body"]	= $menu_body;
	$menu_data["foot"]		= "";		
	$commerce_data		= $menu_data;
}else if(mbw_get_param("board_action")=="table_data"){

	$table_data		= "";
	if((mbw_is_admin() || mbw_is_commerce_group()) && mbw_get_param("fields")!=""){
		if($mb_board_table_name==mbw_get_board_table_name("commerce_order")){
			if(!mbw_is_admin() || !mbw_is_admin_page()){
				mbw_set_board_where(array("field"=>"fn_shop_pid", "value"=>mbw_get_user("fn_pid")));
			}
		}else if(!mbw_is_admin()){
			if($mb_board_table_name==mbw_get_board_table_name("commerce_coupon")) exit;
			else mbw_set_board_where(array("field"=>"fn_user_pid", "value"=>mbw_get_user("fn_pid")));
		}
		$select_pid				= mbw_get_param("select_pid");
		$select_pid				= mbw_value_filter($select_pid);
		if(!empty($select_pid)){
			$billing_format			= array();
			$pid_array				= explode(",", $select_pid);
			foreach($pid_array as $value) $billing_format[]		= "%d";
			$select_query				= mbw_get_add_query(array("column"=>"*","join"=>"none")).$mdb->prepare(' where pid in ('.implode(",",$billing_format).') order by pid desc', $pid_array);
		}else{
			$select_query				= mbw_get_add_query(array("column"=>"*","join"=>"none"), "where", "order")." limit 0, 1500";
		}
		$items						= $mdb->get_results($select_query,ARRAY_A);

		$table_data		= "<table>";
		$table_array		= array();
		$table_item		= array();
		$table_fields		= explode(",", mbw_get_param("fields"));
		$table_titles		= explode(",", mbw_get_param("titles"));

		if(count($items)> 0){
			$table_data			.= '<tr>';
			foreach($table_titles	 as $title){
				$table_data			= $table_data.'<td style="width:100px;border:solid 3px #EEE;">'.$title.'</td>';
				$table_item[]			= $title;
			}			
			$table_data			.= '</tr>';
			$table_array[]		= $table_item;
			foreach($items as $item){
				$table_data			.= '<tr>';
				$table_item			= array();

				foreach($table_fields as $field){
					if($field=="fn_order_products"){
						$option_data			= "";
						$order_products		= maybe_unserialize($item[$api_fields[$field]]);
						$table_data			.= '<td style="width:500px;border:solid 1px #EEE;">';
						foreach($order_products as $product){
							$option_data		.= "- ".$product[$api_fields["fn_title"]]." [".$product[$api_fields["fn_order_count"]]."개]<br>";
							if(!empty($api_fields["fn_order_options"]) && !empty($product[$api_fields["fn_order_options"]])) {
								$order_options		= mbw_htmlspecialchars_decode($product[$api_fields["fn_order_options"]]);							
								$order_options		= str_replace("<div>"," └ ",$order_options);
								$order_options		= strip_tags(str_replace("</span></div>","@@br@@",$order_options));
								$order_options		= str_replace("@@br@@","<br>",$order_options);
								$option_data			.= $order_options;
							}

							if(!empty($api_fields["fn_order_options1"]) && !empty($product[$api_fields["fn_order_options1"]])) 
								$option_data			.= " └ ".$product[$api_fields["fn_order_options1"]]."<br>";
							if(!empty($api_fields["fn_order_options2"]) && !empty($product[$api_fields["fn_order_options2"]])) 
								$option_data			.= " └ ".$product[$api_fields["fn_order_options2"]]."<br>";
							if(!empty($api_fields["fn_order_options3"]) && !empty($product[$api_fields["fn_order_options3"]])) 
								$option_data			.= " └ ".$product[$api_fields["fn_order_options3"]]."<br>";
						}						
						$table_data			.= $option_data."</td>";
						$table_item[]			= str_replace("<br>",chr(10),substr($option_data, 0, -4));
					}else if($field=='fn_shipping_postcode'){
						$table_data			.= '<td style="width:100px;border:solid 0.5px #EEE;">'.mbw_htmlspecialchars_decode($item[$api_fields[$field]]).'&nbsp;</td>';
						$table_item[]			= mbw_htmlspecialchars_decode($item[$api_fields[$field]]);
					}else if($field=='fn_shipping_address'){
						$table_data			.= '<td style="width:100px;border:solid 0.5px #EEE;">'.mbw_htmlspecialchars_decode($item[$api_fields['fn_shipping_address1']].' '.$item[$api_fields['fn_shipping_address2']]).'</td>';
						$table_item[]			= mbw_htmlspecialchars_decode($item[$api_fields['fn_shipping_address1']].' '.$item[$api_fields['fn_shipping_address2']]);
					}else if($field=='fn_home_address'){
						$table_data			.= '<td style="width:100px;border:solid 0.5px #EEE;">'.mbw_htmlspecialchars_decode($item[$api_fields['fn_home_address1']].' '.$item[$api_fields['fn_home_address2']]).'</td>';
						$table_item[]			= mbw_htmlspecialchars_decode($item[$api_fields['fn_home_address1']].' '.$item[$api_fields['fn_home_address2']]);
					}else if($field=='fn_order_state'){
						global $mb_commerce_order_shipping_state;
						$commerce_item_state		= $mb_commerce_order_shipping_state;
						$order_state				= $item[$api_fields[$field]];
						$pay_method			= $item[$api_fields["fn_pay_method"]];

						if(strpos($pay_method,"bank")===0 || $pay_method=="v_bank"){
							$commerce_item_state["cancelled_payment"]		= __MW("W_STATE_COMPLETED_REFUND");
							$commerce_item_state["completed_payment"]		= __MW("W_STATE_COMPLETED_DEPOSIT");
						}
						if(!empty($commerce_item_state[$order_state])){
							$order_state		= $commerce_item_state[$order_state];
						}
						$table_data			.= '<td style="width:100px;border:solid 0.5px #EEE;">'.$order_state.'</td>';
						$table_item[]			= mbw_htmlspecialchars_decode($order_state);
					}else if(strpos($field,'fn_')===0){
						$table_data			.= '<td style="width:100px;border:solid 0.5px #EEE;">'.mbw_htmlspecialchars_decode($item[$api_fields[$field]]).'</td>';
						$table_item[]			= mbw_htmlspecialchars_decode($item[$api_fields[$field]]);
					}else{
						$table_data			.= '<td style="width:100px;border:solid 0.5px #EEE;">'.$field.'</td>';
						$table_item[]			= $field;
					}					
				}
				$table_data			.= '</tr>';
				$table_array[]		= $table_item;
			}
		}			
		$table_data		.= "</table>";
	}
	$commerce_data			= $table_data;
	if(version_compare(mbw_get_option("mb_version"), '1.9.7', '>=') && has_filter('mf_commerce_order_table_data')){
		$commerce_data		= apply_filters("mf_commerce_order_table_data",$commerce_data, $table_array);
	}
}
if($mstore->get_result_data("state")=="error"){
	echo mbw_data_encode($mstore->result_data);	
	exit;
}
do_action('mbw_commerce_api_body');
if(!empty($query_command)){
	if(has_filter('mf_commerce_send_data')) $send_data		= apply_filters("mf_commerce_send_data",$send_data);
	$mdb->db_query($query_command,$mb_board_table_name, $send_data, $where_data);	
}
if(!empty($query_data)){
	$count					= count($query_data);
	for($i=0;$i<$count;$i++){
		if(!empty($query_data[$i])) $mdb->query($query_data[$i]);
	}
}

if($mstore->get_result_data("state")=="error"){
	echo mbw_data_encode($mstore->result_data);
	exit;
}

$mstore->set_result_data(array("data"=>$commerce_data));

do_action('mbw_commerce_api_footer');
echo mbw_data_encode($mstore->get_result_datas(array("state"=>"success")));
exit;
?>