<?php
register_activation_hook(MBW_PLUGIN_FILE, 'mbw_commerce_install');

function mbw_commerce_install(){
	global $wpdb;
	require(MBW_PLUGIN_PATH."includes/mb-config.php");
	require(MBW_PLUGIN_PATH."plugins/commerce/includes/commerce-config.php");	
	require(MBW_PLUGIN_PATH."includes/install/schema/mb-schema.php");
	require(MBW_PLUGIN_PATH."includes/install/schema/commerce-schema.php");

	$log_path			= MBW_LOG_PATH."pg/";
	if(!is_dir($log_path)){
		@mkdir($log_path, 0777, true);
		@chmod($log_path, 0777);
	}
	
	foreach($mb_commerce_tables as $key=>$value){
		$schema				= "";
		if(!empty($commerce_schema[$key])){
			$schema		= $commerce_schema[$key];
		}else if($key=="commerce_product_qa" || $key=="commerce_product_review" || $key=="commerce_info" || $key=="commerce_notification"){
			$schema		= $mb_schema["board"];
		}else if($key=="commerce_product_comment" || $key=="commerce_product_qa_comment" || $key=="commerce_product_review_comment"){
			$schema		= $mb_schema["comment"];
		}
		if(!empty($schema)) mbw_create_query($mb_commerce_tables[$key],$schema);
	}
	
	$board_options_rows									= array();	
	$board_options_rows['commerce_product']			= "('commerce_product', '', 'bbs_basic', 'commerce/product', '', '', '', '', '', 'S', 'mb', 48, 50, 10, 'SELECT_RELOAD', '{\"아우터\":\"아우터\",\"드레스\":\"드레스\",\"기타\":\"기타\"}', 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 5, 99, 10, 8, 8, 8, 0, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 1)";
	$board_options_rows['commerce_lecture']			= "('commerce_lecture', '', 'bbs_basic', 'commerce/lecture', 'commerce_product', '', '', '', '', 'S', 'mb', 48, 50, 10, 'SELECT_RELOAD', '{\"홈페이지\":\"홈페이지\",\"쇼핑몰\":\"쇼핑몰\",\"기타\":\"기타\"}', 0, 0, 1, 0, 0, 1, 1, 1, 1, 0, 0, 5, 99, 10, 8, 8, 8, 0, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 1)";
	$board_options_rows['commerce_product_qa']		= "('commerce_product_qa', '', 'bbs_basic', 'commerce/product_qa', '', '', '', '', '', 'S', 'mb', 24, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 1, 5, 10, 8, 8, 8, 99, 0, 0, 0, 0, 'board', '2016-06-01 12:00:00', 1)";
	$board_options_rows['commerce_product_review']	= "('commerce_product_review', '', 'bbs_basic', 'commerce/product_review', '', '', '', '', '', 'S', 'mb', 24, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 5, 10, 8, 8, 8, 99, 0, 0, 0, 0, 'board', '2016-06-01 12:00:00', 1)";
	$board_options_rows['commerce_product_comment']	= "('commerce_product_comment', '', 'bbs_basic', 'commerce/product', '', '', '', '', '', 'S', 'mb', 5, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 5, 10, 8, 8, 8, 99, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 0)";
	$board_options_rows['commerce_cart']				= "('commerce_cart', '', 'bbs_basic', 'commerce/cart', '', '', '', '', '', 'N', 'mb', 50, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 99, 99, 10, 10, 99, 8, 99, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 1)";
	$board_options_rows['commerce_wishlist']			= "('commerce_wishlist', '', 'bbs_basic', 'commerce/wishlist', '', '', '', '', '', 'N', 'mb', 24, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 99, 99, 99, 99, 99, 8, 99, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 1)";
	$board_options_rows['commerce_billing']			= "('commerce_billing', '', 'bbs_basic', 'commerce/billing', 'commerce_order', '', '', '', '', 'N', 'mb', 50, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 99, 99, 10, 99, 99, 8, 99, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 0)";
	$board_options_rows['commerce_order']			= "('commerce_order', '', 'bbs_basic', 'commerce/order', '', '', '', '', '', 'N', 'mb', 50, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 99, 99, 10, 99, 99, 8, 99, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 1)";
	$board_options_rows['commerce_my_order']		= "('commerce_my_order', '', 'bbs_basic', 'commerce/my_order', 'commerce_order', '', '', '', '', 'N', 'mb', 24, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 99, 99, 99, 99, 99, 8, 99, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 1)";
	$board_options_rows['commerce_order_virtual']	= "('commerce_order_virtual', '', 'bbs_basic', 'commerce/billing', 'commerce_order', '', '', '', '', 'N', 'mb', 24, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 99, 99, 99, 99, 99, 8, 99, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 0)";
	$board_options_rows['commerce_order_shipping']= "('commerce_order_shipping', '', 'bbs_basic', 'commerce/billing', 'commerce_order', '', '', '', '', 'N', 'mb', 24, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 99, 99, 99, 99, 99, 8, 99, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 0)";
	$board_options_rows['commerce_order_result']	= "('commerce_order_result', '', 'bbs_basic', 'commerce/order', 'commerce_order', '', '', '', '', 'N', 'mb', 50, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 99, 99, 99, 99, 99, 8, 99, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 0)";
	$board_options_rows['commerce_order_search']	= "('commerce_order_search', '', 'bbs_basic', 'commerce/order', 'commerce_order', '', '', '', '', 'N', 'mb', 24, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 99, 99, 99, 99, 99, 8, 99, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 0)";
	$board_options_rows['commerce_coupon']			= "('commerce_coupon', '', 'bbs_basic', 'commerce/coupon', '', '', '', '', '', 'N', 'mb', 36, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 8, 99, 10, 10, 99, 8, 99, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 1)";
	$board_options_rows['commerce_point']			= "('commerce_point', '', 'bbs_basic', 'commerce/point', 'logs', '', '', '', '', 'N', 'mb', 36, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 99, 99, 10, 99, 99, 8, 99, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 1)";
	$board_options_rows['commerce_meta']				= "('commerce_meta', '', 'bbs_basic', 'commerce/meta', '', '', '', '', '', 'N', 'mb', 24, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 8, 8, 99, 99, 99, 99, 99, 8, 99, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 0)";
	$board_options_rows['commerce_email']			= "('commerce_email', '', 'bbs_basic', 'commerce/email', 'commerce_notification', '', '', '', '', 'S', 'mb', 24, 50, 10, 'NONE', 'email', 0, 0, 0, 0, 0, 1, 1, 1, 1, 8, 8, 8, 99, 10, 99, 99, 8, 99, 0, 0, 0, 0, 'board', '2016-06-01 12:00:00', 1)";
	$board_options_rows['commerce_notification']		= "('commerce_notification', '', 'bbs_basic', 'commerce/notification', '', '', '', '', '', 'S', 'mb', 24, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 1, 1, 1, 1, 8, 8, 8, 99, 10, 99, 99, 8, 99, 0, 0, 0, 0, 'board', '2016-06-01 12:00:00', 0)";
	$board_options_rows['commerce_info']				= "('commerce_info', '', 'bbs_basic', 'commerce/info', '', '', '', '', '', 'S', 'mb', 24, 50, 10, 'TAB_AJAX', '판매자정보,배송정보,반품정보,교환정보,기타안내', 0, 0, 0, 0, 0, 1, 1, 1, 1, 8, 8, 8, 99, 10, 99, 99, 8, 99, 0, 0, 0, 0, 'board', '2016-06-01 12:00:00', 1)";
	$board_options_rows['commerce_sales_table']		= "('commerce_sales_table', '', 'bbs_basic', 'commerce/sales_table', 'commerce_order', '', '', '', '', 'N', 'mb', 100, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 8, 8, 99, 99, 99, 99, 99, 8, 99, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 0)";
	$board_options_rows['commerce_users']			= "('commerce_users', '', 'bbs_basic', 'commerce/users', 'users', '', '', '', '', 'N', 'mb', 50, 50, 10, 'NONE', '', 0, 0, 0, 0, 0, 0, 0, 1, 1, 8, 8, 10, 99, 10, 10, 10, 8, 8, 0, 0, 0, 0, 'commerce', '2016-06-01 12:00:00', 0)";
	mbw_install_add_board_options($board_options_rows,$mb_admin_tables["board_options"]);
	
	$commerce_pay_pp		= "m_pay_pp";
	$commerce_pay_ts		= "m_pay_ts";
	if(is_file(MBW_PLUGIN_PATH."plugins/user/user.php")){
		$commerce_pay_pp		= "privacy_policy";
		$commerce_pay_ts		= "terms_service";	
	}
	$options_rows													= array();	
	$options_rows['commerce_db_version']				= "('setup', 'commerce', '커머스 디비 버젼', 'commerce_db_version', '".$mb_commerce_db_version."', '', '', '', 'width:300px;', '', '', 'text_static', '')";
	$options_rows['commerce_version']					= "('setup', 'commerce', '커머스 버젼', 'commerce_version', '".$mb_commerce_version."', '', '', '', 'width:300px;', '', '', 'text_static', '')";
	$options_rows['commerce_pp_url']					= "('setup', 'commerce', '개인정보 수집 주소', 'commerce_pp_url', '".$commerce_pay_pp."', '', '', '', '', '', '', 'text', '<br>결제시 동의가 필요한 개인정보 수집 URL 주소 또는 페이지 SLUG를 입력합니다(생략시 버튼도 표시 안됨)')";
	$options_rows['commerce_ts_url']					= "('setup', 'commerce', '결제 이용약관 주소', 'commerce_ts_url', '".$commerce_pay_ts."', '', '', '', '', '', '', 'text', '<br>결제시 동의가 필요한 이용약관 URL 주소 또는 페이지 SLUG를 입력합니다(생략시 버튼도 표시 안됨)')";
	$options_rows['use_guest_order']					= "('setup', 'commerce', '비회원 주문', 'use_guest_order', '0', '0,1', '사용안함,사용', '', '', '', '', 'radio', '<br>비회원 주문 기능 사용시 로그인 없이도 주문 및 결제가 가능합니다')";
	$options_rows['use_review_write']					= "('setup', 'commerce', '상품 리뷰 작성', 'use_review_write', '2', '0,1,2', '사용안함,사용(주문자만 리뷰등록 가능),사용(누구나 리뷰등록 가능)', '', '', '', '', 'radio', '')";	
	//$options_rows['use_shipping_date']				= "('setup', 'commerce', '희망 배송일 기능', 'use_shipping_date', '0', '0,1', '사용안함,사용', '', '', '', '', 'radio', '')";
	$options_rows['add_shipping_cost']					= "('setup', 'commerce', '추가 배송비', 'add_shipping_cost', '3000', '', '', '', 'width:200px;', '', '', 'text', '<br>제주 및 도서산간지역 추가 배송비로 표시할 기준 금액을 설정합니다 (지역에 따라 실제 추가되는 추가 배송비는 CJ대한통운 요금제를 기준으로 자동 반영됩니다)')";
	$options_rows['use_add_shipping_cost']				= "('setup', 'commerce', '추가 배송비 기능', 'use_add_shipping_cost', '1', '0,1', '사용안함,사용', '', '', '', '', 'radio', '<br>제주 및 도서산간지역 추가 배송비 기능 사용 여부를 설정합니다')";
	$options_rows['free_shipping_order']				= "('setup', 'commerce', '무료 배송 주문금액', 'free_shipping_order', '100000', '', '', '', 'width:200px;', '', '', 'text', '<br>주문금액이 설정금액 이상일 경우 무료 배송으로 설정합니다')";
	$options_rows['shipping_cost']						= "('setup', 'commerce', '기본 배송비', 'shipping_cost', '0', '', '', '', 'width:200px;', '', '', 'text', '<br>배송상품(단일 배송비) 모드 사용시 사용할 기본 배송비를 설정합니다')";
	$options_rows['shipping_company']					= "('setup', 'commerce', '기본 배송업체', 'shipping_company', 'CJ대한통운택배', '', '', '', '', '', '', 'commerce_sc_list', '')";		
	//$options_rows['use_escrow']						= "('setup', 'commerce', '에스크로', 'use_escrow', '1', '0,1', '사용안함,사용', '', '', '', '', 'radio', '')";		
	$options_rows['min_use_point']						= "('setup', 'commerce', ' - 최소 사용 포인트', 'min_use_point', '1000', '', '', '', 'width:200px;', '', '', 'text',  '<br>결제에 사용할 수 있는 최소 사용 포인트를 설정합니다')";
	$options_rows['use_point_pay']						= "('setup', 'commerce', '포인트 결제', 'use_point_pay', '1', '0,1', '사용안함,사용', '', '', '', '', 'radio', '<br>결제시 회원 포인트를 사용할 수 있도록 설정합니다')";


	$options_rows['paypal_api_signature']				= "('setup', 'commerce', ' - 페이팔 API Signature', 'paypal_api_signature', '', '', '', '', '', '', '', 'text', '')";
	$options_rows['paypal_api_user_pw']				= "('setup', 'commerce', ' - 페이팔 API Password', 'paypal_api_user_pw', '', '', '', '', '', '', '', 'text', '')";
	$options_rows['paypal_api_user_id']					= "('setup', 'commerce', ' - 페이팔 API Username', 'paypal_api_user_id', '', '', '', '', '', '', '', 'text', '')";
	$options_rows['paypal_identity_token']				= "('setup', 'commerce', ' - 페이팔 ID Token', 'paypal_identity_token', '', '', '', '', '', '', '', 'text', '')";
	$options_rows['paypal_account']						= "('setup', 'commerce', ' - 페이팔 Account ID', 'paypal_account', '', '', '', '', '', '', '', 'text', '<br>페이팔 계정의 ID를 입력합니다')";

	$options_rows['paypal_sandbox_api_signature']	= "('setup', 'commerce', ' - 페이팔 Sandbox API Signature', 'paypal_sandbox_api_signature', '', '', '', '', '', '', '', 'text', '')";
	$options_rows['paypal_sandbox_api_user_pw']		= "('setup', 'commerce', ' - 페이팔 Sandbox API Password', 'paypal_sandbox_api_user_pw', '', '', '', '', '', '', '', 'text', '')";
	$options_rows['paypal_sandbox_api_user_id']		= "('setup', 'commerce', ' - 페이팔 Sandbox API Username', 'paypal_sandbox_api_user_id', '', '', '', '', '', '', '', 'text', '')";
	$options_rows['paypal_sandbox_identity_token']	= "('setup', 'commerce', ' - 페이팔 Sandbox ID Token', 'paypal_sandbox_identity_token', '', '', '', '', '', '', '', 'text', '')";
	$options_rows['paypal_sandbox_account']			= "('setup', 'commerce', ' - 페이팔 Sandbox Account ID', 'paypal_sandbox_account', '', '', '', '', '', '', '', 'text', '')";

	$options_rows['paypal_exchange_rate']				= "('setup', 'commerce', ' - 페이팔 환율', 'paypal_exchange_rate', '1400', '', '', '', '', '', '', 'text', '')";
	$options_rows['paypal_currency_code']				= "('setup', 'commerce', ' - 페이팔 화폐 코드', 'paypal_currency_code', 'USD', '', '', '', '', '', '', 'text', '')";	
	$options_rows['use_paypal']							= "('setup', 'commerce', '페이팔 결제', 'use_paypal', '0', '0,1', '사용안함,사용', '', '', '', '', 'radio', '')";
	/*
	$options_rows['commerce_kakaopay_key']			= "('setup', 'commerce', ' - 카카오페이 Admin KEY', 'commerce_kakaopay_key', '', '', '', '', 'width:300px;', '', '', 'text', '')";
	$options_rows['commerce_kakaopay_cid']			= "('setup', 'commerce', ' - 카카오페이 가맹점 코드', 'commerce_kakaopay_cid', '', '', '', '', 'width:300px;', '', '', 'text', '')";
	$options_rows['use_kakao_pay']							= "('setup', 'commerce', '카카오 페이', 'use_kakao_pay', '0', '0,1', '사용안함,사용', '', '', '', '', 'radio', '')";
	INSERT INTO `mb_options` (`option_load`, `option_category`, `option_title`, `option_name`, `option_value`, `option_data`, `option_label`, `option_class`, `option_style`, `option_event`, `option_attribute`, `option_type`, `option_sequence`, `is_show`, `description`) VALUES
	('setup', 'commerce', ' - 카카오페이 Admin KEY', 'commerce_kakaopay_key', '', '', '', '', 'width:300px;', '', '', 'text', 0, 1, ''),
	('setup', 'commerce', ' - 카카오페이 가맹점 코드', 'commerce_kakaopay_cid', '', '', '', '', 'width:300px;', '', '', 'text', 0, 1, ''),
	('setup', 'commerce', '카카오 페이', 'use_kakao_pay', '0', '0,1', '사용안함,사용', '', '', '', '', 'radio', 0, 1, '');
	*/
	$options_rows['commerce_naver_pay_account_id']	= "('setup', 'commerce', ' - 네이버 공통인증키(Account ID)', 'commerce_naver_pay_account_id', '', '', '', '', 'width:300px;', '', '', 'text', '<br>가맹점 센터(네이버페이 센터) > 내 정보 > 가맹점 가입 정보 > 쇼핑몰 정보')";
	$options_rows['commerce_naver_pay_button_key']	= "('setup', 'commerce', ' - 네이버 페이 Button KEY', 'commerce_naver_pay_button_key', '', '', '', '', 'width:300px;', '', '', 'text', '')";
	$options_rows['commerce_naver_pay_certi_key']	= "('setup', 'commerce', ' - 네이버 페이 KEY', 'commerce_naver_pay_certi_key', '', '', '', '', 'width:300px;', '', '', 'text', '')";
	$options_rows['commerce_naver_pay_mid']			= "('setup', 'commerce', ' - 네이버 페이 상점 ID', 'commerce_naver_pay_mid', '', '', '', '', 'width:300px;', '', '', 'text', '')";
	$options_rows['use_naver_pay']						= "('setup', 'commerce', '네이버 페이 (주문형)', 'use_naver_pay', '0', '0,1,2,3', '사용안함,사용(상품내용),사용(상품내용+장바구니),네이버 검수모드(상품내용+장바구니)', '', '', '', '', 'radio', '<br>네이버 페이는 배송상품에만 사용 가능, 네이버 검수모드 설정시 네이버 검수 진행을 위한 환경이 자동 설정되며 검수모드 아이디(ID: test1234/PW: test1234)로 가입 후 로그인시에만 네이버페이 버튼이 노출됩니다<br>네이버 페이 상품정보 XML URL : ".home_url()."/?mcp=naver&ITEM_ID=XXX&ITEM_ID=XXX')";

	$options_rows['use_bank_cash_receipt']				= "('setup', 'commerce', ' - 현금영수증', 'use_bank_cash_receipt', '0', '0,1', '사용안함,사용', '', '', '', '', 'radio', '<br>무통장입금 주문시 주문 상세보기 페이지에서 현금영수증 신청/발행 기능 (이니시스만 사용가능)')";
	$options_rows['commerce_bank_account']			= "('setup', 'commerce', ' - 계좌정보', 'commerce_bank_account', '00은행: 0000-000-00000 (예금주: 0000)', '', '', '', 'width:300px;', '', '', 'text', '')";
	$options_rows['use_bank_pay']						= "('setup', 'commerce', '무통장입금', 'use_bank_pay', '1', '0,1', '사용안함,사용', '', '', '', '', 'radio', '')";
	$options_rows['use_v_bank_pay']						= "('setup', 'commerce', '가상 계좌', 'use_v_bank_pay', '0', '0,1', '사용안함,사용', '', '', '', '', 'radio', '')";
	$options_rows['use_handphone_pay']				= "('setup', 'commerce', '핸드폰 결제', 'use_handphone_pay', '1', '0,1', '사용안함,사용', '', '', '', '', 'radio', '<br>모바일 환경에서만 사용가능')";
	$options_rows['use_d_bank_pay']						= "('setup', 'commerce', '실시간 계좌이체', 'use_d_bank_pay', '1', '0,1', '사용안함,사용', '', '', '', '', 'radio', '<br>PC 환경에서만 사용가능')";
	$options_rows['use_card_pay']						= "('setup', 'commerce', '카드 결제', 'use_card_pay', '1', '0,1', '사용안함,사용', '', '', '', '', 'radio', '')";	

	$options_rows['commerce_item_type']				= "('setup', 'commerce', '판매상품 타입', 'commerce_item_type', 'all', '', '', '', '', '', '', 'commerce_item_type', '')";
	$options_rows['commerce_pay_platform']			= "('setup', 'commerce', '결제 타입', 'commerce_pay_platform', 'test', 'test,service', '테스트 결제,실제 결제', '', '', '', '', 'radio', '')";
	
	$options_rows['use_inicis_ssgpay']					= "('setup', 'commerce', ' - SSG페이', 'use_inicis_ssgpay', '0', '0,1', '사용안함,사용', '', '', '', '', 'commerce_pg_radio', '')";
	$options_rows['use_inicis_lpay']						= "('setup', 'commerce', ' - L.Pay', 'use_inicis_lpay', '0', '0,1', '사용안함,사용', '', '', '', '', 'commerce_pg_radio', '')";
	$options_rows['use_inicis_payco']						= "('setup', 'commerce', ' - PAYCO', 'use_inicis_payco', '0', '0,1', '사용안함,사용', '', '', '', '', 'commerce_pg_radio', '')";
	$options_rows['use_inicis_samsungpay']				= "('setup', 'commerce', ' - 삼성페이', 'use_inicis_samsungpay', '0', '0,1', '사용안함,사용', '', '', '', '', 'commerce_pg_radio', '')";
	//$options_rows['use_inicis_naverpay']				= "('setup', 'commerce', ' - 네이버페이', 'use_inicis_naverpay', '0', '0,1', '사용안함,사용', '', '', '', '', 'commerce_pg_radio', '')";
	$options_rows['use_inicis_kakaopay']				= "('setup', 'commerce', ' - 카카오페이', 'use_inicis_kakaopay', '0', '0,1', '사용안함,사용', '', '', '', '', 'commerce_pg_radio', '')";
	$options_rows['use_inicis_simple_payment']			= "('setup', 'commerce', '이니시스 간편결제', 'use_inicis_simple_payment', '0', '0,1', '사용안함,사용', '', '', '', '', 'commerce_pg_radio', '<br>별도의 간편결제 가입절차 없이 이니시스를 통해 간편결제 기능 추가<br>신청방법: 이니시스 가맹점(https://iniweb.inicis.com) 로그인>변경/추가>1.서비스 추가 및 변경>지불수단 추가 및 변경>지불수단 추가 및 변경>6.간편결제<br>삼성페이,PAYCO,L.pay,카카오페이,SSG페이 사용으로 설정')";
	
	$options_rows['commerce_pg_nicepay_key2']		= "('setup', 'commerce', ' - Nicepay 결제 인증키', 'commerce_pg_nicepay_key2', '', '', '', '', 'width:300px;', '', '', 'commerce_pg_input', '<br><a href=\"https://www.mangboard.com/pay-key/\" target=\"_blank\">https://www.mangboard.com/pay-key/</a> 주소에서 결제 인증키 발급')";
	$options_rows['commerce_pg_nicepay_password']	= "('setup', 'commerce', ' - Nicepay Password', 'commerce_pg_nicepay_password', '123456', '', '', '', 'width:300px;', '', '', 'commerce_pg_input', '<br>결제 취소 기능을 사용하기 위한 패스워드를 입력합니다(생략가능)')";
	//$options_rows['commerce_pg_nicepay_billkey']		= "('setup', 'commerce', ' - Nicepay 빌링 KEY', 'commerce_pg_nicepay_billkey', '', '', '', '', 'width:300px;', '', '', 'commerce_pg_input', '<br>Nicepay 관리자 사이트>가맹점 정보>가맹점 정보>KEY 관리 페이지에서 암호화 키 복사')";	
	//$options_rows['commerce_pg_nicepay_billing']		= "('setup', 'commerce', ' - Nicepay 빌링 MID', 'commerce_pg_nicepay_billing', '', '', '', '', 'width:300px;', '', '', 'commerce_pg_input', '<br>Nicepay 정기결제 사용시에만 빌링 MID 입력 (정기결제 모듈 추가 설치 필요)')";
	$options_rows['commerce_pg_nicepay_key']		= "('setup', 'commerce', ' - Nicepay 암호화 KEY', 'commerce_pg_nicepay_key', '', '', '', '', 'width:300px;', '', '', 'commerce_pg_input', '<br>Nicepay 관리자 사이트>가맹점 정보>가맹점 정보>KEY 관리 페이지에서 암호화 키 복사')";	
	$options_rows['commerce_pg_nicepay_mid']		= "('setup', 'commerce', ' - Nicepay 상점 MID', 'commerce_pg_nicepay_mid', '', '', '', '', 'width:300px;', '', '', 'commerce_pg_input', '<br>Nicepay 상점 MID를 입력합니다')";
	$options_rows['commerce_pg_lguplus_key']		= "('setup', 'commerce', ' - LG U+ KEY', 'commerce_pg_lguplus_key', '', '', '', '', 'width:300px;', '', '', 'commerce_pg_input', '')";
	$options_rows['commerce_pg_lguplus_mid']		= "('setup', 'commerce', ' - LG U+ 상점 ID', 'commerce_pg_lguplus_mid', '', '', '', '', 'width:300px;', '', '', 'commerce_pg_input', '')";
	$options_rows['commerce_pg_kcp_key']				= "('setup', 'commerce', ' - KCP KEY', 'commerce_pg_kcp_key', '', '', '', '', 'width:300px;', '', '', 'commerce_pg_input', '')";
	$options_rows['commerce_pg_kcp_mid']				= "('setup', 'commerce', ' - KCP 상점 ID', 'commerce_pg_kcp_mid', '', '', '', '', 'width:300px;', '', '', 'commerce_pg_input', '')";
	$options_rows['commerce_pg_inicis_password']	= "('setup', 'commerce', ' - 이니시스 Key Password', 'commerce_pg_inicis_password', '1111', '', '', '', 'width:300px;', '', '', 'commerce_pg_input', '<br>결제 취소 기능을 사용하려면 상점측에 발급된 키파일 안의 readme.txt 파일에 있는 4자리의 키패스워드를 입력합니다 (생략가능)')";

	$options_rows['commerce_pg_inicis_apiiv']		= "('setup', 'commerce', ' - 이니시스 INIAPI IV', 'commerce_pg_inicis_apiiv', '', '', '', '', 'width:300px;', '', '', 'commerce_pg_input', '<br>이니시스 관리자 사이트>상점정보>계약정보>부가정보 페이지에서 INIAPI Key 생성 갱신>IV')";
	$options_rows['commerce_pg_inicis_apikey']		= "('setup', 'commerce', ' - 이니시스 INIAPI Key', 'commerce_pg_inicis_apikey', '', '', '', '', 'width:300px;', '', '', 'commerce_pg_input', '<br>이니시스 관리자 사이트>상점정보>계약정보>부가정보 페이지에서 INIAPI Key 생성 갱신>KEY')";
	$options_rows['commerce_pg_inicis_key']			= "('setup', 'commerce', ' - 이니시스 SignKey', 'commerce_pg_inicis_key', '', '', '', '', 'width:300px;', '', '', 'commerce_pg_input', '<br>이니시스 관리자 사이트>상점정보>계약정보>부가정보 페이지에서 웹결제 signkey 생성')";
	$options_rows['commerce_pg_inicis_mid']			= "('setup', 'commerce', ' - 이니시스 상점 ID', 'commerce_pg_inicis_mid', '', '', '', '', 'width:300px;', '', '', 'commerce_pg_input', '<br>MBD로 시작하는 이니시스 상점 ID를 입력합니다')";
	$options_rows['commerce_pay_pg']					= "('setup', 'commerce', '결제 PG', 'commerce_pay_pg', 'inicis', '', '', '', '', '', '', 'commerce_pay_pg', '')";	
	$options_rows['commerce_cancel_option1']			= "('setup', 'commerce', '환불 신청 이유', 'commerce_cancel_option1', '단순변심,옵션 변경후 재구매,상품불량,상품정보와 상이,배송지연', '', '', '', '', '', '', 'text', '<br>환불 신청시 팝업창에 표시할 항목을 쉼표로 구분해서 입력합니다')";
	$options_rows['commerce_product_view_url']		= "('setup', 'commerce', '상품 정보 페이지', 'commerce_product_view_url', 'm_product_info', '', '', '', '', '', '', 'text', '<br>장바구니 및 주문/배송조회 페이지에서 상품정보 클릭시 이동할 페이지 URL 주소 또는 페이지 SLUG를 입력합니다(생략가능)')";
	$options_rows['commerce_group']					= "('setup', 'commerce', '상품 판매 그룹', 'commerce_group', 'commerce', '', '', '', 'width:300px;', '', '', 'text', '<br>상품 등록 권한을 부여할 회원 그룹명을 입력합니다 (관리자 레벨은 그룹에 상관없이 등록 가능)')";	
	$options_rows['commerce_email']						= "('setup', 'commerce', '주문 관리 이메일', 'commerce_email', '', '', '', '', 'width:300px;', '', '', 'text', '<br>주문 결과를 전송할 관리자 이메일 주소를 입력합니다 (여러개일 경우 쉼표로 구분해서 입력합니다)')";	
	$options_rows['commerce_name']					= "('setup', 'commerce', '쇼핑몰 이름', 'commerce_name', 'MB-COMMERCE', '', '', '', 'width:300px;', '', '', 'text', '<br>쇼핑몰 이름을 입력합니다 (주문 내용 메일 발송시에 사용합니다)')";
	
	mbw_install_add_options($options_rows,$mb_admin_tables["options"]);	

	//커머스 패키지 페이지 추가
	$insert_check		= $wpdb->get_var("SELECT count(*) from ".$wpdb->prefix."posts where post_content like '%[mb_commerce name=\"commerce_cart\" style=\"\"]%'");
	if(empty($insert_check)){
		$insert_page	= array();
		$insert_page[]	= array('post_title' => '상품 등록/관리','post_content' => '[mb_board name="commerce_product" login_page="1" style=""]','post_name' => 'm_product','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '강의 등록/관리','post_content' => '[mb_board name="commerce_lecture" login_page="1" style=""]','post_name' => 'm_lecture','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');

		$insert_page[]	= array('post_title' => '상품 갤러리-M1','post_content' => '[mb_commerce_category name="commerce_product" template="select-basic-1" style="text-align:right;"]
[mb_commerce_category name="commerce_product" template="tab-basic-2" text_color="#888" focus_text_color="#E03030" class="" style="padding-bottom:5px;"]
[mb_commerce_gallery name="commerce_product" title="추천 상품" list_size="4" class="mb-gallery-basic-m1" template="gallery-basic-421" height="260px" tablet_height="280px" mobile_height="290px" style="padding-bottom:20px" use_title="true" use_desc="false" price_type="2"]
[mb_commerce name="commerce_product" responsive_class="col-421" vimg-max-width="500px" vimg-max-height="460px" template="gallery-basic-m1" height="260px" tablet_height="280px" mobile_height="290px" style=""]','post_name' => 'm-product-gallery-m1','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');

		$insert_page[]	= array('post_title' => '상품 갤러리-M2','post_content' => '[mb_commerce_category name="commerce_product" template="select-basic-1" style="text-align:right;"]
[mb_commerce_category name="commerce_product" template="tab-basic-2" text_color="#888" focus_text_color="#E03030" class="" style="padding-bottom:5px;"]
[mb_commerce_gallery name="commerce_product" title="추천 상품" list_size="3" class="mb-gallery-basic-m2" template="gallery-basic-321" height="320px" tablet_height="320px" mobile_height="300px" style="padding-bottom:20px" use_title="true" use_desc="false" price_type="2"]
[mb_commerce name="commerce_product" responsive_class="col-321" vimg-max-width="500px" vimg-max-height="460px" template="gallery-basic-m2" height="320px" tablet_height="320px" mobile_height="300px" style=""]','post_name' => 'm-product-gallery-m2','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '상품 갤러리-M3','post_content' => '[mb_commerce_category name="commerce_product" template="select-basic-1" style="text-align:right;"]
[mb_commerce_category name="commerce_product" template="tab-basic-2" text_color="#888" focus_text_color="#E03030" class="" style="padding-bottom:5px;"]
[mb_commerce_gallery name="commerce_product" title="추천 상품" list_size="4" class="mb-gallery-basic-m3" template="gallery-basic-421" height="200px" tablet_height="210px" mobile_height="220px" style="padding-bottom:20px" use_title="true" use_desc="false" price_type="2"]
[mb_commerce name="commerce_product" responsive_class="col-421" vimg-max-width="500px" vimg-max-height="460px" template="gallery-basic-m3" height="200px" tablet_height="210px" mobile_height="220px" style=""]','post_name' => 'm-product-gallery-m3','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '상품 갤러리-M4','post_content' => '[mb_commerce_category name="commerce_product" template="select-basic-1" style="text-align:right;"]
[mb_commerce_category name="commerce_product" template="tab-basic-2" text_color="#888" focus_text_color="#E03030" class="" style="padding-bottom:5px;"]
[mb_commerce_gallery name="commerce_product" title="추천 상품" list_size="4" class="mb-gallery-basic-m4" template="gallery-basic-421" height="260px" tablet_height="280px" mobile_height="290px" style="padding-bottom:20px" use_title="true" use_desc="false" price_type="2"]
[mb_commerce name="commerce_product" responsive_class="col-421" vimg-max-width="500px" vimg-max-height="460px" template="gallery-basic-m4" height="260px" tablet_height="280px" mobile_height="290px" style=""]','post_name' => 'm-product-gallery-m4','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '상품 갤러리-M5','post_content' => '[mb_commerce_category name="commerce_product" template="select-basic-1" style="text-align:right;"]
[mb_commerce_category name="commerce_product" template="tab-basic-2" text_color="#888" focus_text_color="#E03030" class="" style="padding-bottom:5px;"]
[mb_commerce_gallery name="commerce_product" title="추천 상품" list_size="4" class="mb-gallery-basic-m5" template="gallery-basic-421" height="240px" tablet_height="260px" mobile_height="270px" style="padding-bottom:20px" use_title="true" use_desc="false" price_type="2"]
[mb_commerce name="commerce_product" responsive_class="col-421" vimg-max-width="500px" vimg-max-height="460px" template="gallery-basic-m5" height="240px" tablet_height="260px" mobile_height="270px" style=""]','post_name' => 'm-product-gallery-m5','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '상품 갤러리-M6','post_content' => '[mb_commerce_category name="commerce_product" template="select-basic-1" style="text-align:right;"]
[mb_commerce_category name="commerce_product" template="tab-basic-2" text_color="#888" focus_text_color="#E03030" class="" style="padding-bottom:5px;"]
[mb_commerce_gallery name="commerce_product" title="추천 상품" list_size="4" class="mb-gallery-basic-m6" template="gallery-basic-421" height="240px" tablet_height="260px" mobile_height="270px" style="padding-bottom:20px" use_title="true" use_desc="false" price_type="2"]
[mb_commerce name="commerce_product" responsive_class="col-421" vimg-max-width="500px" vimg-max-height="460px" template="gallery-basic-m6" height="240px" tablet_height="260px" mobile_height="270px" style=""]','post_name' => 'm-product-gallery-m6','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '상품 갤러리-M7','post_content' => '[mb_commerce_category name="commerce_product" template="select-basic-1" style="text-align:right;"]
[mb_commerce_category name="commerce_product" template="tab-basic-2" text_color="#888" focus_text_color="#E03030" class="" style="padding-bottom:5px;"]
[mb_commerce_gallery name="commerce_product" title="추천 상품" list_size="4" class="mb-gallery-basic-m7" template="gallery-basic-421" height="260px" tablet_height="280px" mobile_height="290px" style="padding-bottom:20px" use_title="true" use_desc="false" price_type="2"]
[mb_commerce name="commerce_product" responsive_class="col-421" vimg-max-width="500px" vimg-max-height="460px" template="gallery-basic-m7" height="260px" tablet_height="280px" mobile_height="290px" style=""]','post_name' => 'm-product-gallery-m7','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '상품 갤러리-M8','post_content' => '[mb_commerce_category name="commerce_product" template="select-basic-1" style="text-align:right;"]
[mb_commerce_category name="commerce_product" template="tab-basic-2" text_color="#888" focus_text_color="#E03030" class="" style="padding-bottom:5px;"]
[mb_commerce_gallery name="commerce_product" title="추천 상품" list_size="4" class="mb-gallery-basic-m8" template="gallery-basic-421" height="260px" tablet_height="280px" mobile_height="290px" style="padding-bottom:20px" use_title="true" use_desc="false" price_type="2"]
[mb_commerce name="commerce_product" responsive_class="col-421" vimg-max-width="500px" vimg-max-height="460px" template="gallery-basic-m8" height="260px" tablet_height="280px" mobile_height="290px" style=""]','post_name' => 'm-product-gallery-m8','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');

		$insert_page[]	= array('post_title' => '상품 리스트-M1','post_content' => '[mb_commerce_category name="commerce_product" template="select-basic-1" style="text-align:right;"]
[mb_commerce_category name="commerce_product" template="tab-basic-2" text_color="#888" focus_text_color="#E03030" class="" style="padding-bottom:5px;"]
[mb_commerce_gallery name="commerce_product" title="추천 상품" list_size="4" class="mb-list-basic-m1" template="gallery-basic-421" height="200px" tablet_height="210px" mobile_height="220px" style="padding-bottom:20px" use_title="true" use_desc="false" price_type="2"]
[mb_commerce name="commerce_product" vimg-max-width="500px" vimg-max-height="460px" template="list-basic-m1"]','post_name' => 'm-product-list-m1','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');

		$insert_page[]	= array('post_title' => '강의 리스트-M1','post_content' => '[mb_commerce_category name="commerce_product" product_type="lecture" template="select-basic-1" style="text-align:right;"]
[mb_commerce_category name="commerce_product" product_type="lecture" template="tab-basic-2" text_color="#888" focus_text_color="#E03030" class="" style="padding-bottom:5px;"]
[mb_commerce_gallery name="commerce_product" product_type="lecture" title="추천 강의" list_size="4" template="gallery-basic-421" height="200px" tablet_height="210px" mobile_height="220px" style="padding-bottom:20px" use_title="true" use_desc="false" price_type="2"]
[mb_commerce name="commerce_lecture" vimg-max-width="500px" vimg-max-height="460px" template="list-basic-m1"]','post_name' => 'm-lecture-list-m1','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');

		$insert_page[]	= array('post_title' => '카테고리 템플릿 목록','post_content' => '<p style="padding-top: 30px;">Template : tab-basic-1</p>
[mb_commerce_category name="commerce_product" template="tab-basic-1" text_color="#888" focus_text_color="#fff" focus_bg_color="#000" class="" style="padding-bottom:5px;"]
<p style="padding-top: 30px;">Template : tab-basic-2</p>
[mb_commerce_category name="commerce_product" template="tab-basic-2" text_color="#888" focus_text_color="#E03030" class="" style="padding-bottom:5px;"]
<p style="padding-top: 30px;">Template : tab-basic-3</p>
[mb_commerce_category name="commerce_product" template="tab-basic-3" text_color="#888" focus_text_color="#fff" focus_bg_color="#000" class="" style="padding-bottom:5px;"]
<p style="padding-top: 30px;">Template : tab-basic-4</p>
[mb_commerce_category name="commerce_product" template="tab-basic-4" text_color="#888" focus_text_color="#fff" focus_bg_color="#000" class="" style="padding-bottom:5px;"]
<p style="padding-top: 30px;">Template : tab-basic-5</p>
[mb_commerce_category name="commerce_product" template="tab-basic-5" text_color="#888" focus_text_color="#fff" focus_bg_color="#000" class="" style="padding-bottom:5px;"]
<p style="padding-top: 30px;">Template : tab-basic-6</p>
[mb_commerce_category name="commerce_product" template="tab-basic-6" text_color="#888" focus_text_color="#fff" focus_bg_color="#000" class="" style="padding-bottom:5px;"]
<p style="padding-top: 30px;">Template : tab-basic-7</p>
[mb_commerce_category name="commerce_product" template="tab-basic-7" text_color="#888" focus_text_color="#fff" focus_bg_color="#000" class="" style="padding-bottom:5px;"]
<p style="padding-top: 30px;">Template : tab-basic-8</p>
[mb_commerce_category name="commerce_product" template="tab-basic-8" text_color="#888" focus_text_color="#000" focus_bg_color="#000" class="" style="padding-bottom:5px;"]
<p style="padding-top: 30px;">Template : tab-basic-9</p>
[mb_commerce_category name="commerce_product" template="tab-basic-9" text_color="#888" focus_text_color="#000" focus_bg_color="#fff" class="" style="padding-bottom:5px;"]
<p style="padding-top: 30px;"></p>
[mb_commerce name="commerce_product" responsive_class="col-421" vimg-max-width="500px" vimg-max-height="460px" template="gallery-basic-m1"]','post_name' => 'm-template-list','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');

		$insert_page[]	= array('post_title' => '상품 정보','post_content' => '[mb_commerce name="commerce_product" responsive_class="col-421" vimg-max-width="500px" vimg-max-height="460px" template="gallery-basic-m1" height="260px" tablet_height="280px" mobile_height="290px" style=""]','post_name' => 'm_product_info','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '위시리스트','post_content' => '[mb_board name="commerce_wishlist" login_page="1" style=""]','post_name' => 'm_wishlist','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '장바구니','post_content' => '[mb_commerce name="commerce_cart" style=""]','post_name' => 'm_cart','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '주문/결제','post_content' => '[mb_commerce name="commerce_billing" style=""]','post_name' => 'm_billing','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '주문완료','post_content' => '[mb_commerce name="commerce_order_result" style=""]','post_name' => 'm_order_result','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '주문/배송조회','post_content' => '[mb_board name="commerce_my_order" login_page="1" style=""]','post_name' => 'm_my_order','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '판매/주문조회(판매자용)','post_content' => '[mb_board name="commerce_order" login_page="1" style=""]','post_name' => 'm_order','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '나의 상품 Q&amp;A','post_content' => '[mb_board name="commerce_product_qa" login_page="1" style=""]','post_name' => 'm_product_qa','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '나의 상품 리뷰','post_content' => '[mb_board name="commerce_product_review" login_page="1" style="" where="user_post1"]','post_name' => 'm_product_review','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '상품 리뷰(전체)','post_content' => '[mb_board name="commerce_product_review" style=""]','post_name' => 'm_review_list','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '나의 포인트','post_content' => '[mb_commerce name="commerce_point" login_page="1"]','post_name' => 'm_point','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '나의 쿠폰함','post_content' => '[mb_commerce name="commerce_coupon" login_page="1"]','post_name' => 'm_coupon','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '비회원 주문조회','post_content' => '[mb_commerce name="commerce_order_search" style=""]','post_name' => 'm_order_search','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '이용약관','post_content' => '[mb_commerce name="commerce_terms_service"]','post_name' => 'm_pay_ts','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		$insert_page[]	= array('post_title' => '개인정보 수집동의','post_content' => '[mb_commerce name="commerce_privacy_policy"]','post_name' => 'm_pay_pp','comment_status' =>'closed','ping_status'=>'closed','post_status'=>'publish','post_type'=>'page');
		
		foreach($insert_page as $item){
			wp_insert_post($item);
		}
	}

	$insert_check		= $wpdb->get_var("select count(*) from ".$mb_table_prefix."commerce_product");
	if(empty($insert_check))	{
		//설치시 테스트 상품 추가
		$user_name		= '관리자';
		$user_email		= "";
		$user_pid			= '1';
		$user				= wp_get_current_user();
		if(!empty($user) && !empty($user->data->user_login)){
			if(!empty($user->data->user_login)) $user_pid			= $wpdb->get_var("select pid from `".$mb_table_prefix."users` WHERE user_id='".$user->data->user_login."'");
			if(!empty($user->data->display_name)) $user_name	= $user->data->display_name;
			if(!empty($user->data->user_email)) $user_email		= $user->data->user_email;			
		}
		$reg_date				= date("Y-m-d H:i:s", current_time('timestamp'));
		$lecture_deadline	= date("Y-m-d H:i:s", current_time('timestamp')+(60*60*24*60));
		
		$pid			= intval($wpdb->get_var("select pid from `".$mb_table_prefix."commerce_product` ORDER BY pid DESC limit 1"))+1;
		$query		= "INSERT INTO `".$mb_table_prefix."commerce_product` (`pid`, `gid`, `user_name`, `user_pid`, `user_email`, `passwd`, `reg_date`, `modify_date`, `calendar_date`, `lecture_deadline`, `data_type`, `editor_type`, `stock`, `category1`, `regular_price`, `sale_price`, `product_point`, `template_name`, `product_type`, `title`, `content`, `product_description`, `image_path`) VALUES ";
		$wpdb->query($query."(".$pid.", ".$pid.", '".$user_name."', ".$user_pid.", '".$user_email."', '".$user_pid."', '".$reg_date."', '".$reg_date."', '".$reg_date."', '', 'html', 'S', 9999, '드레스', 10000, 9000, 1000, 'view-basic1', 'shipping', '[드레스] 배송상품1','&lt;p&gt;상품 설명&lt;/p&gt;', '상품 요약 설명', 'https://www.mangboard.com/images/commerce.png');");
		$pid++;
		$wpdb->query($query."(".$pid.", ".$pid.", '".$user_name."', ".$user_pid.", '".$user_email."', '".$user_pid."', '".$reg_date."', '".$reg_date."', '".$reg_date."', '".$lecture_deadline."', 'html', 'S', 20, '기타', 10000, 9000, 1000, 'view-basic1', 'lecture', '[기타] 테스트 강의1','&lt;p&gt;강의 설명&lt;/p&gt;', '강의 요약 설명', 'https://www.mangboard.com/images/commerce.png');");		
		$pid++;
		$wpdb->query($query."(".$pid.", ".$pid.", '".$user_name."', ".$user_pid.", '".$user_email."', '".$user_pid."', '".$reg_date."', '".$reg_date."', '".$reg_date."', '', 'html', 'S', 9999, '기타', 10000, 9000, 1000, 'view-basic1', 'virtual', '[기타] 가상상품1','&lt;p&gt;상품 설명&lt;/p&gt;', '상품 요약 설명', 'https://www.mangboard.com/images/commerce.png');");
		$pid++;
		$wpdb->query($query."(".$pid.", ".$pid.", '".$user_name."', ".$user_pid.", '".$user_email."', '".$user_pid."', '".$reg_date."', '".$reg_date."', '".$reg_date."', '', 'html', 'S', 9999, '아우터', 10000, 9000, 1000, 'view-basic1', 'shipping', '[아우터] 배송상품2','&lt;p&gt;상품 설명&lt;/p&gt;', '상품 요약 설명', 'https://www.mangboard.com/images/commerce.png');");
	}
}
?>