<?php
define("MBW_COMMERCE_PATH", MBW_PLUGIN_PATH."plugins/commerce/");
define("MBW_COMMERCE_URL", MBW_PLUGIN_URL."plugins/commerce/");
if(is_file(MBW_PLUGIN_PATH."includes/languages/mb-commerce-".mbw_get_option("locale").".php")){
	require(MBW_PLUGIN_PATH."includes/languages/mb-commerce-".mbw_get_option("locale").".php");
}else if(is_file(MBW_PLUGIN_PATH."includes/languages/mb-commerce.php")){
	require(MBW_PLUGIN_PATH."includes/languages/mb-commerce.php");
}
require(MBW_COMMERCE_PATH."includes/commerce-config.php");
require(MBW_COMMERCE_PATH."includes/func.commerce.php");
require(MBW_COMMERCE_PATH."includes/commerce-fields.php");
require(MBW_COMMERCE_PATH."includes/commerce-options.php");
require(MBW_COMMERCE_PATH."includes/commerce-filters.php");
require(MBW_COMMERCE_PATH."includes/commerce-actions.php");

if(!function_exists('mb_init_script_commerce')){
	function mb_init_script_commerce(){
		loadScript(MBW_PLUGIN_URL."plugins/commerce/js/main.js");
		loadStyle(mbw_get_template_url("commerce/css/main","theme","css"));
		global $mb_scripts; 
		$mb_scripts[]		= mbw_init_commerce_javascript();	
	}
}
if(!function_exists('mbw_init_commerce_javascript')){
	function mbw_init_commerce_javascript(){
		$script		= "";
		$script		= $script.'<script type="text/javascript">';
		$script		= $script.'mb_urls["commerce_cart"]					= "'.mbw_check_permalink(mbw_get_option("post_cart")).'";';
		$script		= $script.'mb_urls["commerce_wishlist"]				= "'.mbw_check_permalink(mbw_get_option("post_wishlist")).'";';
		$script		= $script.'mb_urls["commerce_order"]				= "'.mbw_check_permalink(mbw_get_option("post_order")).'";';
		$script		= $script.'mb_urls["commerce_billing"]				= "'.mbw_check_permalink(mbw_get_option("post_billing")).'";';
		$script		= $script.'mb_urls["commerce_order_result"]		= "'.mbw_check_permalink(mbw_get_option("post_order_result")).'";';
		$script		= $script.'mb_urls["commerce_order_search"]		= "'.mbw_check_permalink(mbw_get_option("post_order_search")).'";';
		$script		= $script.'mb_urls["commerce_point"]				= "'.mbw_check_permalink(mbw_get_option("post_point")).'";';
		$script		= $script.'mb_urls["commerce_product"]				= "'.mbw_check_permalink(mbw_get_option("post_product")).'";';
		$script		= $script.'mb_urls["commerce_product_info"]		= "'.mbw_check_permalink(mbw_get_option("post_product_info")).'";';
		$script		= $script.'mb_urls["commerce_lecture"]				= "'.mbw_check_permalink(mbw_get_option("post_lecture")).'";';
		$script		= $script.'mb_urls["commerce_product_qa"]			= "'.mbw_check_permalink(mbw_get_option("post_product_qa")).'";';
		$script		= $script.'mb_urls["commerce_product_review"]	= "'.mbw_check_permalink(mbw_get_option("post_product_review")).'";';
		$script		= $script.'</script>';
		return $script;
	}
}

add_action('wp_enqueue_scripts', 'mb_init_script_commerce',2);
add_action('admin_enqueue_scripts', 'mb_init_script_commerce',2);

add_filter('query_vars','mbw_commerce_add_trigger',10,1);
if(!function_exists('mbw_commerce_add_trigger')){	
	function mbw_commerce_add_trigger($vars) {
		$vars[] = 'mb_commerce';
		return $vars;
	}
}
add_action('template_redirect', 'mbw_commerce_trigger_check');
if(!function_exists('mbw_commerce_trigger_check')){	
	function mbw_commerce_trigger_check() {
		if(get_query_var('mb_commerce')=="ep_naver" || get_query_var('mb_commerce')=="ep_daum") {
			if(is_file(MBW_COMMERCE_PATH."includes/commerce-ep.php"))
				require(MBW_COMMERCE_PATH."includes/commerce-ep.php");
			exit;
		}else if(get_query_var('mb_commerce')=="cash_receipt" || get_query_var('mb_commerce')=="cash_receipt_result") {
			if(is_file(MBW_COMMERCE_PATH."includes/commerce-cash-receipt.php"))
				require(MBW_COMMERCE_PATH."includes/commerce-cash-receipt.php");
			exit;
		}
	}
}

// 관리자 메뉴설정
if(!function_exists('mbw_create_commerce_menu')){
	function mbw_create_commerce_menu(){
		$index		= 32;
		while(!empty($GLOBALS['menu'][$index])) $index++;
		add_menu_page('쇼핑몰 관리', '쇼핑몰 관리', 'administrator', 'mbw_commerce_dashboard', 'mbw_manage_page', plugins_url('mangboard/assets/images/favicon.png'), $index);
		add_submenu_page('mbw_commerce_dashboard', __MW('W_MENU_DASHBOARD'), __MW('W_MENU_DASHBOARD'), 'administrator', 'mbw_commerce_dashboard', 'mbw_manage_page');
		add_submenu_page('mbw_commerce_dashboard', __MW("W_MENU_COMMERCE_PRODUCT"), __MW("W_MENU_COMMERCE_PRODUCT"), 'administrator', 'mbw_commerce_product', 'mbw_manage_board');
		add_submenu_page('mbw_commerce_dashboard', __MW("W_MENU_COMMERCE_LECTURE"), __MW("W_MENU_COMMERCE_LECTURE"), 'administrator', 'mbw_commerce_lecture', 'mbw_manage_board');
		add_submenu_page('mbw_commerce_dashboard', __MW("W_MENU_COMMERCE_PRODUCT_CATEGORY"), __MW("W_MENU_COMMERCE_PRODUCT_CATEGORY"), 'administrator', 'mbw_commerce_category', 'mbw_manage_page');
		add_submenu_page('mbw_commerce_dashboard', __MW("W_MENU_COMMERCE_USER"), __MW("W_MENU_COMMERCE_USER"), 'administrator', 'mbw_commerce_users', 'mbw_manage_board');	
		add_submenu_page('mbw_commerce_dashboard', __MW("W_MENU_COMMERCE_MAIL"), __MW("W_MENU_COMMERCE_MAIL"), 'administrator', 'mbw_commerce_email', 'mbw_manage_board');	
		add_submenu_page('mbw_commerce_dashboard', __MW("W_MENU_COMMERCE_COUPON"), __MW("W_MENU_COMMERCE_COUPON"), 'administrator', 'mbw_commerce_coupon', 'mbw_manage_board');
		add_submenu_page('mbw_commerce_dashboard', __MW("W_MENU_COMMERCE_POINT"), __MW("W_MENU_COMMERCE_POINT"), 'administrator', 'mbw_commerce_point', 'mbw_manage_board');	
		add_submenu_page('mbw_commerce_dashboard', __MW("W_MENU_COMMERCE_QA"), __MW("W_MENU_COMMERCE_QA"), 'administrator', 'mbw_commerce_product_qa', 'mbw_manage_board');
		add_submenu_page('mbw_commerce_dashboard', __MW("W_MENU_COMMERCE_REVIEW"), __MW("W_MENU_COMMERCE_REVIEW"), 'administrator', 'mbw_commerce_product_review', 'mbw_manage_board');	
		add_submenu_page('mbw_commerce_dashboard', __MW("W_MENU_COMMERCE_SHIPPING"), __MW("W_MENU_COMMERCE_SHIPPING"), 'administrator', 'mbw_commerce_info', 'mbw_manage_board');		
		$index++;
		add_menu_page('주문 관리', '주문 관리', 'administrator', 'mbw_order_dashboard', 'mbw_manage_page', plugins_url('mangboard/assets/images/favicon.png'), $index);
		add_submenu_page('mbw_order_dashboard', __MW('W_MENU_DASHBOARD'), __MW('W_MENU_DASHBOARD'), 'administrator', 'mbw_order_dashboard', 'mbw_manage_page');
		add_submenu_page('mbw_order_dashboard', __MW("W_MENU_COMMERCE_ORDER"), __MW("W_MENU_COMMERCE_ORDER"), 'administrator', 'mbw_commerce_order', 'mbw_manage_board');
		add_submenu_page('mbw_order_dashboard', __MW("W_MENU_COMMERCE_SALES_TABLE"), __MW("W_MENU_COMMERCE_SALES_TABLE"), 'administrator', 'mbw_commerce_sales_table', 'mbw_manage_board');	
		add_submenu_page('mbw_order_dashboard', __MW("W_MENU_COMMERCE_CART"), __MW("W_MENU_COMMERCE_CART"), 'administrator', 'mbw_commerce_cart', 'mbw_manage_board');		
	}
}
add_action('admin_menu', 'mbw_create_commerce_menu',32);


if(!function_exists('mbw_filter_check_commerce_table')){
	function mbw_filter_check_commerce_table($name){
		global $mb_table_prefix,$mb_commerce_tables;

		if(in_array($mb_table_prefix.$name, $mb_commerce_tables)!==false || in_array($name, $mb_commerce_tables)!==false){
			return "commerce";
		}else{
			return "";
		}
	}
}
add_filter('mf_check_table_type', 'mbw_filter_check_commerce_table',5,1); 

if(!function_exists('mbw_check_commerce_cart')){
	function mbw_check_commerce_cart(){
		global $mdb;
		global $mb_commerce_tables,$mb_fields;

		//비로그인 장바구니 데이타를 회원 장바구니로 변경하기
		if(!empty($_COOKIE["mb_cart_id"]) && (strpos($_COOKIE["mb_cart_id"],"_U")===false)){
			$cart_id1			= $_COOKIE["mb_cart_id"];
			unset($_COOKIE["mb_cart_id"]);
			$cart_id2			= mbw_get_cart_id();
			$mdb->query("UPDATE ".$mb_commerce_tables["commerce_cart"]." SET ".$mb_fields["commerce_cart"]["fn_cart_id"]."='".$cart_id2."', ".$mb_fields["commerce_cart"]["fn_user_pid"]."='".mbw_get_user("fn_pid")."', ".$mb_fields["commerce_cart"]["fn_user_name"]."='".mbw_get_user("fn_user_name")."' WHERE ".$mb_fields["commerce_cart"]["fn_cart_id"]."='".$cart_id1."'");
		}
	}
}
add_action('mbw_user_login', 'mbw_check_commerce_cart');

if(!function_exists('mbw_unset_commerce_cart')){
	function mbw_unset_commerce_cart(){	
		if(isset($_COOKIE["mb_cart_id"])) mbw_clear_auth_cookie("mb_cart_id");
	}
}
add_action('mbw_user_logout', 'mbw_unset_commerce_cart');
add_action('wp_logout', 'mbw_unset_commerce_cart');

//Shortcode Action 등록
if(!function_exists('mbw_shortcode_commerce_panel')){
	function mbw_shortcode_commerce_panel($content){
		$mb_shortcode		= "mb_commerce";	
		if(strpos($content, '['.$mb_shortcode." name=") !== false){
			$index1		= strpos($content,'['.$mb_shortcode." name=")+19;
			$name		= substr($content,$index1,strpos($content,"\"",$index1)-$index1);
			if(!empty($name)) mbw_init_commerce_panel($name);
			if($name=="commerce_billing" || $name=="commerce_order_result"){
				mbw_commerce_session_start();
			}
		}
	}
}
add_shortcode("mb_commerce", 'mbw_create_commerce_panel');	
add_action('mbw_shortcode', 'mbw_shortcode_commerce_panel',5); 

if(!function_exists('mbw_init_commerce_panel')){
	function mbw_init_commerce_panel($name){
		global $mb_board_name;
		mbw_set_vars("shortcode","commerce");

		if(!empty($_GET['type'])) $name		= $_GET['type'];
		$name	= mbw_value_filter($name,"name");
			
		if($name=="commerce_cart" || $name=="commerce_billing" || $name=="commerce_order_result"){
			mbw_get_nocache_header();
			add_action('wp_head', 'mbw_get_nocache_meta',0);
		}else if($name=="commerce_privacy_policy" || $name=="commerce_terms_service"){
			$name	= "commerce_product";
		}
		
		if($name=="commerce_billing") mbw_load_postcode_script("daum");
		if(!empty($name)){
			$mb_board_name		= $name;	
			mbw_init_board($mb_board_name);
		}
	}
}

if(!function_exists('mbw_create_commerce_panel')){
	function mbw_create_commerce_panel($args, $content=""){	
		if(mbw_get_request_mode()=="API") return;
		else if(mbw_get_trace("mbw_create_commerce_panel")!="" && mbw_get_param("mode")=="view") return;
		global $mdb,$mstore,$mb_fields,$mb_api_urls,$billing_html;
		global $mb_admin_tables,$mb_board_table_name,$mb_comment_table_name;
		global $mb_vars,$mb_board_name,$mb_words,$mb_languages;

		mbw_add_trace("mbw_create_commerce_panel");
		mbw_set_vars("shortcode_args",$args);

		if(empty($args['echo'])) ob_start();
		echo '<div class="clear"></div>';
		if(!empty($content)) $args["content"]		= $content;
		if(!isset($args['name'])){
			mbw_error_message("MSG_SEARCH_ERROR2", "ShortCode","1000");
		}else{
			mbw_set_board_params($args);
			mbw_is_permission_level();
		}
		if(mbw_get_result_data("state")=="error"){
			echo mbw_echo_error_message();
			if(empty($args['echo'])) return ob_get_clean();
			else return;
		}

		$mb_user_level		= mbw_get_user("fn_user_level");
		
		if(mbw_get_param("mode")==""){
			if(!empty($args['mode'])) mbw_set_param("mode", mbw_value_filter($args['mode']));
			else mbw_set_param("mode", "list");
			if(!empty($args['board_action'])) mbw_set_param("board_action", mbw_value_filter($args['board_action']));
			else if(!empty($args['action'])) mbw_set_param("board_action", mbw_value_filter($args['action']));
			if(!empty($args['board_pid'])) mbw_set_param("board_pid", mbw_value_filter($args['board_pid']));			
		}
		if(mbw_get_param("mode")=="") mbw_set_param("mode", "list");
		if(mbw_get_param("mode")=="list"){
			if(mbw_get_param("product_type")!=""){
				mbw_set_board_where(array("field"=>"fn_product_type", "value"=>mbw_get_param("product_type")));
			}else{
				if(!empty($args['product_type'])) mbw_set_board_where(array("field"=>"fn_product_type", "value"=>mbw_value_filter($args['product_type'])));
			}
		}
		if(!isset($_GET["category1"]) && mbw_get_param("category1")==""){
			if(!empty($args['category1'])) mbw_set_param("category1", $args['category1']);
			if(!empty($args['category2'])) mbw_set_param("category2", $args['category2']);
			if(!empty($args['category3'])) mbw_set_param("category3", $args['category3']);
			mbw_set_category_params();
		}
		if(!empty($args['search_field'])){
			if(function_exists('mbw_set_search_field')) mbw_set_search_field($args);
		}
		if(mbw_get_param("tpl_name")==""){
			if(!empty($args['tpl_name'])) mbw_set_param("tpl_name", mbw_value_filter($args['tpl_name']));
		}
		if(mbw_get_param("template")==""){
			if(!empty($args['template'])) mbw_set_param("template", mbw_value_filter($args['template']));
		}

		$board_mode			= mbw_value_filter(mbw_get_param("mode"));

		if(!empty($_GET['type'])) $name		= $_GET['type'];
		else if(!empty($args['name']))		$name		= $args['name'];
		else $name		= "";
		$name			= mbw_value_filter($name);

		if(empty($mb_board_name) && !empty($name)) $mb_board_name		= $name;
		if(empty($mb_board_table_name) && !empty($mb_board_name)) $mb_board_table_name		= mbw_get_board_table_name($mb_board_name);

		$board_class	= "";
		if(function_exists('mbw_get_board_class')) $board_class	= mbw_get_board_class();

		if(empty($args['style'])) $board_style			= "";
		else $board_style			= ' style="'.str_replace('"',"'",esc_attr($args['style'])).'"';

		$device_type			= mbw_get_vars("device_type");
		$class_array			= array();
		if(!empty($args[$device_type.'_'.$board_mode.'_class'])){
			$class_array[]		= mbw_value_filter(trim($args[$device_type.'_'.$board_mode.'_class']),"class");
		}
		if(!empty($args[$device_type.'_class'])){
			$class_array[]		= mbw_value_filter(trim($args[$device_type.'_class']),"class");
		}
		if(!empty($args[$board_mode.'_class'])){
			$class_array[]		= mbw_value_filter(trim($args[$board_mode.'_class']),"class");
		}
		if(!empty($args['class'])){
			$class_array[]		= mbw_value_filter(trim($args['class']),"class");
		}
		if(!empty($_REQUEST["template_class"])){
			$t_class			= str_replace(","," ",$_REQUEST["template_class"]);
			$class_array[]		= mbw_value_filter(trim($t_class),"class");
		}
		if(!empty($class_array)){
			$template_class		= implode(" ", $class_array);
		}else{
			$template_class		= "";
		}
		mbw_set_vars("template_class",$template_class);

		echo '<div id="mb_top" class="mb-'.esc_attr($device_type).'">';
		echo '<div class="mb-board mb-commerce"'.$board_style.'>';
		echo '<div class="'.esc_attr($board_class).'">';
		if(!empty($template_class)){
			echo '<div class="'.esc_attr($template_class).'">';
		}

		require(MBW_COMMERCE_PATH."_header.php");
		do_action('mbw_commerce_header');
		echo mbw_get_board_option("fn_board_header");
		
		if($name=="commerce_cart"){
			if(mbw_get_param("product_pid")!=""){
				echo '<script type="text/javascript">addCartMove('.esc_js(mbw_get_param("product_pid")).');</script>';
			}else{
				require(MBW_COMMERCE_PATH."commerce-cart.php");
			}
		}else if($name=="commerce_billing"){
			if(mbw_get_param("product_pid")!=""){
				echo '<script type="text/javascript">addCheckout("direct",'.esc_js(mbw_get_param("product_pid")).',1);</script>';
			}else{
				require(MBW_COMMERCE_PATH."commerce-order-billing.php");
			}
		}else if($name=="commerce_point"){
			require(MBW_COMMERCE_PATH."commerce-point-list.php");
		}else if($name=="commerce_coupon"){
			require(MBW_COMMERCE_PATH."commerce-coupon-list.php");
		}else if($name=="commerce_order_search"){
			require(MBW_COMMERCE_PATH."commerce-order-search.php");
			
		}else if($name=="commerce_order_result"){
			require(MBW_COMMERCE_PATH."commerce-order-result.php");
		}else if($name=="commerce_privacy_policy"){
			require(MBW_COMMERCE_PATH."commerce-privacy-policy.php");
		}else if($name=="commerce_terms_service"){
			require(MBW_COMMERCE_PATH."commerce-terms-service.php");
		}else if($name=="commerce_product" || $name=="commerce_lecture" || strpos($name,'commerce_')===0 ){
			if($board_mode=="view"){
				require(MBW_COMMERCE_PATH."commerce-product-view.php");
			}else if($board_mode=="list") {
				require(MBW_COMMERCE_PATH."commerce-product-list.php");
			}else if($board_mode=="write") {
				$MangBoard		= new MangBoard($mdb,$mstore);
				$MangBoard->get_board_panel($args);
			}else if(!empty($args['template'])) {
				$template_path				= mbw_get_template_path("commerce/product-".$board_mode."/".mbw_value_filter($args['template']),"theme");
				if(!empty($template_path)) require($template_path);
			}
		}
		require(MBW_COMMERCE_PATH."_footer.php");
		do_action('mbw_commerce_footer');
		echo mbw_get_board_option("fn_board_footer");

		if(!empty($template_class)){
			echo '</div>';
		}
		echo '</div></div></div>';
		echo '<div style="display:none !important;" class="mb-poweredby"><!-- 워드프레스 쇼핑몰 - 망보드 --><a href="https://www.mangboard.com" target="_blank" style="font-size:13px;" title="Powered by MangBoard">Powered by MangBoard</a> | <a href="https://www.mangboard.com/store/" target="_blank" style="font-size:13px;" title="워드프레스 쇼핑몰 망보드">워드프레스 쇼핑몰 망보드</a></div>';
		if(empty($args['echo'])) return ob_get_clean();
	}
}
?>