<?php
if(!function_exists('mbw_get_cart_id')){
	function mbw_get_cart_id(){
		global $mstore;

		if(mbw_get_cookie("mb_cart_id")==""){
			$cart_id		= date("Ymd",mbw_get_timestamp());
			if(mbw_is_login()){
				$cart_id		= $cart_id."_U".mbw_get_user("fn_pid");
			}else{
				$cart_id		= $cart_id."_T".substr(mbw_get_timestamp(),-6);
			}
			$cart_id		= $cart_id."_".wp_generate_password(24,false);
			@mbw_set_cookie("mb_cart_id",$cart_id);
		}else{
			$cart_id			= mbw_get_cookie("mb_cart_id");
		}		
		return $cart_id;
	}
}
if(!function_exists('mbw_get_billing_id')){
	function mbw_get_billing_id($pid){
		$pid				= intval($pid);
		$time_format		= "Ymd-His";
		if($pid>100000){
			$pid				= $pid % 100000;
			$time_format		= "Ymd-Hi";
		}
		$billing_id		= date($time_format,mbw_get_timestamp()).strval($pid);
		return $billing_id;
	}
}
if(!function_exists('mbw_commerce_session_start')){
	function mbw_commerce_session_start(){
		$result	= true;
		if(mbw_get_trace("mbw_commerce_session_start")==""){
			mbw_add_trace("mbw_commerce_session_start");
			$session	= @session_id();
			if(empty($session)){
				if(mbw_get_option("use_card_pay")==1){
					if(mbw_get_option("ssl_mode") || strpos(MBW_HOME_URL,'https')===0) $secure		= is_ssl();
					else $secure = false;
					if($secure){
						$http_user_agent		= "";
						if(!empty($_SERVER['HTTP_USER_AGENT'])) $http_user_agent		= $_SERVER['HTTP_USER_AGENT'];
						if(!preg_match('/(iPhone|iPad|iPod)/i', $http_user_agent)){
							if(version_compare(PHP_VERSION, '7.3.0', '<')){
								@session_set_cookie_params(0, '/; samesite=None', "", true, true);
							}else{
								@session_set_cookie_params(['secure'=>true,'httponly'=>true,'samesite'=>'None']);
							}
						}
					}
				}
				$result	= @session_start();
			}
		}
		return $result;
	}
}
if(!function_exists('mbw_is_product_order')){
	function mbw_is_product_order($pid,$order_count=array(1),$data=array()){	
		//제품의 상태, 재고 정보를 가져와서 판매가 가능한지 여부 체크
		global $mb_fields,$mstore,$mdb,$mb_admin_tables,$mb_commerce_tables;

		//재고옵션을 포함한 주문시 옵션 상품에 대한 재고 체크
		$check_product_options		= mbw_get_param("check_product_options");
		if(!empty($check_product_options)){
			$error_data			= array();
			$query_data		= array();
			$error_message	= "";
			$fields				= $mb_fields["meta"];

			foreach($check_product_options as $value){
				$option_data			= explode("___",$value);
				$query					= $mdb->prepare("SELECT ".$fields["fn_meta_value"]." FROM " . $mb_admin_tables["meta"]. " WHERE ".$fields["fn_meta_pid"]."=%d and ".$fields["fn_meta_key"]."=%s and ".$fields["fn_meta_table"]."='commerce_product_op02_count' limit 1;",$option_data[2],$option_data[3]);
				$count					= intval($mdb->get_var($query));
				if(intval($option_data[4])>$count){
					$error_data[]		= $option_data[1]." (주문가능 ".$count."개)";
				}else{
					$query_data[]	= $mdb->prepare("UPDATE ".$mb_admin_tables["meta"]." set ".$fields["fn_meta_value"]."=".($count-intval($option_data[4]))." WHERE ".$fields["fn_meta_pid"]."=%d and ".$fields["fn_meta_key"]."=%s and ".$fields["fn_meta_table"]."='commerce_product_op02_count' limit 1;",$option_data[2],$option_data[3]);
				}
			}
			if(!empty($error_data)){
				$error_message		= implode(",",$error_data);
				mbw_error_message("MSG_COMMERCE_PRODUCT_SHORTAGE_STOCK2", '"'.$error_message.'"<br>',"");
				return false;
			}else{
				mbw_set_vars("op02_update_query",$query_data);
			}
		}else if(mbw_get_param("product_required_options")!="" || mbw_get_param("product_required_options2")!=""){

			if(mbw_get_param("product_required_options")!=""){
				$product_required_options					= mbw_get_param("product_required_options");		
				$product_required_options_count		= mbw_get_param("product_required_options_count");
			}else if(mbw_get_param("product_required_options2")!=""){
				$product_required_options					= mbw_get_param("product_required_options2");		
				$product_required_options_count		= mbw_get_param("product_required_options_count2");
			}

			$error_data			= array();
			$error_message		= "";
			$fields					= $mb_fields["meta"];
			$index					= 0;
			$product_pid			= mbw_get_param("board_pid");
			if(!empty($product_pid) && !empty($data) && $data["product_options_type"]=="mc-op02"){
				foreach($product_required_options as $value){
					$option_data			= explode("||",$value);
					$query					= $mdb->prepare("SELECT ".$fields["fn_meta_value"]." FROM " . $mb_admin_tables["meta"]. " WHERE ".$fields["fn_meta_pid"]."=%d and ".$fields["fn_meta_key"]."=%s and ".$fields["fn_meta_table"]."='commerce_product_op02_count' limit 1;",$product_pid,$option_data[2]);
					$count					= intval($mdb->get_var($query));
					if(!empty($product_required_options_count[$index])){
						$options_count			= $product_required_options_count[$index];
						if(intval($options_count)>$count){
							$error_data[]		= $option_data[0]." (주문가능 ".$count."개)";
						}
					}					
					$index++;
				}
				if(!empty($error_data)){
					$error_message		= implode(",",$error_data);
					mbw_error_message("MSG_COMMERCE_PRODUCT_SHORTAGE_STOCK2", '"'.$error_message.'"<br>',"");
					return false;
				}
			}
		}
		
		$item_field						= $mb_fields["commerce_product"];
		$is_check						= true;
		
		if(!empty($data)){
			$product_items				= array();
			$product_items[]				= $data;
		}else{
			if(is_array($pid)){
				$select_query				= mbw_get_add_query(array("column"=>"*","join"=>"none","table"=>$mb_commerce_tables["commerce_product"]));
				$select_query				= $select_query." where ".$item_field["fn_pid"]." in (".implode(",",$pid).") order by FIELD(pid,".implode(",",$pid).");";
			}else if(is_string($pid)){
				$select_query				= mbw_get_add_query(array("column"=>"*","join"=>"none","table"=>$mb_commerce_tables["commerce_product"]), array(array("field"=>"fn_pid","value"=>$pid)))." limit 1";
			}
			$product_items				= $mdb->get_results($select_query,ARRAY_A);
		}
		$index		= 0;

		foreach($product_items as $product){
			$sale_status		= intval($product[$item_field["fn_sale_status"]]);
			if(($sale_status!=1 && $sale_status!=6) || ($sale_status==6 && !mbw_is_login())){
				$is_check		= false;
				mbw_error_message("MSG_COMMERCE_PRODUCT_STOP_SALE", '"'.$product[$item_field["fn_title"]].'"<br>',"");
				break;
			}else if(strpos($product[$item_field["fn_product_type"]],"lecture")===0){
				if($product[$item_field["fn_lecture_deadline"]]!="" && $product[$item_field["fn_lecture_deadline"]]<mbw_get_current_date()){
					$is_check		= false;
					mbw_error_message("MSG_COMMERCE_LECTURE_SOLD_OUT", '"'.$product[$item_field["fn_title"]].'"<br>',"");
					break;
				}else if(intval($product[$item_field["fn_sale_count"]])>=intval($product[$item_field["fn_stock"]])){
					$is_check		= false;
					mbw_error_message("MSG_COMMERCE_LECTURE_SOLD_OUT", '"'.$product[$item_field["fn_title"]].'"<br>',"");
					break;
				}else if((intval($product[$item_field["fn_sale_count"]])+intval($order_count[$index]))>intval($product[$item_field["fn_stock"]])){
					$is_check		= false;
					mbw_error_message("MSG_COMMERCE_PRODUCT_SHORTAGE_STOCK2", '"'.$product[$item_field["fn_title"]].'"<br>',"");
					break;
				}				
			}else {
				if(intval($product[$item_field["fn_stock"]])==0){
					$is_check		= false;
					mbw_error_message("MSG_COMMERCE_PRODUCT_SOLD_OUT", '"'.$product[$item_field["fn_title"]].'"<br>',"");
					break;
				}else if(intval($product[$item_field["fn_stock"]])<intval($order_count[$index])){
					$is_check		= false;
					mbw_error_message("MSG_COMMERCE_PRODUCT_SHORTAGE_STOCK", '"'.$product[$item_field["fn_title"]].'"<br>',"");
					break;
				}
			}
			$index++;
		}
		
		if($is_check) return true;
		else return false;
	}
}
if(!function_exists('mbw_update_order_product_data')){
	function mbw_update_order_product_data($type,$order_pid){
		global $mdb,$mb_commerce_tables,$mb_fields;
		if($type=='cancel'){
			//사용자 주문 취소시 상품 판매개수(sale_count)를 주문한 개수만큼 감소 시키기
			$select_query		= $mdb->prepare("select * from `".$mb_commerce_tables["commerce_order"]."` where `".$mb_fields["commerce_order"]["fn_pid"]."`=%d", $order_pid);
			$order_item			= $mdb->get_row($select_query,ARRAY_A);
			if(!empty($order_item)){
				$order_products		= maybe_unserialize($order_item[$mb_fields["commerce_order"]["fn_order_products"]]);
				foreach($order_products as $product){
					$mdb->query($mdb->prepare("UPDATE ".$mb_commerce_tables["commerce_product"]." set ".$mb_fields["commerce_product"]["fn_sale_count"]."=".$mb_fields["commerce_product"]["fn_sale_count"]."-%d where ".$mb_fields["commerce_product"]["fn_pid"]."=%d", $product[$mb_fields["commerce_cart"]["fn_order_count"]],$product[$mb_fields["commerce_cart"]["fn_product_pid"]]));
				}
				$coupon_pid		= $order_item[$mb_fields["commerce_order"]["fn_coupon_pid"]];
				if(!empty($coupon_pid)){					
					$mdb->query($mdb->prepare("update ".$mb_commerce_tables["commerce_coupon"]." set ".$mb_fields["commerce_coupon"]["fn_is_use"]."=0 where ".$mb_fields["commerce_coupon"]["fn_pid"]."=%d",$coupon_pid));
				}
			}
		}
	}
}
if(!function_exists('mbw_get_product_view_url')){
	function mbw_get_product_view_url($mode=""){
		global $mdb,$mb_admin_tables,$mb_fields;
		$product_url		= "";
		$board_name	= mbw_get_board_name();
		if(strpos($board_name,"commerce_product_")===0 || strpos($board_name,"commerce_lecture_")===0){
			$board_name		= "link_".$board_name;
		}
		if($mode=="product_view"){
			$product_url		= mbw_get_option("commerce_product_view_url");
			if(strpos($product_url, 'http') !== 0 && mbw_check_permalink($product_url)!="") $product_url		= mbw_check_permalink($product_url);
		}else if(mbw_get_board_item('fn_pid')!="" && (strpos($board_name,"commerce_product")===0 || strpos($board_name,"commerce_lecture")===0)){
			$product_url		= mbw_get_url(array('vid'=>mbw_get_board_item('fn_pid')),"","");						
		}else if(mbw_get_option("commerce_product_view_url")!=""){
			$product_url		= mbw_get_option("commerce_product_view_url");
			if(strpos($product_url, 'http') !== 0 && mbw_check_permalink($product_url)!="") $product_url		= mbw_check_permalink($product_url);
		}else{
			$product_url		= mbw_check_permalink(mbw_get_option("post_product_info"));
		}
		return $product_url;
	}
}

if(!function_exists('mbw_get_product_status')){
	function mbw_get_product_status($type,$item=array()){
		global $mb_fields;
		$fields			= $mb_fields["commerce_product"];
		if(empty($item)){
			$product_item		= mbw_get_board_item();
		}else{
			$product_item		= $item;
		}
		if(empty($product_item)) return 0;
		if(!isset($product_item[$fields['fn_stock']])) return 1;
		$lecture_deadline	= $product_item[$fields['fn_lecture_deadline']];
		if($lecture_deadline=="0000-00-00 00:00:00") $lecture_deadline	= "";
		$sale_count			= intval($product_item[$fields['fn_sale_count']]);
		$stock					= intval($product_item[$fields['fn_stock']]);
		$sale_status			= $product_item[$fields['fn_sale_status']];

		if($sale_status=="") return 0;
		$status			= intval($sale_status);
		if($status==1 || ($status==6 && mbw_is_login())){
			if(!empty($lecture_deadline)){
				$end_status		= 4;
				if(strpos($type,"lecture")===0){ $end_status		= 2; }
				if($lecture_deadline!="" && $lecture_deadline<mbw_get_current_date()) $status		= $end_status;
				else if($sale_count>=$stock) $status		= $end_status;
			}else {
				if($stock==0) $status		= 2;
			}
		}
		return $status;
	}
}

if(!function_exists('mbw_get_product_status_text')){
	function mbw_get_product_status_text($type,$status=-1,$item=array()){
		global $mb_commerce_sale_status,$mb_commerce_lecture_status;
		if($status==-1) $status			= mbw_get_product_status($type,$item);
		$status_text		= "";

		if(strpos($type,"lecture")===0 && !empty($mb_commerce_lecture_status[$status])){
			$status_text		= $mb_commerce_lecture_status[$status];
		}else if(!empty($mb_commerce_sale_status[$status])){
			if($status==6){
				$status_text		= __MW("W_MEMBER_ONLY_PRICING");
			}else{
				$status_text		= $mb_commerce_sale_status[$status];
			}			
		}
		return $status_text;
	}
}

if(!function_exists('mbw_get_cart_items_subtotal')){
	function mbw_get_cart_items_subtotal(){
		global $mdb,$mstore,$mb_admin_tables,$mb_fields;
		$name						= "commerce_cart";
		$board_field				= $mb_fields[$name];
		$table_name				= mbw_get_table_name($name);
		$where_query				= ' where '.$board_field["fn_is_order"].'="0"';

		if(mbw_is_login()){
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_user_pid"]."=%s",mbw_get_user("fn_pid"));		
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_cart_id"]."!=%s","");		
		}else{
			$cart_id			= mbw_get_cart_id();			
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_cart_id"]."=%s",$cart_id);		
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_user_pid"]."=%s","0");		
		}				
		$cart_items		= $mdb->get_results("SELECT * FROM " . $table_name . $where_query, ARRAY_A);
		$subtotal		= 0;
		foreach($cart_items as $item){			
			$subtotal	= $subtotal+(floatval($item[$board_field["fn_sale_price"]])*floatval($item[$board_field["fn_order_count"]]))+floatval($item[$board_field["fn_order_options_price"]]);
		}
		return mbw_set_format($subtotal);
	}
}
if(!function_exists('mbw_get_cart_items_count')){
	function mbw_get_cart_items_count(){
		global $mdb,$mstore,$mb_admin_tables,$mb_fields;
		$name						= "commerce_cart";
		$board_field				= $mb_fields[$name];
		$table_name				= mbw_get_table_name($name);
		$where_query				= ' where '.$board_field["fn_is_order"].'="0"';

		if(mbw_is_login()){
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_user_pid"]."=%s",mbw_get_user("fn_pid"));		
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_cart_id"]."!=%s","");		
		}else{
			$cart_id			= mbw_get_cart_id();			
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_cart_id"]."=%s",$cart_id);		
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_user_pid"]."=%s","0");		
		}		
		$count					= intval($mdb->get_var("SELECT count(*) FROM " . $table_name . $where_query));		
		return $count;
	}
}

if(!function_exists('mbw_get_cart_items')){
	function mbw_get_cart_items($list_size=10){
		global $mdb,$mstore,$mb_admin_tables,$mb_fields;
		$name						= "commerce_cart";
		$board_field				= $mb_fields[$name];
		$table_name				= mbw_get_table_name($name);
		$where_query				= ' where '.$board_field["fn_is_order"].'="0"';

		if(mbw_is_login()){
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_user_pid"]."=%s",mbw_get_user("fn_pid"));		
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_cart_id"]."!=%s","");		
		}else{
			$cart_id			= mbw_get_cart_id();			
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_cart_id"]."=%s",$cart_id);		
			$where_query	.= $mdb->prepare(" and ".$board_field["fn_user_pid"]."=%s","0");		
		}
		
		$cart_items		= $mdb->get_results("SELECT * FROM " . $table_name . $where_query." order by ".$board_field["fn_pid"]." DESC limit 0,".$list_size, ARRAY_A);
		return $cart_items;
	}
}
if(!function_exists('mbw_get_wish_items_count')){
	function mbw_get_wish_items_count(){		
		if(mbw_is_login()){
			global $mdb,$mb_fields;
			$name			= "commerce_wishlist";
			$board_field		= $mb_fields[$name];
			$table_name		= mbw_get_table_name($name);
			$where_query	= ' where '.$mdb->prepare($board_field["fn_user_pid"]."=%s",mbw_get_user("fn_pid"));
			$count			= intval($mdb->get_var("SELECT count(*) FROM " . $table_name . $where_query));		
		}else{
			$count			= 0;
		}
		return $count;
	}
}
if(!function_exists('mbw_get_recently_view_count')){
	function mbw_get_recently_view_count(){
		global $mdb,$mstore,$mb_admin_tables;
		$name					= "commerce_product";
		$table_name				= mbw_get_table_name($name);
		$cookie_pid				= mbw_get_cookie("mb_product_hit");
		if(!empty($cookie_pid)){
			$where_query	= " where pid in (".$cookie_pid.")";
			$count			= intval($mdb->get_var("SELECT count(*) FROM " . $table_name . $where_query));		
		}else{
			$count			= 0;
		}
		return $count;
	}
}
if(!function_exists('mbw_get_product_category')){
	function mbw_get_product_category($board_name="commerce_product"){
		global $mdb,$mb_admin_tables,$mb_fields;

		if($board_name==mbw_get_board_name() && mbw_get_board_option("fn_category_data")!=""){
			$category_text		= mbw_get_board_option("fn_category_data");			
		}else{
			$category_text		= mbw_htmlspecialchars_decode($mdb->get_var("select ".$mb_fields["board_options"]["fn_category_data"]." from ".$mb_admin_tables["board_options"]." where ".$mb_fields["board_options"]["fn_board_name2"]."='".$board_name."'"));
		}
		return $category_text;		
	}
}

if(!function_exists('mbw_is_show_shipping_cost')){
	function mbw_is_show_shipping_cost(){	
		global $mb_commerce_shipping_cost_template_type;
		$type		= mbw_get_board_item('fn_product_type');
		if(strpos($type,"shipping")===0 && in_array(mbw_get_option("commerce_item_type"), $mb_commerce_shipping_cost_template_type)) return true;
		else false;
	}
}

if(!function_exists('mbw_is_commerce_group')){
	function mbw_is_commerce_group(){
		if(mbw_is_login() && mbw_get_option("commerce_group")!="" && mbw_get_option("commerce_group")==mbw_get_user("fn_user_group")){
			return true;
		}else return false;
	}
}


if(!function_exists('mbw_is_virtual_template_type')){
	function mbw_is_virtual_template_type(){	
		global $mb_commerce_virtual_template_type;
		$type		= mbw_get_option("commerce_item_type");
		if(in_array($type, $mb_commerce_virtual_template_type))  return true;
		else return false;
	}
}

//포인트 쿠폰 지급
if(!function_exists('mbw_set_point_coupon')){
	function mbw_set_point_coupon($value,$type="point"){
		global $mdb,$mstore,$mb_commerce_tables,$mb_fields;

		if(mbw_is_login()){
			//쿠폰 타입이 point_id 이면 일치하는 키 쿠폰을 가져와서 회원에게 포인트 지급하고, 쿠폰은 사용상태로 처리
			$coupon_data		= array();
			$field				= $mb_fields["commerce_coupon"];

			if($type=="point_id"){			// value 값이 쿠폰 key 값으로 넘어옴
				$coupon_data		= $mdb->get_row($mdb->prepare("select * from `".$mb_commerce_tables["commerce_coupon"]."` where `".$field["fn_coupon_id"]."`=%s and `".$field["fn_coupon_type"]."`='point_id' limit 1",$value),ARRAY_A);				
				if(empty($coupon_data)){
					mbw_error_message("MSG_COUPON_ID_NOT_EXIST");
				}else if(intval($coupon_data[$field["fn_is_use"]])==1){
					mbw_error_message("MSG_COUPON_USE_ERROR");
					$coupon_data		= array();
				}else if(intval($coupon_data[$field["fn_is_use"]])>1){
					mbw_error_message("사용할 수 없는 쿠폰입니다");
					$coupon_data		= array();
				}
			}else if($type=="point"){		// value 값이 쿠폰 pid 값으로 넘어옴
				$coupon_data		= $mdb->get_row($mdb->prepare("select * from `".$mb_commerce_tables["commerce_coupon"]."` where `".$field["fn_pid"]."`=%s and `".$field["fn_coupon_type"]."`='point' and `".$field["fn_is_use"]."`='0' limit 1",$value),ARRAY_A);
				if($coupon_data[$field["fn_user_pid"]]!=mbw_get_user("fn_pid")){
					mbw_error_message("사용할 수 없는 쿠폰입니다");
					$coupon_data		= array();		//쿠폰의 user_pid와 로그인된 user_pid가 일치하지 않을 경우 쿠폰 데이타 초기화
				}
			}
			do_action('mbw_commerce_point_coupon',$value,$type);

			if(!empty($coupon_data)){
				$current_date	= mbw_get_current_date();
				$start_date		= $coupon_data[$field["fn_start_date"]];
				$end_date		= $coupon_data[$field["fn_end_date"]];

				if(!empty($start_date) && $current_date<$start_date){
					if($type=="point_id"){
						mbw_error_message("유효기간이 시작되지 않은 쿠폰ID입니다");
					}else{
						mbw_error_message("유효기간이 시작되지 않은 쿠폰입니다");
					}
				}else  if(!empty($end_date) && $current_date>$end_date){
					if($type=="point_id"){
						mbw_error_message("유효기간이 만료된 쿠폰ID입니다");
					}else{
						mbw_error_message("유효기간이 만료된 쿠폰입니다");
					}
				}else{
					$point				= floatval($coupon_data[$field["fn_coupon_value"]]);
					$send_data		= array();
					$where_data		= array();

					$send_data[$field["fn_is_use"]]						= "1";
					$send_data[$field["fn_use_date"]]					= mbw_get_current_time();
					$send_data[$field["fn_user_pid"]]					= mbw_get_user('fn_pid');
					$send_data[$field["fn_user_name"]]					= mbw_get_user('fn_user_name');
					$where_data[$field["fn_pid"]]							= $coupon_data[$field["fn_pid"]];

					$mdb->db_query("UPDATE",$mb_commerce_tables["commerce_coupon"], $send_data, $where_data);

					mbw_set_user_point("coupon","give",$point,$coupon_data[$field["fn_user_pid"]],$coupon_data[$field["fn_user_name"]]);
					$mstore->set_result_data(array("message"=>$point.__MM("MSG_SEND_POINT_SUCCESS")));
				}
			}
		}else{
			mbw_error_message("MSG_REQUIRE_LOGIN");
		}
	}
}
if(!function_exists('mbw_get_cif')){
	function mbw_get_cif(){
		$cif_entry	= "pg=".mbw_get_option("commerce_pay_pg")."&type=".mbw_get_option("commerce_pay_platform");
		return base64_encode($cif_entry);
	}
}
if(!function_exists('mbw_commerce_fetch_feed')){
	function mbw_commerce_fetch_feed($url){
		$data			= array();		
		$data['v']		= mbw_get_option("mb_version");
		$data['cv']		= mbw_get_option("commerce_version");
		$data['site']	= MBW_SITE_URL;
		$data['ps']	= mbw_get_cif();
		$ch			= curl_init();
		curl_setopt( $ch, CURLOPT_URL, $url);
		curl_setopt( $ch, CURLOPT_POSTFIELDS, http_build_query($data) );
		curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, 0 );
		curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, 0 );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
		curl_setopt( $ch, CURLOPT_POST, 1);
		$response = curl_exec($ch);
		curl_close($ch);

		if(!empty($response)){
			$response		= json_decode(trim($response),true);
		}
		return $response;
	}
}
if(!function_exists('mbw_add_point_coupon')){
	function mbw_add_point_coupon($point,$args=array()){		
		mbw_insert_coupon("point",$point,$args);
	}
}
//포인트 쿠폰 지급
if(!function_exists('mbw_insert_coupon')){
	function mbw_insert_coupon($type,$value="",$args=array()){		
		global $mdb,$mb_commerce_tables,$mb_fields;

		$send_data			= array();
		$where_data		= array();
		$field					= $mb_fields["commerce_coupon"];

		$send_data[$field["fn_coupon_type"]]						= $type;
		$send_data[$field["fn_coupon_value"]]						= $value;


		if(!empty($args["coupon_title"])) $send_data[$field["fn_coupon_title"]]		= $args["coupon_title"];
		if(!empty($args["coupon_id"])) $send_data[$field["fn_coupon_id"]]		= $args["coupon_id"];
		if(!empty($args["image_path"])) $send_data[$field["fn_image_path"]]			= $args["image_path"];
		if(!empty($args["product_pid"])) $send_data[$field["fn_product_pid"]]		= $args["product_pid"];
		if(!empty($args["user_pid"])) $send_data[$field["fn_user_pid"]]					= $args["user_pid"];
		if(!empty($args["user_name"])) $send_data[$field["fn_user_name"]]			= $args["user_name"];
		if(!empty($args["start_date"])) $send_data[$field["fn_start_date"]]				= $args["start_date"];
		if(!empty($args["end_date"])) $send_data[$field["fn_end_date"]]				= $args["end_date"];
		if(!empty($args["target_type"])) $send_data[$field["fn_target_type"]]			= $args["target_type"];
		else $send_data[$field["fn_target_type"]]							= "user";

		$send_data[$field["fn_reg_date"]]							= mbw_get_current_time();
		$send_data[$field["fn_ip"]]										= $_SERVER["REMOTE_ADDR"];
		$send_data[$field["fn_agent"]]								= mbw_get_vars("user_agent");

		$mdb->db_query("INSERT",$mb_commerce_tables["commerce_coupon"], $send_data, $where_data);



	}
}
if(!function_exists('mbw_get_rand_coupon_id')){
	function mbw_get_rand_coupon_id($value){
		$key		= wp_generate_password( 5, false ).$value.wp_generate_password( 5, false );
		return strtolower($key);
	}
}
//포인트 쿠폰 생성
if(!function_exists('mbw_create_point_coupon')){
	function mbw_create_point_coupon($point,$count){
		global $mdb,$mb_commerce_tables,$mb_fields;
		$coupon_title		= (mbw_get_param("coupon_title"));
		$start_date			= (mbw_get_param("coupon_start_date"));
		$end_date			= (mbw_get_param("coupon_end_date"));

		$field					= $mb_fields["commerce_coupon"];
		$query				= "INSERT INTO ".$mb_commerce_tables["commerce_coupon"]." (`".$field["fn_coupon_type"]."`, `".$field["fn_coupon_id"]."`, `".$field["fn_coupon_value"]."`, `".$field["fn_coupon_title"]."`, `".$field["fn_start_date"]."`, `".$field["fn_end_date"]."`,`".$field["fn_reg_date"]."`) VALUES ";
		$reg_date			= mbw_get_current_time();
		$index				= intval($mdb->get_var("select ".$field["fn_pid"]." from `".$mb_commerce_tables["commerce_coupon"]."` ORDER BY ".$field["fn_pid"]." DESC limit 1"))+1;

		for($i=0;$i<$count-1;$i++){
			$query		.= $mdb->prepare("('point_id',%s,%s,%s,%s,%s,%s),", mbw_get_rand_coupon_id($index),$point,$coupon_title,$start_date,$end_date,$reg_date);
			$index++;
		}
		$query		.= $mdb->prepare("('point_id',%s,%s,%s,%s,%s,%s);", mbw_get_rand_coupon_id($index),$point,$coupon_title,$start_date,$end_date,$reg_date);
		$mdb->query($query);
	}
}

//디비에 있는 옵션 재고개수 가지고 와서 옵션 데이타에 넣기
if(!function_exists('mbw_check_options_data')){
	function mbw_check_options_data($options){

		global $mdb,$mb_fields,$mb_admin_tables;
		$fields					= $mb_fields["meta"];
		$options_count		= $mdb->get_results("SELECT ".$fields["fn_meta_key"].",".$fields["fn_meta_value"]." FROM " . $mb_admin_tables["meta"] . " WHERE ".$fields["fn_meta_pid"]."='".mbw_get_board_item('fn_pid')."' and ".$fields["fn_meta_table"]."='commerce_product_op02_count';", ARRAY_A);
		$count_array			= array();
		$key_field				= $fields["fn_meta_key"];
		$value_field				= $fields["fn_meta_value"];
		foreach($options_count as $value){
			$count_array[$value[$key_field]]		= $value[$value_field];
		}
		$options_data						= json_decode($options,true);
		$options_data						= mbw_check_options_count($options_data,$count_array);
		return $options_data;
	}
}
if(!function_exists('mbw_check_options_count')){
	function mbw_check_options_count($options,$data=array()){
		foreach($options as $key =>$value){		
			if(isset($value["children"])){
				$options[$key]["children"]		= mbw_check_options_count($value["children"],$data);
			}
			if(isset($value["id"]) && isset($data[$value["id"]])){
				$options[$key]["option_count"]		= $data[$value["id"]];
			}
		}
		return $options;
	}
}
//옵션의 id로 개수 배열 가져오기
if(!function_exists('mbw_get_options_count')){
	function mbw_get_options_count($options,$data=array()){
		$item_count		= $data;
		foreach($options as $key =>$value){		
			if(isset($value["children"])){
				$item_count		= mbw_get_options_count($value["children"],$item_count);
			}
			if(isset($value["id"]) && isset($value["option_count"])){		
				$item_count[$value["id"]]		= $value["option_count"];
			}
		}
		return $item_count;
	}
}
//옵션의 id로 이름 배열 가져오기
if(!function_exists('mbw_get_options_name')){
	function mbw_get_options_name($options,$data=array()){
		$item_title		= $data;
		foreach($options as $key =>$value){		
			if(isset($value["children"])){
				$item_title		= mbw_get_options_name($value["children"],$item_title);
			}
			if(isset($value["id"]) && isset($value["option_name"])){		
				$item_title[$value["id"]]		= $value["option_name"];
			}
		}
		return $item_title;
	}
}
if(!function_exists('mbw_set_commerce_data')){
	function mbw_set_commerce_data($field1, $field2, $item){
		$field					= $field1;
		$item_field			= $field2;		
		$send_data			= array();

		if(isset($field["fn_title"]))		$send_data[$field["fn_title"]]											= $item[$item_field["fn_title"]];
		if(isset($field["fn_image_path"]))		$send_data[$field["fn_image_path"]]						= $item[$item_field["fn_image_path"]];
		if(isset($field["fn_regular_price"]))		$send_data[$field["fn_regular_price"]]					= $item[$item_field["fn_regular_price"]];
		if(isset($field["fn_sale_text"]))		$send_data[$field["fn_sale_text"]]								= $item[$item_field["fn_sale_text"]];
		if(isset($field["fn_sale_price"]))		$send_data[$field["fn_sale_price"]]							= $item[$item_field["fn_sale_price"]];
		if(isset($field["fn_product_type"]))		$send_data[$field["fn_product_type"]]					= $item[$item_field["fn_product_type"]];
		if(isset($field["fn_pay_type"]) && !empty($item[$item_field["fn_pay_type"]]))		$send_data[$field["fn_pay_type"]]								= $item[$item_field["fn_pay_type"]];

		if(mbw_get_param("product_pay_type")!="" && isset($field["fn_pay_type"])){
			if(mbw_get_param("product_pay_type")=="empty"){
				$send_data[$field["fn_pay_type"]]		= "";
			}else{
				$send_data[$field["fn_pay_type"]]		= mbw_value_filter(mbw_get_param("product_pay_type"));
			}
		}

		if(isset($field["fn_shipping_cost"])){
			if(strpos($item[$item_field["fn_product_type"]],"shipping")===0) $send_data[$field["fn_shipping_cost"]]		= $item[$item_field["fn_shipping_cost"]];
			else $send_data[$field["fn_shipping_cost"]]				= 0;
		}
		if(mbw_get_param('recommender_pid')!="" && isset($field["fn_recommender_pid"])){
			$send_data[$field["fn_recommender_pid"]]				= mbw_get_param('recommender_pid');
		}

		if(isset($field["fn_product_description"])) $send_data[$field["fn_product_description"]]		= $item[$item_field["fn_product_description"]];
		if(isset($field["fn_product_point"]))		$send_data[$field["fn_product_point"]]					= $item[$item_field["fn_product_point"]];
		if(isset($field["fn_shop_email"]))		$send_data[$field["fn_shop_email"]]						= $item[$item_field["fn_user_email"]];
		if(isset($field["fn_shop_name"]))		$send_data[$field["fn_shop_name"]]						= $item[$item_field["fn_user_name"]];
		if(isset($field["fn_shop_pid"]))		$send_data[$field["fn_shop_pid"]]							= $item[$item_field["fn_user_pid"]];

		if(mbw_get_option("commerce_db_version")>"1.0.2"){
			if(isset($field["fn_category1"]))		$send_data[$field["fn_category1"]]								= $item[$item_field["fn_category1"]];
			if(isset($field["fn_category2"]))		$send_data[$field["fn_category2"]]								= $item[$item_field["fn_category2"]];
			if(isset($field["fn_category3"]))		$send_data[$field["fn_category3"]]								= $item[$item_field["fn_category3"]];

			if(isset($field["fn_market_type1"]))	$send_data[$field["fn_market_type1"]]								= $item[$item_field["fn_market_type1"]];
			if(isset($field["fn_market_type2"]))	$send_data[$field["fn_market_type2"]]								= $item[$item_field["fn_market_type2"]];
			if(isset($field["fn_market_type3"]))	$send_data[$field["fn_market_type3"]]								= $item[$item_field["fn_market_type3"]];
			if(isset($field["fn_market_type4"]))	$send_data[$field["fn_market_type4"]]								= $item[$item_field["fn_market_type4"]];
		}
		//dev2 20.02.07
		if(mbw_get_option("commerce_db_version")>"1.0.5"){
			if(isset($field["fn_is_dutyfree"]))		$send_data[$field["fn_is_dutyfree"]]								= $item[$item_field["fn_is_dutyfree"]];
		}
		for($i=1;$i<=10;$i++){
			$f_name		= "fn_ext".$i;
			if(isset($field[$f_name]) && isset($item_field[$f_name]) && isset($item[$item_field[$f_name]]))	$send_data[$field[$f_name]]	= $item[$item_field[$f_name]];
		}

		return $send_data;
	}
}
?>