<?php
require_once(MBW_PLUGIN_PATH."plugins/naver_pay/functions.php");
function mb_commerce_naver_pay_init(){
	if(intval(mbw_get_option("use_naver_pay"))!=0){
		loadScript(MBW_PLUGIN_URL."plugins/naver_pay/js/naver_pay.js");
		$pay_platform			= "";
		if(intval(mbw_get_option("use_naver_pay"))==3) $pay_platform		= 'test-';

		if(mbw_get_vars("device_type")!="desktop"){
			loadScript("//".$pay_platform."pay.naver.com/customer/js/mobile/naverPayButton.js");
		}else{
			loadScript("//".$pay_platform."pay.naver.com/customer/js/naverPayButton.js");
		}
	}
}
add_action('wp_enqueue_scripts', 'mb_commerce_naver_pay_init');
add_action('admin_enqueue_scripts', 'mb_commerce_naver_pay_init');

add_action('wp_head', 'mbw_naver_pay_scripts',10);
if(!function_exists('mbw_naver_pay_scripts')){	
	function mbw_naver_pay_scripts() {		
		if(intval(mbw_get_option("use_naver_pay"))!=0){
			//$board_name		= mbw_get_board_name();
			//if(in_array($board_name, array('commerce_product','commerce_cart')))
			{
				$naver_account_id		= trim(mbw_get_option("commerce_naver_pay_account_id"));
				if(!empty($naver_account_id)){
					$naver_inflow				= str_replace("www.","",$_SERVER["HTTP_HOST"]);
					echo '<script type="text/javascript" src="//wcs.naver.net/wcslog.js"></script>';
					echo '<script type="text/javascript">if(!wcs_add) var wcs_add={};wcs_add["wa"]="'.$naver_account_id.'";wcs.inflow("'.$naver_inflow.'");</script>';
				}
			}
		}
	}
}
add_action('wp_footer', 'mbw_naver_pay_footer',10);
if(!function_exists('mbw_naver_pay_footer')){
	function mbw_naver_pay_footer(){
		if(intval(mbw_get_option("use_naver_pay"))!=0){
			//$board_name		= mbw_get_board_name();
			//if(in_array($board_name, array('commerce_product','commerce_cart')))
			{
				$naver_account_id		= trim(mbw_get_option("commerce_naver_pay_account_id"));
				if(!empty($naver_account_id)){
					echo '<script type="text/javascript"> wcs_do(); </script>';
				}
			}
		}
	}
}


add_filter('query_vars','mbw_commerce_naver_pay_add_trigger');
if(!function_exists('mbw_commerce_naver_pay_add_trigger')){
	function mbw_commerce_naver_pay_add_trigger($vars){
		$vars[] = 'mcp';
		return $vars;
	}
}

add_action('template_redirect', 'mbw_commerce_naver_pay_trigger_check');
if(!function_exists('mbw_commerce_naver_pay_trigger_check')){	
	function mbw_commerce_naver_pay_trigger_check() {
		if(strtolower(get_query_var('mcp')) == "naver") {
			$query						= $_SERVER['QUERY_STRING'];
			$vars							= array();
			foreach(explode('&', $query) as $pair) {
				list($key, $value)		= explode('=', $pair);
				$key						= urldecode($key);
				$value					= urldecode($value);
				$vars[$key][]			= $value;
			}
			if(empty($vars['ITEM_ID'])) {
				exit('ITEM_ID 는 필수입니다.');
			}
			$itemIds						= $vars['ITEM_ID'];

			global $mstore,$mdb,$mb_commerce_tables,$mb_fields;

			header('Content-Type: application/xml;charset=UTF-8');
			echo ('<?xml version="1.0" encoding="UTF-8"?>');
			$fields					= $mb_fields["commerce_product"];
			$item_xml				='<response>';
			foreach($itemIds as $value) $itemIds_format[]		= "%d";
			$items				= $mdb->get_results($mdb->prepare("select * from `".$mb_commerce_tables["commerce_product"]."` WHERE ".$fields["fn_pid"]." in (".implode(",",$itemIds_format).")", $itemIds ),ARRAY_A);

			foreach($items as $item){
				$item_xml	.='<item id="'.$item[$fields['fn_pid']].'">';
				$item_xml	.='<name><![CDATA['.mbw_htmlspecialchars_decode($item[$fields['fn_title']]).']]></name>';
				$item_xml	.='<url><![CDATA['.mbw_get_url(array('vid'=>$item[$fields['fn_pid']]),mbw_get_product_view_url(),"").']]></url>';

				$item_xml	.='<description><![CDATA['.$item[$fields['fn_product_description']].']]></description>';
				$item_xml	.='<image><![CDATA['.mbw_get_image_url("url",$item[$fields['fn_image_path']]).']]></image>';
				$item_xml	.='<thumb><![CDATA['.mbw_get_image_url("url",$item[$fields['fn_image_path']]).']]></thumb>';
				$item_xml	.='<price>'.$item[$fields['fn_sale_price']].'</price>';
				$item_xml	.='<quantity>'.$item[$fields['fn_stock']].'</quantity>';
				$item_xml	.='<category>';
				$item_xml	.='<first><![CDATA['.mbw_htmlspecialchars_decode($item[$fields['fn_category1']]).']]></first>';
				$item_xml	.='<second><![CDATA['.mbw_htmlspecialchars_decode($item[$fields['fn_category2']]).']]></second>';
				$item_xml	.='<third><![CDATA['.mbw_htmlspecialchars_decode($item[$fields['fn_category3']]).']]></third>';
				$item_xml	.='</category>';

				if($item[$fields['fn_product_options']]!="" && $item[$fields['fn_use_product_options']]!="0"){
					$item_xml	.='<options>';

					if($item[$fields['fn_product_options_type']]=="mc-op01"){

						$product_required_options		= array();
						$product_options					= maybe_unserialize($item[$fields['fn_product_options']]);
						if(!empty($product_options["required_options"])){
							$product_required_options		= $product_options["required_options"];

							for($i=0;$i<count($product_required_options["value"]);$i++){
								$option_title		= "";
								$option_value		= array();
								if(isset($product_required_options["title"][$i])) $option_title		= $product_required_options["title"][$i];
								if(!empty($product_required_options["value"][$i])){
									$option_value		= array_unique(explode(",",str_replace("||",",",$product_required_options["value"][$i])));
								}else continue;
								$item_xml	.='<option name="'.$option_title.'">';
								foreach($option_value as $value){
									$item_xml	.='<select><![CDATA['.$value.']]></select>';
								}
								$item_xml	.='</option>';
							}
						}
						if(!empty($product_options["add_options"])){
							$product_add_options			= $product_options["add_options"];
							for($i=0;$i<count($product_add_options["value"]);$i++){
								$option_title		= "";
								$option_value		= array();
								if(isset($product_add_options["title"][$i])) $option_title		= $product_add_options["title"][$i];
								if(!empty($product_add_options["value"][$i])){
									$option_value		= explode(",",str_replace("||",",",$product_add_options["value"][$i]));
								}else continue;
								$item_xml	.='<option name="'.$option_title.'">';
								foreach($option_value as $value){
									$item_xml	.='<select><![CDATA['.$value.']]></select>';
								}				
								$item_xml	.='</option>';
							}
						}
					}else if($item[$fields['fn_product_options_type']]=="mc-op02"){

						$product_required_options		= array();
						$product_options					= maybe_unserialize($item[$fields['fn_product_options']]);
						if(!empty($product_options["required_options2"])){

							$product_required_options		= $product_options["required_options2"];
							$product_required_title			= $product_options["required_options2_title"];
							//옵션 재고관리 데이타 동기화하기
							$product_required_options		= mbw_check_options_data($product_required_options);
							$option_value						= array();
							for($j=0;$j<count($product_required_options);$j++){
								if(!empty($product_required_options[$j]["option_is_use"]) && $product_required_options[$j]["option_is_use"]=="OFF") continue;
								$option_value[0][]		= $product_required_options[$j]["option_name"];
								if(!empty($product_required_options[$j]["children"])){
									foreach($product_required_options[$j]["children"] as $item1){
										if(!empty($item1["option_is_use"]) && $item1["option_is_use"]=="OFF") continue;
										$option_value[1][]		= $item1["option_name"];
										if(!empty($item1["children"])){
											foreach($item1["children"] as $item2){
												if(!empty($item2["option_is_use"]) && $item2["option_is_use"]=="OFF") continue;
												$option_value[2][]		= $item2["option_name"];
											}
										}
									}
								}
							}
							$option_value[1]		= array_unique($option_value[1]);
							$option_value[2]		= array_unique($option_value[2]);

							for($i=0;$i<3;$i++){
								$option_title		= "";
								if(!empty($product_required_title["title"][$i])) $option_title		= $product_required_title["title"][$i];
								else break;
								$item_xml	.='<option name="'.$option_title.'">';
								foreach($option_value[$i] as $value){
									$item_xml	.='<select><![CDATA['.$value.']]></select>';
								}
								$item_xml	.='</option>';
							}
						}
						if(!empty($product_options["add_options2"])){
							$product_add_options			= $product_options["add_options2"];
							for($i=0;$i<count($product_add_options["value"]);$i++){
								$option_title		= "";
								$option_value		= array();
								if(isset($product_add_options["title"][$i])) $option_title		= $product_add_options["title"][$i];
								if(!empty($product_add_options["value"][$i])){
									$option_value		= explode(",",str_replace("||",",",$product_add_options["value"][$i]));
								}else continue;
								$item_xml	.='<option name="'.$option_title.'">';
								foreach($option_value as $value){
									$item_xml	.='<select><![CDATA['.$value.']]></select>';
								}				
								$item_xml	.='</option>';
							}
						}
					}
					$item_xml	.='</options>';
				}
				$item_xml	.='</item>';
			}

			$item_xml	.='</response>';
			echo $item_xml;
			exit;
		}
	}
}



if(!function_exists('mbw_commerce_naver_pay_api_body')){	
	function mbw_commerce_naver_pay_api_body(){
		if(strpos(mbw_get_param("board_action"),'naver_')!==0) return;
		global $mstore,$mdb,$mb_commerce_tables,$mb_fields;
		
		$shopId					= trim(mbw_get_option("commerce_naver_pay_mid"));
		$certiKey					= trim(mbw_get_option("commerce_naver_pay_certi_key"));
		$pay_platform			= "";		
		if(intval(mbw_get_option("use_naver_pay"))==3) $pay_platform		= 'test-';

		$req_addr				= 'ssl://'.$pay_platform.'pay.naver.com';
		$req_host					= $pay_platform.'pay.naver.com';

		$req_url					= "";
		$req_port					= 443;
		$value						= array();
		$arr_count				= count($value);
		$errno					= "";
		$errstr						= "";
		$req_check				= false;
		$backUrl					= mbw_get_param("redirect_to");
		if(strpos($backUrl,'&NaPm=')!==false){
			$backUrl		= substr($backUrl,0,strpos($backUrl,'&NaPm='));
		}

		$shippingType		= "PAYED";
		$shippingPrice		= 0;
		$fields					= $mb_fields["commerce_product"];
		$queryString			= 'SHOP_ID='.urlencode($shopId).'&CERTI_KEY='.urlencode($certiKey).'&RESERVE1=&RESERVE2=&RESERVE3=&RESERVE4=&RESERVE5=';

		$board_action		= mbw_get_param("board_action");
		if(strpos($board_action,'naver_order')===0){
			$req_url			= 'POST /customer/api/order.nhn HTTP/1.1'; // utf-8

			$queryString .= '&BACK_URL='.urlencode($backUrl);
			$queryString .= '&SA_CLICK_ID='.$_COOKIE["NVADID"]; //CTS
			// CPA 스크립트 가이드 설치 업체는 해당 값 전달
			$queryString .= '&CPA_INFLOW_CODE='.urlencode($_COOKIE["CPAValidator"]);
			$queryString .= '&NAVER_INFLOW_CODE='.urlencode($_COOKIE["NA_CO"]);
			$total_order_price		= 0;
			$option_price			= 0;
			$order_count			= 0;
			$item_option				= "";

			if(mbw_get_param("board_pid")!=""){		//상품상세 페이지에서 네이버 페이 클릭

				if(mbw_is_product_order(mbw_get_param("board_pid"), array(mbw_get_param("order_count")))){

					$item					= $mdb->get_row($mdb->prepare("select * from `".$mb_commerce_tables["commerce_product"]."` WHERE ".$fields["fn_pid"]."=%d limit 1", mbw_get_param("board_pid") ),ARRAY_A);
					$id						= $item[$fields['fn_pid']]; // 상품번호
					$name				= $item[$fields['fn_title']]; // 상품명
					$uprice				= intval($item[$fields['fn_sale_price']]); // 상품 가격
					$count				= abs(intval($order_count));
					$shippingPrice		= intval($item[$fields['fn_shipping_cost']]); // 배송비
					$option				= $item_option;
					$tprice				= 0;

					if(!empty($_POST["product_required_options"]) || !empty($_POST["product_required_options2"])){
						if(!empty($_POST["product_required_options"])){
							$product_required_options				= $_POST["product_required_options"];
							if(!empty($_POST["product_required_options_count"])){
								$product_required_options_count		= $_POST["product_required_options_count"];
							}else{
								$product_required_options_count		= array_fill(0, count($product_required_options), 1);
							}
						}else if(!empty($_POST["product_required_options2"])){
							$product_required_options				= $_POST["product_required_options2"];
							if(!empty($_POST["product_required_options_count2"])){
								$product_required_options_count		= $_POST["product_required_options_count2"];
							}else{
								$product_required_options_count		= array_fill(0, count($product_required_options), 1);
							}
						}
						$index				= 0;
						if(!empty($product_required_options)){
							$product_options_type		= mbw_get_param("product_options_type");
							if($product_options_type=="mc-op11"){
								$uprice	= 0;
							}
							foreach($product_required_options as $value){
								$option_data		= explode("||",$value);
								$count			= abs(intval($product_required_options_count[$index]));
								if(empty($count)) $count	= 1;
								$item_option		.= "";
								if(empty($option_data[1])) $item_option		= $option_data[0].' / '.$count.'개';
								else $item_option		= $option_data[0].' / '.$count.'개 / +'.strip_tags(mbw_set_format($option_data[1]));
								$order_count		= $order_count+$count;
								$option_uprice		= $uprice+intval($option_data[1]);
								$option_tprice		= $option_uprice*$count;
								$tprice				= $tprice+$option_tprice;
								$queryString		.= '&'.mbw_make_order_query($id, $name, $option_tprice, $option_uprice, $item_option, $count);
								$index++;
							}
						}
					}else{
						$count			= abs(intval(mbw_get_param("order_count")));
						if(empty($count)) $count	= 1;
						$item_tprice		= ($uprice * $count);
						$tprice			= $tprice+$item_tprice;
						$queryString		.= '&'.mbw_make_order_query($id, $name, $item_tprice, $uprice, $option, $count);
					}

					if(!empty($_POST["product_add_options"]) || !empty($_POST["product_add_options2"])){
						if(!empty($_POST["product_add_options"])){
							$product_add_options				= $_POST["product_add_options"];
							if(!empty($_POST["product_add_options_count"])){
								$product_add_options_count		= $_POST["product_add_options_count"];
							}else{
								$product_add_options_count		= array_fill(0, count($product_add_options), 1);
							}
						}else if(!empty($_POST["product_add_options2"])){
							$product_add_options				= $_POST["product_add_options2"];
							if(!empty($_POST["product_add_options_count2"])){
								$product_add_options_count		= $_POST["product_add_options_count2"];
							}else{
								$product_add_options_count		= array_fill(0, count($product_add_options), 1);
							}
						}
						$index				= 0;
						if(!empty($product_add_options)){
							foreach($product_add_options as $value){
								$option_data		= explode("||",$value);
								$count			= abs(intval($product_add_options_count[$index]));
								if(empty($count)) $count	= 1;
								$item_option		= "";
								if(empty($option_data[1])) $item_option		= $option_data[0].' / '.$count.'개';
								else $item_option	= $option_data[0].' / '.$count.'개 / +'.strip_tags(mbw_set_format($option_data[1]));
								$option_uprice		= intval($option_data[1]);
								$option_tprice		= $option_uprice*$count;
								$tprice				= $tprice+$option_tprice;
								$queryString		.= '&'.mbw_make_order_query($id, $name, $option_tprice, $option_uprice, $item_option, $count);
								$index++;
							}
						}
					}

					$free_shipping_price	= mbw_get_option("free_shipping_order");
					if($free_shipping_price!=0 && $tprice >= $free_shipping_price){ 
						$shippingPrice		=  0;
						$shippingType		= 'FREE';
					}
					if($shippingPrice==0) $shippingType		= 'FREE';
					$queryString			.= '&SHIPPING_TYPE='.$shippingType;
					$queryString			.= '&SHIPPING_PRICE='.$shippingPrice;
					$queryString			.= '&TOTAL_PRICE='.(intval($tprice) + intval($shippingPrice));
					$total_order_price		+= intval($tprice) + intval($shippingPrice);
					$req_check			= true;
				}
			}else{			//장바구니에서 네이버 페이 클릭

				$fields					= $mb_fields["commerce_cart"];
				$billing_pid			= mbw_get_param("check_array");
				foreach($billing_pid as $value) $billing_format[]		= "%d";

				$items					= $mdb->get_results($mdb->prepare("select * from `".$mb_commerce_tables["commerce_cart"]."` WHERE ".$fields["fn_pid"]." in (".implode(",",$billing_format).")", $billing_pid ),ARRAY_A);
				$shippingPriceMax	= 0;
				$shippingPrice		= 0;
				
				foreach($items as $item){
					$tprice				= 0;
					$id						= $item[$fields['fn_product_pid']]; // 상품번호
					$name				= $item[$fields['fn_title']]; // 상품명
					$uprice				= intval($item[$fields['fn_sale_price']]); // 상품 가격
					$count				= abs(intval($item[$fields['fn_order_count']]));
					$option_price		= intval($item[$fields['fn_order_options_price']]);
					$shippingPrice		+= intval($item[$fields['fn_shipping_cost']]); // 배송비
					if($shippingPriceMax<intval($item[$fields['fn_shipping_cost']])) $shippingPriceMax		= intval($item[$fields['fn_shipping_cost']]);

					$item_option			= mbw_htmlspecialchars_decode($item[$fields['fn_order_options']]);

					$product_required_options	= array();
					$product_add_options			= array();
					
					if(strpos($item_option,'mc-order-required-options')!==false) {
						if(strpos($item_option,'check_product_options')!==false) {
							$offset1	= strpos($item_option,'<div class="mc-order-required-options">');
							$required_options	= substr($item_option,$offset1,strpos($item_option,'/></div>',$offset1)-$offset1+8);
							$required_options	= str_replace("</span>/<span>", "</span>||<span>",$required_options);
							$required_options	= strip_tags(str_replace("/><div>", "/>@@<div>",$required_options));
							$product_required_options	= explode('@@',$required_options);
						}else{
							$offset1	= strpos($item_option,'<div class="mc-order-required-options">');
							$required_options	= substr($item_option,$offset1,strpos($item_option,'</div></div>',$offset1)-$offset1+12);
							$required_options	= str_replace("</span>/<span>", "</span>||<span>",$required_options);
							$required_options	= strip_tags(str_replace("</div><div>", "@@</div><div>",$required_options));
							$product_required_options	= explode('@@',$required_options);
						}						
					}
					if(strpos($item_option,'mc-order-add-options')!==false) {
						$offset2	= strpos($item_option,'<div class="mc-order-add-options">');
						$add_options	= substr($item_option,$offset2,strpos($item_option,'</div></div>',$offset2)-$offset2+12);
						$add_options	= str_replace("</span>/<span>", "</span>||<span>",$add_options);
						$add_options	= strip_tags(str_replace("</div><div>", "@@</div><div>",$add_options));
						$product_add_options	= explode('@@',$add_options);
					}					

					if(strpos($item_option,'mc-order-required-options')===false && strpos($item_option,'mc-order-add-options')===false) {
						$item_option			= strip_tags(str_replace("</span></div>", ", </span></div>",$item_option));
						$item_option			= substr($item_option,0,-2);
						$option				= $item_option;
						if(empty($count)) $count	= 1;
						$tprice				= ($uprice * $count)+$option_price;					
						$queryString			.= '&'.mbw_make_order_query($id, $name, $tprice, $uprice, $option, $count);
					}else{
						foreach($product_required_options as $value){
							$option_data			= explode("||",$value);
							if(!empty($option_data[1])){
								$option_count		= intval(rtrim(trim($option_data[1]),'개'));
								if(empty($option_count)) $option_count	= 1;
							}else{
								$option_count		= 1;
							}
							if(!empty($option_data[2])){
								$option_uprice		= $uprice + intval(str_replace(array("+",",","원"), "", $option_data[2]));
							}else{
								$option_uprice		= $uprice;								
							}
							$option_tprice		= $option_uprice*$option_count;
							$tprice				= $tprice+$option_tprice;
							$queryString		.= '&'.mbw_make_order_query($id, $name, $option_tprice, $option_uprice, str_replace('||','/',$value), $option_count);							
						}
						foreach($product_add_options as $value){
							$option_data			= explode("||",$value);
							if(!empty($option_data[1])){
								$option_count		= intval(rtrim(trim($option_data[1]),'개'));
								if(empty($option_count)) $option_count	= 1;
							}else{
								$option_count		= 1;
							}
							if(!empty($option_data[2])){
								$option_uprice		= intval(str_replace(array("+",",","원"), "", $option_data[2]));
							}else{
								$option_uprice		= 0;								
							}
							$option_tprice		= $option_uprice*$option_count;
							$tprice				= $tprice+$option_tprice;
							$queryString		.= '&'.mbw_make_order_query($id, $name, $option_tprice, $option_uprice, str_replace('||','/',$value), $option_count);							
						}
					}					
					$total_order_price		+= intval($tprice);
				}				
				
				if(floatval(mbw_get_option("free_shipping_order"))>0 && $total_order_price>=floatval(mbw_get_option("free_shipping_order"))){
					$shippingPrice			= 0;
				//상품 타입이 전체 또는 단일 배송비일 경우 단일 배송비로 설정
				}else if(mbw_get_option("commerce_item_type")=="all" || mbw_get_option("commerce_item_type")=="shop") {
					$shippingPrice			= floatval(mbw_get_option("shipping_cost"));
					if($shippingPriceMax>$shipping_cost) $shippingPrice		= $shippingPriceMax;
				}
				$total_order_price		+= intval($shippingPrice);
				if($shippingPrice==0) $shippingType		= 'FREE';

				$queryString			.= '&SHIPPING_TYPE='.$shippingType;
				$queryString			.= '&SHIPPING_PRICE='.$shippingPrice;
				$queryString			.= '&TOTAL_PRICE='.$total_order_price;
				$req_check				= true;
			}
		}else if(strpos($board_action,'naver_wishlist')===0){
			$req_url = 'POST /customer/api/wishlist.nhn HTTP/1.1'; // utf-8
			if(mbw_get_param("board_pid")!=""){
				$billing_pid					= array(mbw_get_param("board_pid"));
			}else{ 
				$billing_pid					= mbw_get_param("check_array");
			}		
			foreach($billing_pid as $value) $billing_format[]		= "%d";
			$items				= $mdb->get_results($mdb->prepare("select * from `".$mb_commerce_tables["commerce_product"]."` WHERE ".$fields["fn_pid"]." in (".implode(",",$billing_format).")", $billing_pid ),ARRAY_A);

			foreach($items as $item){
				$uid				= $item[$fields['fn_pid']]; // 상품번호
				$name			= $item[$fields['fn_title']]; // 상품명
				$uprice			= $item[$fields['fn_sale_price']]; // 상품 가격
				$image			= mbw_get_image_url("url",$item[$fields['fn_image_path']]); // 상품이미지 주소
				$thumb			= mbw_get_image_url("url",$item[$fields['fn_image_path']]); // 상품 썸네일이미지 주소
				$url				= mbw_get_url(array('vid'=>$item[$fields['fn_pid']]),mbw_get_product_view_url(),"");
				$queryString .= '&'.mbw_make_wishlist_query($uid, $name, $uprice, $image, $thumb, $url);
			}	
			$req_check		= true;
		}

		if($req_check){
			$nc_sock	= @fsockopen($req_addr, $req_port, $errno, $errstr);
			if($nc_sock){
				fwrite($nc_sock, $req_url."\r\n" );
				fwrite($nc_sock, "Host: ".$req_host.":".$req_port."\r\n" );
				fwrite($nc_sock, "Content-type: application/x-www-form-urlencoded; charset=utf-8\r\n");
				fwrite($nc_sock, "Content-length: ".strlen($queryString)."\r\n");
				fwrite($nc_sock, "Accept: */*\r\n");
				fwrite($nc_sock, "\r\n");
				fwrite($nc_sock, $queryString."\r\n");
				fwrite($nc_sock, "\r\n");
			 
				while(!feof($nc_sock)){
					$header=fgets($nc_sock,4096);
					if($header=="\r\n"){
						break;
					} else {
						$headers .= $header;
					}
				}		 
				while(!feof($nc_sock)){
					$bodys.=fgets($nc_sock,4096);
				}			 
				fclose($nc_sock);
				$resultCode	= substr($headers,9,3);
				if($resultCode==200){
					$resultData		= array();

					if(strpos($board_action,'naver_order')===0){
						if(mbw_get_vars("device_type")!="desktop"){
							$move_url = "https://".$pay_platform."m.pay.naver.com/mobile/customer/order.nhn";
						}else{ 
							$move_url = "https://".$pay_platform."pay.naver.com/customer/order.nhn";
						}
						$resultData["url"]		= $move_url."?ORDER_ID=".$bodys."&SHOP_ID=".$shopId."&TOTAL_PRICE=".$total_order_price;
					}else if(strpos($board_action,'naver_wishlist')===0){
						if(mbw_get_vars("device_type")!="desktop"){
							$move_url = "https://".$pay_platform."m.pay.naver.com/mobile/customer/wishList.nhn";
						}else{ 
							$move_url = "https://".$pay_platform."pay.naver.com/customer/wishlistPopup.nhn";
						}
						$resultData["url"]		= $move_url."?SHOP_ID=".$shopId."&ITEM_ID=".$bodys;
					}				
					$mstore->set_result_data(array("state"=>"success","url"=>$resultData["url"]));

				}else{
					$mstore->set_result_data(array("state"=>"error","message"=>$bodys));
				}
			}else {
				$mstore->set_result_data(array("state"=>"error","message"=>"$errstr ($errno)<br>\n"));
			}
		}
	}	
}
add_action('mbw_commerce_api_body', 'mbw_commerce_naver_pay_api_body',5);
?>