<?php
define("MBW_COMMERCE_PAY_PATH", MBW_PLUGIN_PATH."plugins/pay/");

add_filter('query_vars','mbw_commerce_pay_add_trigger');
if(!function_exists('mbw_commerce_pay_add_trigger')){
	function mbw_commerce_pay_add_trigger($vars) {
		$vars[] = 'commerce_pay';
		return $vars;
	}
}
add_action('template_redirect', 'mbw_commerce_pay_trigger_check');
if(!function_exists('mbw_commerce_pay_trigger_check')){	
	function mbw_commerce_pay_trigger_check() {		
		$commerce_pay		= get_query_var('commerce_pay');
		if($commerce_pay == "pay_open") {
			$type			= mbw_get_param("type");
			if(!empty($type)){
				if(is_file(MBW_COMMERCE_PAY_PATH.$type."/functions.php")){
					include(MBW_COMMERCE_PAY_PATH.$type."/functions.php");
				}
				mbw_commerce_pay_popup_open();
			}
			exit;			
		}else if($commerce_pay == "order_approval") {
			$type			= mbw_get_param("type");
			if(!empty($type)){
				if(is_file(MBW_COMMERCE_PAY_PATH.$type."/functions.php")){
					include(MBW_COMMERCE_PAY_PATH.$type."/functions.php");
				}
				if(function_exists('mbw_commerce_pay_order_approval')){	
					mbw_commerce_pay_order_approval();
				}
			}
			exit;
		}else if($commerce_pay == "order_ipn" || $commerce_pay == "order_status") {
			$type			= mbw_get_param("type");
			if(!empty($type)){
				if(is_file(MBW_COMMERCE_PAY_PATH.$type."/functions.php")){
					include(MBW_COMMERCE_PAY_PATH.$type."/functions.php");
				}
				if(function_exists('mbw_commerce_pay_order_ipn')){	
					mbw_commerce_pay_order_ipn();
				}				
			}
			exit;
		}else if($commerce_pay == "pay_fail") {
			mbw_commerce_pay_popup_close("결제에 오류가 발생했습니다. 잠시 후 다시 이용해 주세요.");
			exit;
		}else if($commerce_pay == "pay_cancel") {
			mbw_commerce_pay_popup_close();
			exit;
		}
	}
}
if(!function_exists('mbw_commerce_pay_popup_close')){	
	function mbw_commerce_pay_popup_close($msg=''){
		$html		= "";
		$html		.= '<html><head><title></title>';
		$html		.= '<script type="text/javascript">';
			if(!empty($msg)) $html		.= 'alert("'.$msg.'");';
			$type			= mbw_get_param("type");
			if($type=="paypal"){
				$html		.= 'self.close();';
			}else{
				$html		.= 'parent.parent.closeOrderStep();';
			}			
		$html		.= '</script>';
		$html		.= '</head><body></body></html>';
		echo $html;
	}
}
$require_files		= mbw_get_require_path("plugins/pay");
if(!empty($require_files)){
	foreach($require_files  as $value){
		require_once($value);
	}
}
if(!function_exists('mbw_commerce_save_order_data')){
	function mbw_commerce_save_order_data(){
		//페이팔 IPN 지원을 위해 결제 데이타 임시 저장
		if(mbw_get_param("board_action")=="save_user_order_data"){			
			if(mbw_get_param('order_data')!=''){
				global $mdb,$mstore,$mb_fields,$mb_board_table_name,$mb_admin_tables;
				$send_data				= array();
				$where_data				= array();
				$fields						= $mb_fields["meta"];
				$user_pid					= intval(mbw_get_user("fn_pid"));
				$order_id					= mbw_get_param("order_id");
				
				if(mbw_is_login() && !empty($user_pid)){
					$meta_pid			= $user_pid;
				}else{
					$meta_pid			= substr($order_id,-9);
				}
				$query		= mbw_get_add_query(array("column"=>"count(*)","table"=>$mb_admin_tables["meta"]),array(array("field"=>"meta_table","value"=>"commerce_paypal_ipn"),array("field"=>"meta_pid","value"=>$meta_pid)));
				$ipn_check	= intval($mdb->get_var($query));

				$send_data[$fields["fn_meta_value"]]		= mbw_get_param('order_data');
				if(!empty($ipn_check)){
					$query_command							= "UPDATE";
					$where_data[$fields["fn_meta_table"]]	= "commerce_paypal_ipn";
					$where_data[$fields["fn_meta_pid"]]		= $meta_pid;
				}else{
					$query_command							= "INSERT";
					$send_data[$fields["fn_meta_table"]]		= "commerce_paypal_ipn";
					$send_data[$fields["fn_meta_pid"]]		= $meta_pid;
					$send_data[$fields["fn_meta_key"]]		= "ipn";
				}
				$mdb->db_query($query_command,$mb_admin_tables["meta"], $send_data, $where_data);
				//log_trace(mbw_get_param('order_data'));
			}	
		}
	}
}
add_action('mbw_template_api_plugin', 'mbw_commerce_save_order_data',5);
?>