<?php
if(!function_exists('mbw_pay_order_result')){	
	function mbw_pay_order_result(){
		$result_data		= array("result_code"=>"01","state"=>"","result_msg"=>"","total_price"=>"","order_id"=>"","tid"=>"","bank_account"=>"","pay_info"=>"","pay_auth_no"=>"","pay_state"=>"");
		$pp_hostname	= trim(mbw_get_option("paypal_hostname"));
		$identity_token	= trim(mbw_get_option("paypal_identity_token"));
		if(empty($identity_token)){
			$result_data["result_msg"]			= "Paypal ID Token 값을 입력해 주세요";
			return $result_data;
		}

		mbw_commerce_session_start();
		if(!empty($_SESSION['paypal_tx'])) $paypal_tx		= $_SESSION['paypal_tx'];
		else if(!empty($_REQUEST['paypal_tx'])) $paypal_tx		= $_REQUEST['paypal_tx'];
		else $paypal_tx		= "";
		$param				= "cmd=_notify-synch&tx=".$paypal_tx."&at=".$identity_token;

		$curl_handle = curl_init();
		curl_setopt($curl_handle, CURLOPT_URL, "https://".$pp_hostname."/cgi-bin/webscr");
		curl_setopt($curl_handle, CURLOPT_FRESH_CONNECT, TRUE);
		curl_setopt($curl_handle, CURLOPT_POST, 1);
		curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER,1);
		curl_setopt($curl_handle, CURLOPT_POSTFIELDS, $param);
		curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, 1);
		curl_setopt($curl_handle, CURLOPT_SSL_VERIFYHOST, 2);
		curl_setopt($curl_handle, CURLOPT_HTTPHEADER, array("Host: ".$pp_hostname,"Cache-Control: must-revalidate,max-age=0, no-store, no-cache","Pragma: no-cache","Expires: 0"));
		$response		= curl_exec($curl_handle);
		curl_close($curl_handle);

		if(!$response){
			$result_data["result_msg"]			= "Paypal 서버 연동 오류가 발생했습니다";
		}else{
			$res_data			= explode("\n", $response);
			$res_array	= array();

			if(strcmp($res_data[0], "SUCCESS") == 0){
				for ($i=1; $i<count($res_data);$i++){
					if(strpos($res_data[$i], '=') !== false){
						list($key,$val) = explode("=", $res_data[$i]);
						$res_array[urldecode($key)] = urldecode($val);
					}
				}
				if($res_array["payment_status"]=="Completed"){
					$result_data["result_code"]			= "00";
					$result_data["pay_state"]			= "complete";
					$result_data["order_id"]				= $res_array["item_number"];
					$result_data["total_price"]			= floatval($res_array["payment_gross"])*mbw_get_option("paypal_exchange_rate");				
					$result_data["tid"]					= $res_array["txn_id"];
				}else{
					$result_data["result_msg"]			= "Paypal 결제오류가 발생했습니다";
				}
			}else if(strcmp($res_data[0], "FAIL") == 0){
				$result_data["result_msg"]			= "Paypal 결제오류가 발생했습니다";
			}
		}

		if($result_data["result_code"] == "00")
			$result_data["state"]				= "success";
		else
			$result_data["state"]				= "error";

		return $result_data;
	}
}


if(!function_exists('mbw_commerce_pay_cancel2')){	
	function mbw_commerce_pay_cancel2($data){

		$result_data			= array("result_code"=>"01","state"=>"","result_msg"=>"","total_price"=>"","order_id"=>"","tid"=>"","bank_account"=>"","pay_info"=>"","pay_auth_no"=>"","pay_state"=>"");

		$api_user_id			= trim(mbw_get_option("paypal_api_user_id"));
		$api_user_pw		= trim(mbw_get_option("paypal_api_user_pw"));
		$api_signature		= trim(mbw_get_option("paypal_api_signature"));

		if(empty($api_user_id)){
			$result_data["result_msg"]			= "Paypal API Username 값을 입력해 주세요";
			return $result_data;
		}else if(empty($api_user_pw)){
			$result_data["result_msg"]			= "Paypal API Password 값을 입력해 주세요";
			return $result_data;
		}else if(empty($api_signature)){
			$result_data["result_msg"]			= "Paypal API Signature 값을 입력해 주세요";
			return $result_data;
		}

		$api_url			= mbw_get_option('paypal_api_url');

		$param = array(
			'USER' => ($api_user_id),
			'PWD' => ($api_user_pw),
			'SIGNATURE' => $api_signature,
			'METHOD' => 'RefundTransaction',
			'VERSION' => 95,
			'TRANSACTIONID' => $data["tid"],
			'REFUNDTYPE' => 'Full',		//Full or Partial			
			'CURRENCYCODE' => 'USD'
		);
		//Partial
		//'AMT' => ($data["amt"]),

		$curl_handle			= curl_init();
		curl_setopt($curl_handle, CURLOPT_URL, $api_url);
		curl_setopt($curl_handle, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
		curl_setopt($curl_handle, CURLOPT_POST, 1);
		curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER,1);
		curl_setopt($curl_handle, CURLOPT_POSTFIELDS, http_build_query($param));
		curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, 1);
		curl_setopt($curl_handle, CURLOPT_SSL_VERIFYHOST, 2);
		curl_setopt($curl_handle, CURLOPT_FORBID_REUSE, 1);
		curl_setopt($curl_handle, CURLOPT_HTTPHEADER, array("Cache-Control: must-revalidate,max-age=0, no-store, no-cache","Pragma: no-cache","Expires: 0"));
		$response		= curl_exec($curl_handle);
		if(!$response){
			curl_close($curl_handle);
			$result_data["result_msg"]			= "A payment error has occured";
		}else{
			parse_str($response, $result);
			if(!empty($result['ACK']) && $result['ACK']=='Success'){
				$result_data["result_code"]			= "00";				
			}else{
				$error_msg		= "결제취소 오류가 발생했습니다";
				if(isset($result['L_LONGMESSAGE0'])){
					$error_msg		= $result['L_LONGMESSAGE0'];
				}
				$result_data["result_msg"]			= $error_msg;
			}
		}
		if($result_data["result_code"] == "00")
			$result_data["state"]				= "success";
		else
			$result_data["state"]				= "error";

		return $result_data;
	}
}

if(!function_exists('mbw_commerce_pay_order_approval')){
	function mbw_commerce_pay_order_approval(){
		mbw_commerce_session_start();
		if(isset($_REQUEST['tx'])) $paypal_tx		= $_REQUEST['tx'];
		else $paypal_tx		= "";
		$_SESSION['paypal_tx']		= $paypal_tx;
		?>
		<!doctype html>
		<html xmlns="http://www.w3.org/1999/xhtml" lang="ko-KR">
		<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<title></title>
		<script type="text/javascript">
			function sendPayInfoSubmit(){
				opener.parent.sendPaypalData(document.PAYPAL_PAYINFO);
			}
		</script>
		</head>
		<body onload="sendPayInfoSubmit()">
		<form method="post" name="PAYPAL_PAYINFO" id="PAYPAL_PAYINFO" action="">
			<input type="hidden" name="paypal_tx" value="<?php echo $paypal_tx;?>"/>
		</form>
		</body>
		</html>
		<?php		
	}
}
if(!function_exists('mbw_commerce_pay_order_ipn')){
	function mbw_commerce_pay_order_ipn(){
	
		//IPN 정보 처리하기
		global $mdb,$mstore,$mb_admin_tables,$mb_fields;
		$order_id					= mbw_get_param("item_number");
		$user_pid					= intval(mbw_get_param("custom"));
		$payment_status			= mbw_get_param("payment_status");
		$paypal_tx				= mbw_get_param("txn_id");

		if(!empty($order_id) && $payment_status=='Completed'){
			sleep(7);
			$paypal_ipn_auth				= md5($paypal_tx."_".$user_pid."_".$order_id);
			if(!empty($user_pid)){
				$meta_pid			= $user_pid;
			}else{
				$meta_pid			= substr($order_id,-9);
			}
			$order_check	= intval($mdb->get_var(mbw_get_add_query(array("column"=>"count(*)","table"=>"mb_commerce_order"),array(array("field"=>"billing_id","value"=>$order_id)))));
			$query			= mbw_get_add_query(array("column"=>"meta_value","table"=>$mb_admin_tables["meta"]), array(array("field"=>"meta_table","value"=>"commerce_paypal_ipn"),array("field"=>"meta_pid","value"=>$meta_pid)));
			$order_str		= $mdb->get_var($query);

			if(empty($order_check) && !empty($order_str)){				
				parse_str($order_str, $order_param);
				$order_data		= $order_str."&mode=commerce&action=mb_commerce&paypal_tx=".$paypal_tx."&user_pid=".$user_pid."&paypal_ipn_auth=".$paypal_ipn_auth;				

				$board_name		= $order_param["board_name"];
				$time					= mbw_get_timestamp();		
				$mstore->set_board_name($board_name);
				$nonce_token		= mbw_generate_access_token();
				$hash					= mbw_get_hash_key("nonce",$time,"",$nonce_token);	
				$table_name			= mbw_get_board_table_name($board_name);
				$order_data			.= "&mb_nonce_value=".$hash."&mb_nonce_time=".$time."&mb_nonce_token=".$nonce_token."&wp_nonce_value=".wp_create_nonce("mbw_api_nonce".$table_name);

				$api_url			= mbw_check_url(admin_url( 'admin-ajax.php' ));
				$curl_handle		= curl_init();
				curl_setopt($curl_handle, CURLOPT_URL, $api_url);
				curl_setopt($curl_handle, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
				curl_setopt($curl_handle, CURLOPT_POST, 1);
				curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER,1);
				curl_setopt($curl_handle, CURLOPT_POSTFIELDS, ($order_data));
				curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, 1);
				curl_setopt($curl_handle, CURLOPT_SSL_VERIFYHOST, 2);
				curl_setopt($curl_handle, CURLOPT_HTTPHEADER, array("Cache-Control: must-revalidate,max-age=0, no-store, no-cache","Pragma: no-cache","Expires: 0"));
				$response		= curl_exec($curl_handle);
				$mdb->query($mdb->prepare("DELETE FROM ".$mb_admin_tables["meta"]." WHERE ".$mb_fields["meta"]["fn_meta_pid"]."=%s AND (".$mb_fields["meta"]["fn_meta_table"]."='commerce_paypal_ipn')",$meta_pid));
				//log_trace($order_data);
			}
		}
	}
}
?>