<?php
/*
Plugin Name: MB-Commerce Cart
Plugin URI: http://www.mangboard.com
Description: 사이드바에 장바구니 목록을 보여줍니다
Version: 1.0
Author: Hometory
Author URI: http://www.hometory.com
*/

/*
== 새로운 위젯 추가하는 방법 ==
1. 현재 파일에 있는 "commerce_cart" 키워드를 수정하고자 하는 이름으로 전부 수정합니다 (위젯 폴더 및 파일이름 포함)  
	예) commerce_cart_hometory_blue (commerce_cart_제작사_스킨특징)

2. 숏코드 사용예
   수정전 : 
   [mb_commerce_cart name="commerce_cart" title="commerce_cart" style="" template="cart-basic-1" img_width="50px" img_height="50px"]
   수정후 : 
   [mb_commerce_cart_hometory_blue name="commerce_cart" title="commerce_cart" style="" template="cart-basic-1" img_width="50px" img_height="50px"]	
*/

//Shortcode 등록
add_shortcode("mb_commerce_cart", 'mbw_create_commerce_cart');

if(!function_exists('mbw_create_commerce_cart')){
	function mbw_create_commerce_cart($args){
		if(!empty($args['echo'])){
			echo mbw_get_commerce_cart_template("shortcode",$args);
		}else{
			return mbw_get_commerce_cart_template("shortcode",$args);
		}
	}
}
if(!function_exists('mbw_commerce_cart_css')){
	function mbw_commerce_cart_css(){
		loadStyle(mbw_get_template_url("commerce/css/widget-cart","theme","css"));
		$template_path				= mbw_get_template_path("commerce/widget/widget-cart","theme");
		if(!empty($template_path)) include_once($template_path);
	}
}

if ( ! class_exists( 'mbw_commerce_cart', false ) ){

	if(!function_exists('register_commerce_cart')){
		function register_commerce_cart() {	
			register_widget( 'mbw_commerce_cart' );
		}
	}
	add_action( 'widgets_init', 'register_commerce_cart' );


	class mbw_commerce_cart extends WP_Widget {

		function __construct() {
			mbw_commerce_cart_css();
			$widget_ops = array('classname' => 'mbw_commerce_cart', 'description' => __('사이드바에 장바구니 목록을 보여줍니다.','mangboard') ); 
			parent::__construct('mbw_commerce_cart', __('MB-Commerce Cart','mangboard'), $widget_ops);
		} 

		function widget($args, $instance) {
			extract($args);			
			echo $before_widget;
			$title				= apply_filters('widget_title', $instance['title'] ); 
			if ( !empty( $title ) ) { echo $before_title . $title . $after_title; };
			echo mbw_get_commerce_cart_template("sidebar",$instance);
			echo $after_widget;
		}

		 
		function form($instance) {
			global $wpdb;
			$defaults				= array( 'title' => "", 'template' => "", 'maxlength' => '30', 'post_id' => "", 'style' => "" ); 
			$template_options	= mbw_get_option("commerce_cart_template"); 
			$template_labels		= mbw_get_option("commerce_cart_template_label"); 
			if(empty($template_labels)) $template_labels		= $template_options;
			$instance	= wp_parse_args( (array) $instance, $defaults );
			$title					= strip_tags($instance['title']);
			$style					= strip_tags($instance['style']);
			$maxlength		= strip_tags($instance['maxlength']);
			if(empty($maxlength)) $maxlength	= "30";

			$shortcode_product		= '[mb_commerce name="commerce_product"';
			$mbw_list = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "posts where post_status='publish' and post_content like '%".$shortcode_product."%' order by ID DESC");
			?>
			 
			<p><label><?php _e('Title','mangboard') ?>: <input class="widefat" name="<?php echo $this->get_field_name('title'); ?>"  type="text" value="<?php echo esc_attr($title); ?>" /></label></p>

			<p><label><?php _e('Template','mangboard') ?>: 
			<select class="widefat" name="<?php echo $this->get_field_name('template'); ?>">
				<?php
				$list_size = count($template_options);
				$option_html			= "";
				for ($i = 0; $i < $list_size; $i++){
					$option_html		= $option_html.'<option value="'.$template_options[$i].'"';
					if ($instance['template'] == $template_options[$i]) $option_html		= $option_html.' selected="selected"'; 
					$option_html		= $option_html.'>'.$template_labels[$i].'</option>';
				}
				echo $option_html;
				?>
			</select></label></p>

			<p><label><?php _e('Target','mangboard') ?>: 
			<select class="widefat" name="<?php echo $this->get_field_name('post_id'); ?>">
				<?php
				$list_size					= count($mbw_list);
				$option_html			= "";
				$title_max_length		= 13;
				
				for ($i = 0; $i < $list_size; $i++) {
					$post_title			= $mbw_list[$i]->post_title;					
					if(mb_strlen($post_title)>$title_max_length){
						$post_title		= mb_substr($post_title, 0, $title_max_length)."...";
					}					
					$option_html		= $option_html.'<option value="'.$mbw_list[$i]->ID.'"';
					if ($instance['post_id'] == $mbw_list[$i]->ID) $option_html		= $option_html.' selected="selected"'; 
					$option_html		= $option_html.'>'.$post_title.'</option>';
				}
				echo $option_html;
				?>
			</select></label></p>		

			<p><label><?php _e('Max Length','mangboard') ?>: <input class="widefat" name="<?php echo $this->get_field_name('maxlength'); ?>"  type="text" value="<?php echo esc_attr($maxlength); ?>" /></label></p>

			<p><label><?php _e('Style','mangboard') ?>(CSS): <input class="widefat" name="<?php echo $this->get_field_name('style'); ?>"  type="text" value="<?php echo esc_attr($style); ?>" /></label></p>	

			
			<?php
		}
	 
		function update($new_instance, $old_instance) {
			$instance = $old_instance;
			$instance['title']			= strip_tags($new_instance['title']);
			$instance['template']	= strip_tags($new_instance['template']);
			$instance['style']			= strip_tags($new_instance['style']);
			$instance['maxlength']	= strip_tags($new_instance['maxlength']);
			$instance['post_id']		= strip_tags($new_instance['post_id']); 
			return $instance;
		}    
	}
}
?>