<?php
/*
Plugin Name: MB-Commerce Search
Plugin URI: http://www.mangboard.com
Description: 사이드바에 상품에 대한 검색 필터를 보여줍니다
Version: 1.0
Author: Hometory
Author URI: http://www.hometory.com
*/

/*
== 새로운 위젯 추가하는 방법 ==
1. 현재 파일에 있는 "commerce_search" 키워드를 수정하고자 하는 이름으로 전부 수정합니다 (위젯 폴더 및 파일이름 포함)  
	예) commerce_search_hometory_blue (commerce_search_제작사_스킨특징)

2. 숏코드 사용예
   수정전 : 
   [mb_commerce_search name="commerce_product" title="commerce_search" style="" template="price-basic-1"]
   수정후 : 
   [mb_commerce_search_hometory_blue name="commerce_product" title="commerce_search" style="" template="price-basic-1"]
   Template : 
   "price-basic-1" (가격 검색 필터)
*/

//Shortcode 등록
add_shortcode("mb_commerce_search", 'mbw_create_commerce_search');

if(!function_exists('mbw_create_commerce_search')){
	function mbw_create_commerce_search($args){
		if(!empty($args['echo'])){
			echo mbw_get_commerce_search_template("shortcode",$args);
		}else{
			return mbw_get_commerce_search_template("shortcode",$args);
		}
	}
}
if(!function_exists('mbw_commerce_search_css')){
	function mbw_commerce_search_css(){
		loadStyle(mbw_get_template_url("commerce/css/widget-search","theme","css"));
		loadScript(MBW_PLUGIN_URL."plugins/widgets/commerce_search/js/common.js");
		$template_path				= mbw_get_template_path("commerce/widget/widget-search","theme");
		if(!empty($template_path)) include_once($template_path);
	}
}



if ( ! class_exists( 'mbw_commerce_search', false ) ){

	if(!function_exists('register_commerce_search')){
		function register_commerce_search() {	
			register_widget( 'mbw_commerce_search' );
		}
	}
	add_action( 'widgets_init', 'register_commerce_search' );


	class mbw_commerce_search extends WP_Widget {

		//4.3.0 버젼부터 __construct() 함수로 사용해야 함
		function __construct() {
			mbw_commerce_search_css();
			$widget_ops = array('classname' => 'mbw_commerce_search', 'description' => __('사이드바에 상품에 대한 검색 필터를 보여줍니다.','mangboard') ); 
			parent::__construct('mbw_commerce_search', __('MB-Commerce Search','mangboard'), $widget_ops);
		} 

		function widget($args, $instance) {
			if(mbw_get_board_name()!="commerce_product") return;
			extract($args);
			echo $before_widget;
			$title				= apply_filters('widget_title', $instance['title'] ); 
			if ( !empty( $title ) ) { echo $before_title . $title . $after_title; };
			echo mbw_get_commerce_search_template("sidebar",$instance);
			echo $after_widget;
		}

		 
		function form($instance) {
			global $wpdb;
			$defaults				= array( 'title' => '', 'template' => '', 'style' => ''); 
			$template_options	= mbw_get_option("commerce_search_template"); 
			$template_labels		= mbw_get_option("commerce_search_template_label"); 
			if(empty($template_labels)) $template_labels		= $template_options;
			$instance	= wp_parse_args( (array) $instance, $defaults );
			$title			= strip_tags($instance['title']);
			$template	= strip_tags($instance['template']);
			$style			= strip_tags($instance['style']);
						
			?>
			 
			<p><label><?php _e('Title','mangboard') ?>: <input class="widefat" name="<?php echo $this->get_field_name('title'); ?>"  type="text" value="<?php echo esc_attr($title); ?>" /></label></p>
			<p><label><?php _e('Template','mangboard') ?>: 
			<select class="widefat" name="<?php echo $this->get_field_name('template'); ?>">
				<?php
				$list_size = count($template_options);
				$option_html			= "";
				for ($i = 0; $i < $list_size; $i++){
					$option_html		= $option_html.'<option value="'.$template_options[$i].'"';
					if ($instance['template'] == $template_options[$i]) $option_html		= $option_html.' selected="selected"'; 
					$option_html		= $option_html.'>'.$template_labels[$i].'</option>';
				}
				echo $option_html;
				?>
			</select></label></p>
			<p><label><?php _e('Style','mangboard') ?>(CSS): <input class="widefat" name="<?php echo $this->get_field_name('style'); ?>"  type="text" value="<?php echo esc_attr($style); ?>" /></label></p>	

			<?php
		}
	 
		function update($new_instance, $old_instance) {
			$instance = $old_instance;
			$instance['title']			= strip_tags($new_instance['title']);
			$instance['list_size']		= strip_tags($new_instance['list_size']);
			$instance['img_type']	= strip_tags($new_instance['img_type']);
			$instance['template']	= strip_tags($new_instance['template']);
			$instance['style']			= strip_tags($new_instance['style']);
			$instance['category1']	= strip_tags($new_instance['category1']);
			return $instance;
		}    
	}
}
?>