<?php
mbw_set_option("commerce_gallery_template", array("gallery-basic-321","gallery-basic-222"));
mbw_set_option("commerce_gallery_product_type", array("","shipping","virtual","file","lecture"));
mbw_set_option("commerce_gallery_product_type_label", array(__MW("W_PRODUCT_TOTAL"),__MW("W_PRODUCT_SHIPPING"),__MW("W_PRODUCT_VIRTUAL"),__MW("W_PRODUCT_FILE"),__MW("W_PRODUCT_LECTURE")));

if(!function_exists('mbw_get_commerce_gallery_template')){
	function mbw_get_commerce_gallery_template($mode,$data){
		global $mdb,$mstore,$mb_admin_tables,$mb_fields;
		$device_type				= mbw_get_vars("device_type");
		$widget_name			= basename(__FILE__,".php");
		$name					= "commerce_product";
		if($mode=="shortcode" && mbw_get_param("mode")=="view") return "";

		$title_max_length		= 50;
		if(!empty($data['maxlength'])) $title_max_length		= $data['maxlength'];

		if(empty($data['list_size'])) $list_size			= "5";
        else $list_size			= mbw_value_filter($data['list_size']);
		if(!empty($data['list_page'])) $list_page	= intval($data['list_page'])-1;
		else $list_page		= 0;
		if($list_page<0) $list_page	= 0;

		if($device_type=="mobile" && !empty($data['mobile_list_size'])) $list_size			= mbw_value_filter($data['mobile_list_size']);
		else if($device_type=="tablet" && !empty($data['tablet_list_size'])) $list_size			= mbw_value_filter($data['tablet_list_size']);

		if(isset($data[$device_type."_desc_maxlength"])){
			$desc_maxlength			= intval($data[$device_type."_desc_maxlength"]);
		}else if(isset($data["desc_maxlength"])){
			$desc_maxlength			= intval($data["desc_maxlength"]);
		}else{
			$desc_maxlength			= 80;
		}
		if(empty($data['title'])) $title			= "";
        else $title			= $data['title'];

		if(empty($data['search_field'])) $search_field			= "";
        else $search_field			= mbw_value_filter($data['search_field']);
		if(!isset($data['search_text'])) $search_text			= "";
        else $search_text			= $data['search_text'];

		if(empty($data['order_by'])) $order_by			= "product_rank1";
        else $order_by			= mbw_value_filter($data['order_by']);
		if(empty($data['order_type'])) $order_type			= "desc";
        else $order_type			= mbw_value_filter($data['order_type']);

		if(empty($data['img_type'])) $img_type			= "full";
        else $img_type			= $data['img_type'];		

		if(empty($data['template'])) $template			= "gallery-basic-421";
        else $template			= $data['template'];

		if(empty($data['responsive_class'])) $responsive_class			= "";
        else $responsive_class			= $data['responsive_class'];

		if($device_type=="mobile"){
			if(isset($data[$device_type.'_height'])) $img_height			= $data[$device_type.'_height'];
			else $img_height				= "260px"; 
		}else if($device_type=="tablet"){
			if(isset($data[$device_type.'_height'])) $img_height			= $data[$device_type.'_height'];
			else $img_height				= "200px"; 
		}else{
			if(isset($data['height'])) $img_height			= $data['height'];
			else $img_height				= "160px"; 
		}
		
		//제목 노출 여부		
		if(!empty($data['use_title'])){
			if($data['use_title']=="false") $use_title			= false;
			else $use_title		= true;
		}else $use_title		= true;

		//내용 노출 여부
		if(!empty($data['use_desc'])){
			if($data['use_desc']=="false") $use_desc			= false;
			else $use_desc		= true;
		}else $use_desc	= false;

		//가격 타입 0=표시안함,1=세일가격,2=가격정보전체
		if(!isset($data['price_type'])) $price_type			= "2";
        else $price_type			= $data['price_type'];

		if(empty($responsive_class)){
			if(!empty($template)){
				$template_array			= explode("-",$template);
				$responsive_class			= "col-".$template_array[count($template_array)-1];
			}else{
				$responsive_class			= "col-421";
			}
		}

		//if(strpos($img_width,'%')===false && strpos($img_width,'px')===false) $img_width	.= "px";
		if(strpos($img_height,'%')===false && strpos($img_height,'px')===false) $img_height	.= "px";

		if(mbw_get_param("category1")!="")  $category1			= mbw_htmlspecialchars(mbw_get_param("category1"));
		else if(!empty($data['category1'])) $category1			= mbw_htmlspecialchars($data['category1']);
        else $category1			= "";
		if(mbw_get_param("category2")!="")  $category2			= mbw_htmlspecialchars(mbw_get_param("category2"));
		else if(!empty($data['category2'])) $category2			= mbw_htmlspecialchars($data['category2']);
        else $category2			= "";
		if(mbw_get_param("category3")!="")  $category3			= mbw_htmlspecialchars(mbw_get_param("category3"));
		else if(!empty($data['category3'])) $category3			= mbw_htmlspecialchars($data['category3']);
        else $category3			= "";

		if(!empty($data['date_after'])){
			$date_after		= mbw_value_filter(trim($data['date_after']),"date1");
			if($data['date_after']!=$date_after){		// -7 days 형태로 입력이 되었을 경우
				$date_after		= date('Y-m-d',strtotime($data['date_after']));
			}
		}else $date_after = "";
		if(!empty($data['date_before'])){
			$date_before		= mbw_value_filter(trim($data['date_before']),"date1");
			if($data['date_before']!=$date_before){	// -7 days 형태로 입력이 되었을 경우
				$date_before		= date('Y-m-d',strtotime($data['date_before']));
			}
		}else $date_before = "";

		if(mbw_get_param("product_type")!="") $product_type	= mbw_get_param("product_type");
		else if(!empty($data['product_type'])) $product_type	= $data['product_type'];
        else $product_type			= "";

		if(empty($data['class'])) $div_class			= "";
        else $div_class			= ' '.esc_attr($data['class']);
		if(empty($data['style'])) $div_style			= "";
        else $div_style			= " style='".str_replace("'",'"',esc_attr($data['style']))."'";

		$head_title_style1		= "";
		if(!empty($data['head_title_font_size'])){
			if(strpos($data['head_title_font_size'],'px')===false) $data['head_title_font_size']	.= "px";
			$head_title_style1	.= 'font-size:'.mbw_value_filter($data['head_title_font_size']).' !important;';
		}
		if(!empty($data['head_title_font_color'])){
			$data['head_title_font_color']		= mbw_value_filter($data['head_title_font_color'],"color");
			if(strpos($data['head_title_font_color'],'#')!==0 && strpos($data['head_title_font_color'],'rgba(')!==0) $data['head_title_font_color']	= "#".$data['head_title_font_color'];
			$head_title_style1	.= 'color:'.$data['head_title_font_color'].' !important;';
		}
		if(!empty($data['head_title_line_height'])){
			$head_title_style1	.= 'line-height:'.mbw_value_filter($data['head_title_line_height'],"number").' !important;';
		}
		if(!empty($data['head_title_font_weight'])){
			$head_title_style1	.= 'font-weight:'.mbw_value_filter($data['head_title_font_weight']).' !important;';
		}
		if(!empty($head_title_style1)){
			$head_title_style1	= " style='".str_replace("'",'"',esc_attr($head_title_style1))."'";
		}

		$board_field			= $mb_fields["commerce_product"];

		global $post;
		if(!empty($data["post_id"])){
			$commerce_permalink		= get_permalink($data["post_id"]);	
		}else if($mode=="shortcode" && !empty($data["target"])){
			$commerce_permalink		= mbw_check_permalink($data["target"]);
		}else if($mode=="shortcode" && !empty($post->ID) && strpos($post->post_content, "[mb_commerce name=") !== false){
			$commerce_permalink		= get_permalink($post->ID);
		}else if(mbw_get_option("commerce_product_view_url")!=""){
			$commerce_permalink		= mbw_get_option("commerce_product_view_url");			
			if(strpos($commerce_permalink, 'http') !== 0 && mbw_check_permalink($commerce_permalink)!="") $commerce_permalink		= mbw_check_permalink($commerce_permalink);
		}else{
			$commerce_permalink		= mbw_check_permalink(mbw_get_option("post_product_info"));
		}	
		
		if(strpos($commerce_permalink, '?') === false)	$commerce_permalink		= $commerce_permalink."?";
		else 	$commerce_permalink		= $commerce_permalink."&";
		//if(!empty($category1)) $commerce_permalink		= $commerce_permalink."category1=".$category1."&";
		//if(!empty($category2)) $commerce_permalink		= $commerce_permalink."category2=".$category2."&";
		//if(!empty($category3)) $commerce_permalink		= $commerce_permalink."category3=".$category3."&";
		$commerce_permalink		= $commerce_permalink."vid=";
		
		$table_name				= mbw_get_table_name($name);
		$where_query			= ' where is_show=1';
		$where_data				= array();
		if(!empty($date_after)){
			$where_data[]		= $mdb->prepare($board_field["fn_reg_date"].">%s",$date_after);
		}
		if(!empty($date_before)){
			$where_data[]		= $mdb->prepare($board_field["fn_reg_date"]."<%s",$date_before);
		}
		if(!empty($category1)){
			if(strpos($category1, ',') !== false){
				$category1_array		= explode(',',$category1);
				$filter_array1			= array();
				foreach($category1_array as $item){
					$filter_array1[]		= $mdb->prepare($board_field["fn_category1"]."=%s", $item );
				}
				$where_data[]		= " (".implode( ' OR ', $filter_array1).")";
			}else{
				$where_data[]		= $mdb->prepare($board_field["fn_category1"]."=%s",$category1);
			}
		}

		if(!empty($search_field) && $search_text!="") $where_data[] = $mdb->prepare($search_field." like %s","%".$search_text."%");
		if(!empty($where_data)) $where_query				.= " and ".implode(" and ",$where_data);

		if(!empty($product_type) && $product_type!="") $where_query	.= $mdb->prepare(" and product_type=%s",$product_type);
		if(!empty($search_field) && $search_text!="") $where_query	.= $mdb->prepare(" and ".$search_field."=%s",$search_text);
		$where_query2			= $where_query;		

		//카테고리 검색 쿼리 생성
		if(!empty($category1) && !empty($category2)){
			if(strpos($category2, ',') !== false){
				$category2_array		= explode(',',$category2);
				$filter_array2			= array();
				foreach($category2_array as $item){
					$filter_array2[]		= $mdb->prepare($board_field["fn_category2"]."=%s", $item);
				}
				$where_query2	.= " and (".implode( ' OR ', $filter_array2).")";
			}else{
				$where_query2	.= " and ".$mdb->prepare($board_field["fn_category2"]."=%s",$category2);
			}
			if(!empty($category3)){
				if(strpos($category3, ',') !== false){
					$category3_array		= explode(',',$category3);
					$filter_array3			= array();
					foreach($category3_array as $item){
						$filter_array3[]		= $mdb->prepare($board_field["fn_category3"]."=%s", $item);
					}
					$where_query2	.= " and (".implode( ' OR ', $filter_array3).")";
				}else{
					$where_query2	.= " and ".$mdb->prepare($board_field["fn_category3"]."=%s",$category3);
				}
			}
		}

		//가격 검색 쿼리 생성
		if(mbw_get_param("start_price")!=""){
			$where_query2	.= $mdb->prepare(" and ".$board_field["fn_sale_price"].">=%d",mbw_get_param("start_price"));
			if(mbw_get_param("end_price")!=""){
				$where_query2	.= $mdb->prepare(" and ".$board_field["fn_sale_price"]."<=%d",mbw_get_param("end_price"));
			}
		}
		//검색조건에 맞는 상품이 설정한 개수보다 많으면 검색조건에 맞게 보여주고, 작으면 기본 조건으로 검색
		$item_count	= intval($mdb->get_var("SELECT count(*) FROM ".$table_name.$where_query2));
		if($item_count>0){
			$where_query		= $where_query2;
		}
		$where_query			.= ' and '.$board_field["fn_image_path"].'!=""';
		$commerce_list		= $mdb->get_results("SELECT * FROM ".$table_name.$where_query." order by ".mbw_value_filter($order_by,"name")." ".mbw_value_filter($order_type,"name").", pid desc limit ".mbw_value_filter($list_page,"int").",".mbw_value_filter($list_size,"int"), ARRAY_A);								   

		$widget_html	= '<div class="clear"></div>';
		$widget_html	.= '<div class="mb-widget mb-'.$device_type.'">';
		$widget_html	.= '<div'.$div_style.' class="mb-board mc-widget-gallery mc-widget-gallery1 gallery-list mb-widget-'.$mode.$div_class.'">';
		if($mode!="sidebar" && !empty($title)){
			$widget_html	.= '<div class="mc-widget-title"'.$head_title_style1.'>'.$title.'</div>';	
		}

		$widget_html		= $widget_html.'<div class="mc-widget-box">';

		$icon_width		= "48px";
		$icon_height		= "48px";
		$style					= 'width:'.$icon_width.';height:'.$icon_height.';';
	
		if(!empty($commerce_list)){
			foreach($commerce_list as $commerce_item){
				$post_title		= mbw_htmlspecialchars_decode($commerce_item[$board_field["fn_title"]]);
				if(mb_strlen($post_title)>$title_max_length){
					$post_title		= mb_substr($post_title, 0, $title_max_length)."...";
				}
				$img_url		= mbw_get_image_url("url_small",$commerce_item[$board_field["fn_image_path"]]);

				$widget_html	.= '<div class="mc-gallery-item-box '.$responsive_class.'">';

				if($commerce_item[$board_field["fn_product_icon1"]]!="")
					$widget_html	.= '<div style="position:absolute;z-index:90;top:-6px;left:-5px;'.$style.'"><img src="'.MBW_PLUGIN_URL.'plugins/commerce/icons/'.$commerce_item[$board_field["fn_product_icon1"]].'" width="'.$icon_width.'" height="'.$icon_height.'"></div>';
				if($commerce_item[$board_field["fn_product_icon2"]]!="")
					$widget_html	.= '<div style="position:absolute;z-index:90;top:-6px;left:45px;'.$style.'"><img src="'.MBW_PLUGIN_URL.'plugins/commerce/icons/'.$commerce_item[$board_field["fn_product_icon2"]].'" width="'.$icon_width.'" height="'.$icon_height.'"></div>';

				$widget_html	.= '<div class="mc-gallery-item-wrap"><a href="'.$commerce_permalink.$commerce_item[$board_field["fn_pid"]].'">';
					
					if($img_type=="ratio"){
						$widget_html	.= '<div class="mc-gallery-item-img img-ratio"><img class="img" style="max-width:100%;height:'.$img_height.';" src="'.$img_url.'" alt="'.esc_attr($commerce_item[$board_field["fn_title"]]).'" title="'.esc_attr($commerce_item[$board_field["fn_title"]]).'"></div>';
					}else{
						$widget_html	.= '<div class="mc-gallery-item-img img-full"><div style="height:'.$img_height.';background-image:url('.$img_url.');background-position:center center;background-size:cover;background-repeat: no-repeat;"></div></div>';
					}					
					$widget_html	.= '<div class="mc-gallery-item-text-box">';
						if( $use_title ){
							$item_title		= '<div class="mc-gallery-item-title">'.mbw_htmlspecialchars($post_title).'</div>';
							if(has_filter('mf_widget_item_title')) $item_title			= apply_filters("mf_widget_item_title", $item_title, $data, $latest_item, $widget_name);
							$widget_html	.= $item_title;
						}						
						if( $use_desc ){							
							$post_content			= $commerce_item[$board_field["fn_product_description"]];
							if(mbw_get_board_item("fn_data_type")=="html") $post_content			= mbw_htmlspecialchars_decode($post_content);
							$post_content			= strip_tags(mbw_htmlspecialchars_decode($post_content));
							$post_content			= trim(str_replace(array("&nbsp;","　"," ","  "), " ", $post_content));
							
							if(function_exists('mb_strlen')) $content_length	= mb_strlen($post_content, mbw_get_option("encoding"));
							else $content_length	= strlen($post_content);

							if($desc_maxlength<$content_length){
								if(!isset($data["maxtext"])){
									$data["maxtext"]		= "...";
								}
								if(function_exists('mb_substr')) $post_content		= mb_substr($post_content, 0, $desc_maxlength, mbw_get_option("encoding")).$data["maxtext"];
								else $post_content		= substr($post_content, 0, $maxlength).$data["maxtext"];
							}
							$widget_html	.= '<div class="mc-gallery-item-content" style="">'.mbw_htmlspecialchars($post_content).'</div>';
						}
						
						$widget_html	.= '<div class="mc-gallery-item-price">';
						
						if( $price_type != "0" ){
							$price_html		= "";
							if( $price_type == "2" ){
								if(floatval($commerce_item[$board_field["fn_regular_price"]])>floatval($commerce_item[$board_field["fn_sale_price"]])){
									$price_html	.= '<span class="mc-gallery-item-regular-price">'.mbw_set_format($commerce_item[$board_field["fn_regular_price"]]).'</span>';
								}
							}

							$sale_price		= floatval(apply_filters("mf_product_sale_price",$commerce_item[$board_field["fn_sale_price"]],$commerce_item[$board_field["fn_pid"]],$commerce_item[$board_field["fn_category1"]]));
							if($sale_price==0) $sale_price_text		= __MW("W_FREE");
							else $sale_price_text	= mbw_set_format($sale_price);

							$sale_status			= intval($commerce_item[$board_field["fn_sale_status"]]);
							$product_type		= $commerce_item[$board_field['fn_product_type']];

							if($product_type=="lecture"){
								if($commerce_item[$board_field['fn_lecture_deadline']]!="" && $commerce_item[$board_field['fn_lecture_deadline']]<mbw_get_current_date()) $sale_status		= 2;
								else if(intval($commerce_item[$board_field['fn_sale_count']])>=intval($commerce_item[$board_field['fn_stock']])) $sale_status		= 2;
							}else {
								if(intval($commerce_item[$board_field['fn_stock']])==0) $sale_status		= 2;
							}
							if(($sale_status!=1 && $sale_status!=6) || ($sale_status==6 && !mbw_is_login())){
								$price_html			= "";
								$sale_price_text		= mbw_get_product_status_text($product_type,$sale_status);
							}

							$price_html	.= '<span class="mc-gallery-item-sale-price"> '.$sale_price_text.'</span>';
							$widget_html	.= $price_html;
						}

						$widget_html	.= "</div>";
					
					$widget_html	.= '</div>';

				$widget_html	.= "</a></div></div>";
				if(mbw_get_trace("mbw_get_resize_responsive")==""){
					$widget_html	.= '<script type="text/javascript">'.mbw_get_resize_responsive($device_type).'</script>';
				}
			}
		}else{		
		}

		$widget_html	.= '<div class="clear"></div></div></div></div>';
		if(has_filter('mf_widget_html')) $widget_html		= apply_filters("mf_widget_html", $widget_html, $data, $widget_name);
		return $widget_html;
	}
}
?>